<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if file is included...
if (intval($_uid) == 0)
{
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "list");
    $display = campus::get_POST_GET("display", "defects");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $device_id = intval(campus::get_POST_GET("device_id"));
    $date = strtotime(campus::get_POST_GET("date"));
    $teacher = campus::get_POST_GET("teacher");
    $category_id = intval(campus::get_POST_GET("category_id"));
    $comment = campus::get_POST_GET("comment");
    $devicestate = campus::get_POST_GET("devicestate");
    $defect_id = intval(campus::get_POST_GET("defect_id"));
    $search = campus::get_POST_GET("search");
    $filterteacher = campus::get_POST_GET("filterteacher");
    $filteritid = intval(campus::get_POST_GET("filteritid"));
    $filterresourceid = intval(campus::get_POST_GET("filterresourceid"));

    /*
      ==============================================================================
      Dokeos data
      ==============================================================================
     */
    //Lijst van leerkrachten
    $teachers = campus::get_teachers($department_id);
    $userinfo = campus::get_user_info($_uid);


    /*     * ******************************************************************************
     *
     * 	Computer errorlog
     *
     * ******************************************************************************* */
    // Gegevens selectie instellen, deze is afhankelijk van de opdracht
    if ($submitmessage == "")
    { //
        switch ($action)
        {
            case "edit" :
                { //een formulier van de individuele te wijzigen record tonen...
                    $result = mysql_query("SELECT `id`, `date`, `device_id`, `user`, `category_id`, `comment` FROM `campus_it_defect` WHERE `id`='" . $defect_id . "' ");
                    list($defect_id, $date, $device_id, $teacher, $category_id, $comment) = mysql_fetch_row($result);
                    if ($device_id != "")
                    { // get identification (code) and state from device...
                        $result = mysql_query("SELECT `code`,`state` FROM `campus_it_device` WHERE `device_id`='" . $device_id . "' AND `department_id`=" . $department_id . " LIMIT 1");
                        list($code, $devicestate) = mysql_fetch_row($result);
                    }
                }
                break;
            case "delete" :
                {
                    $result = mysql_query("DELETE FROM `campus_it_defect` WHERE `id`=" . $defect_id . "");
                    if ($result)
                    {
                        $message = get_lang("msgItemDeleted");
                        $action = "list";
                    }
                    unset($_POST);
                }
                break;
            case "repair" :
                {  //een leeg formulier van de nieuwe, individuele record tonen...
                    if ($defect_id != 0)
                    {
                        $result = mysql_query("SELECT `id`, `date`, `device_id`, `user`, `category_id`, `comment` FROM `campus_it_defect` WHERE `id`='" . $defect_id . "' ");
                        list($defect_id, $date, $device_id, $teacher, $category_id, $comment) = mysql_fetch_row($result);
                        if ($device_id != "")
                        { // get identification (code) and state from device...
                            $result = mysql_query("SELECT `code`,`state` FROM `campus_it_device` WHERE `device_id`='" . $device_id . "' AND `department_id`=" . $department_id . " LIMIT 1");
                            list($code, $devicestate) = mysql_fetch_row($result);
                        }
                    }
                    $defect_id = 0;
                    $date = time();
                    $teacher = $userinfo['official_code'];
                    $category_id = 2;
                    $devicestate = 0;
                }
                break;
            case "deletefilter" :
                {  //een leeg formulier van de nieuwe, individuele record tonen...
                    if (($filterteacher != 0) || ($filteritid != 0) || ($filterresourceid != 0))
                    {
                        $query = 'DELETE `campus_it_defect` FROM `campus_it_defect` LEFT JOIN `campus_it_device` ON `campus_it_defect`.`device_id`=`campus_it_device`.`id` ';
                        $query.='WHERE `campus_it_defect`.`department_id`=' . $department_id . ' ';
                        $query.= ( $filterteacher != '') ? (' AND `user` = "' . $filterteacher . '" ') : '';
                        //$query.='AND  ';
                        if ($filteritid == '-1')
                        {
                            $query.='AND `campus_it_device`.`code` is null ';
                        }
                        else
                        {
                            $query.= ( $filteritid > 0) ? (' AND `campus_it_device`.`id` = ' . $filteritid . ' ') : '';
                        }
                        $query.= ( $filterresourceid != 0) ? (' AND `resource_id` = ' . $filterresourceid . ' ') : '';
                        $result = mysql_query($query) or die(mysql_error());
                        echo mysql_num_rows($result);
                        if ($result)
                        {
                            $message = get_lang("msgItemDeleted");
                        }
                    }
                    else
                    {
                        $message = get_lang("msgNothingDeleted");
                    }
                    unset($_POST);
                    $action = "list";
                }
                break;

            default :
                {
                    $action = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "edit" :
                {
                    $query = "UPDATE `campus_it_defect` SET ";
                    $query .="`date`=" . $date . ", ";
                    $query .="`device_id`='" . $device_id . "', ";
                    $query .="`user`='" . $teacher . "', ";
                    $query .="`category_id`=" . $category_id . ", ";
                    $query .="`comment`='" . $comment . "' ";
                    $query .="WHERE `id`=" . $defect_id . "";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $action = "edit";
                    }
                    else
                    {
                        // update state of device...
                        $result = mysql_query("UPDATE `campus_it_device` SET `state`=" . $devicestate . " WHERE `id`=" . $device_id . " ");
                        $message = get_lang("msgItemEditSucces");
                        $action = "list";
                        unset($_POST);
                    }
                }
                break;
            case "repair" :
                {
                    $query = "INSERT INTO `campus_it_defect` SET ";
                    $query .="`date`='" . $date . "', ";
                    $query .="`device_id`='" . $device_id . "', ";
                    $query .="`user`='" . $teacher . "', ";
                    $query .="`category_id`=" . $category_id . ", ";
                    $query .="`comment`='" . $comment . "', ";
                    $query .="`department_id`='" . $department_id . "' ";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $action = "repair";
                    }
                    else
                    {
                        // update state of device...
                        $result = mysql_query("UPDATE `campus_it_device` SET `state`=" . $devicestate . " WHERE `id`=" . $device_id . " ");
                        $message = get_lang("msgItemEditSucces");
                        $action = "list";
                    }
                }
                break;
            default :
                {
                    $action = "list";
                }
                break;
        }
    }
    if ($device_id != 0)
    { // get identification (code) from device...
        $query = 'SELECT `code` FROM `campus_it_device` WHERE `id`=' . $device_id;
        $result = mysql_query($query);
        list($code) = mysql_fetch_row($result);
    }

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    if ($action != "list")
    {
        //--------------------------------- formulier NIEUW, WIJZIGEN, WISSEN -------------------
        echo '
			<script LANGUAGE="JavaScript" xml:space="preserve">
			<!-- 
			function updateLeftChars()
			{
				max_len = 255
				msg_text = document.myform.comment.value
				msg_len = msg_text.length
				if (msg_len > max_len)
				{
					document.myform.comment.value = msg_text.substring(0, max_len)
					document.myform.counter.value = 0
				}
				else
					document.myform.counter.value = (max_len - msg_len)
			}
			-->
			</script>
			<form method="post" action="' . $this->get_url() . '" name="myform">
			<input type="hidden" name="page" value="ITerrorlog" >
			<input type="hidden" name="action" value="' . $action . '" >
			<input type="hidden" name="defect_id" value="' . $defect_id . '">
			<table>
			<tr valign="top">
				<td colspan="2">
					<b>' . get_lang('labelDefectReporting') . '</b><br><br>
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang('labelDate') . '
				</td>
				<td>
					<input type="text" name="date" size="16"  value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d %H:%M:%S', $date) . '"  /> (' . strftime('%Y-%m-%d %H:%M:%S') . ')
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
						' . get_lang('labelDeviceID') . ':
			</td>
				<td>
					<input type="hidden" name="device_id"  VALUE="' . $device_id . '"/>
					<input type="text" name="code" size="8" VALUE="' . $code . '" readonly />
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelTeacher") . '
				</td>
				<td>
					<select name="teacher" />';
        foreach ($teachers as $user_id => $teacherinfo)
        {
            echo "<option value='" . $teacherinfo['official_code'] . "' " . (( $teacherinfo['official_code'] == $teacher) ? "selected" : "") . ">" . $teacherinfo['official_code'] . "</option>";
        }
        echo '		</select>
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang('labelState') . ':
				</td>
				<td>';

        echo '<select name="devicestate" ' . (($form == 'readonly') ? 'style="display:none;
                        "' : '') . '>';
        echo '<option value="0" ' . (($devicestate == 0) ? 'SELECTED' : '') . '>' . get_lang('devicestate_0') . '</option>';
        echo '<option value="1" ' . (($devicestate == 1) ? 'SELECTED' : '') . '>' . get_lang('devicestate_1') . '</option>';
        echo '<option value="2" ' . (($devicestate == 1) ? 'SELECTED' : '') . '>' . get_lang('devicestate_2') . '</option>';
        echo '</select>';
        echo '		</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang('labelDefectCategory') . ':
				</td>
				<td>
					<select name="category_id" />
					<option value="">' . get_lang('txtSelectCategory') . '</option>';
        $result2 = mysql_query("SELECT * FROM `campus_it_defect_category` ORDER BY `id`");
        while (list($id, $categorietxt) = mysql_fetch_row($result2))
        {
            echo '<option value="' . $id . '" ' . (($category_id == $id) ? 'SELECTED' : '') . '>' . $categorietxt . '</option>';
        }
        echo '</select>
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelComment") . '<br><br><br>
					<br><' . get_lang('labelCharsLeft') . '<br>(<input readonly name="counter" size="1" style="border:none">)<br />
				</td>
				<td  colspan="2">
					<textarea name="comment" onBlur="updateLeftChars()" onChange="updateLeftChars()" onFocus="updateLeftChars()" onKeyUp="updateLeftChars()" rows="7" cols="60">' . $comment . '</textarea>
			 	</td>
			</tr>
  			<tr valign="top">
				<td>
				</td>
				<td colspan="2">
					<input type="submit" name="submitmessage" value="OK" />
					<input type="submit" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';"/>
				</td>
			</tr>
		        </table>
			</form>';
    }
    else
    {
        // ---------------------------------- lijst (TONEN) --------------------------------
        echo '<form method="post" action="' . $this->get_url() . '" name="myform">
			<input type="hidden" name="page" value="ITerrorlog" >
			<input type="hidden" name="action" value="" >
			<select name="display" style="width:180px;display: inline;" OnChange="myform.submit();" >
  			<option value="defects" ' . (($display == 'defects') ? 'SELECTED' : '') . '>' . get_lang('txtShowDefects') . '</OPTION>
	   		<option value="all" ' . (($display == 'all') ? 'SELECTED' : '') . '>' . get_lang('txtShowComplete') . '</OPTION>
			</select>';
        if ($display == "all")
        {
            echo get_lang('txtFilterOptions') . '&nbsp;:&nbsp;';
            echo '<select name="filterresourceid" style="width:180px;display: inline;" OnChange="myform.submit();" >';
            echo '<option value="">' . get_lang('txtSelectResource') . '</option>';
            $query = 'SELECT DISTINCT `campus_resource`.`id`,`campus_resource`.`code` FROM `campus_resource`
                        INNER JOIN `campus_it_device` ON `campus_it_device`.`resource_id`= `campus_resource`.`id`
                            WHERE `campus_resource`.`department_id`=' . $department_id . ' ORDER BY `code`';
            $result = mysql_query($query);
            while (list($id, $resourcecode) = mysql_fetch_row($result))
            {
                echo "<option value='" . $id . "' " . (($filterresourceid == $id) ? "selected" : "") . ">" . $resourcecode . "</option>";
            }
            echo "</select>";
            echo "<select name='filteritid' style='width:180px;display: inline;' OnChange='myform.submit();' >";
            echo '<option value="0" ' . (($filteritid == 0) ? 'selected' : '') . '>' . get_lang("txtSelectITID") . '</option>';
            echo '<option value="-1" ' . (($filteritid == -1) ? 'selected' : '') . '>' . get_lang("txtWithoutITID") . '</option>';
            $query = "SELECT DISTINCT `id`, `code` FROM `campus_it_device` ";
            $query.="WHERE `department_id`=" . $department_id . " ORDER BY `code`";
            $result = mysql_query($query);
            while (list($id, $itid) = mysql_fetch_row($result))
            {
                echo '<option value="' . $id . '" ' . (($filteritid == $id) ? "selected" : "") . '>' . $itid . '</option>';
            }
            echo "</select>";
            echo "<select name='filterteacher' style='width:180px;display: inline;' OnChange='myform.submit();' >";
            echo "<option value='' selected>" . get_lang("txtSelectTeacher") . "</option>";
            foreach ($teachers as $user_id => $teacherinfo)
            {
                if ($teacherinfo['official_code'] != '')
                {
                    echo "<option value='" . $teacherinfo['official_code'] . "' " . (($filterteacher == $teacherinfo['official_code']) ? "selected" : "") . ">" . $teacherinfo['official_code'] . "</option>";
                }
            }
            echo "</select>";
            if (($filterteacher != 0) || ($filteritid != "") || ($filterresourceid != 0))
            {
                echo '&nbsp;&nbsp;<a href="#" Onmousedown="javascript:document.myform.action.value=\'deletefilter\';" OnClick="javascript:if(confirm(\'' . get_lang("msgboxConfirmDeleteFiltered") . '\')) myform.submit();" title="' . get_lang("tooltipDeleteFiltered") . '">' . get_lang("txtDeleteFiltered") . '</a>';
            }
        }
        else
        {
            $filterteacher = 0;
            $filteritid = "";
            $filterresourceid = 0;
        }
        echo '</form>';
        // Query van het gegevensbestand....
        $query = 'SELECT t1.`id`, t5.`classroom`, t5.`resource_id`,  t1.`date`, t5.`code`, `user`, `category`, t1.`comment`, t5.`state`
                        FROM `campus_it_defect` t1
                            LEFT JOIN `campus_it_defect_category` t2
                                ON t1.`category_id`=t2.`id`
                            LEFT JOIN (SELECT t4.`code` as `classroom`,t3.`resource_id`, t3.`state`, t3.`code`, t3.`id` FROM `campus_it_device` t3
                                            LEFT JOIN `campus_resource` t4 ON t4.`id`=t3.`resource_id`) as t5 ON t5.`id`=t1.`device_id`
 			WHERE `department_id`=' . $department_id;
        $query.= ( $filterteacher != '') ? (' AND `user` = "' . $filterteacher . '" ') : '';
        if ($filteritid == '-1')
        {
            $query.=' AND t5.`code` is null ';
        }
        else
        {
            $query.= ( $filteritid > 0) ? (' AND t5.`id` = ' . $filteritid . ' ') : '';
        }
        $query.= ( $filterresourceid != 0) ? (' AND `resource_id` = ' . $filterresourceid ) : '';
        if ($display != "all")
        {
            $query.=' AND t5.`state`>0 ';
        }
        $query.=' ORDER BY `classroom` ASC, `code` ASC, `date` DESC';
        // extra filter en sorteer instellingen blijven gedurende de hele sessie bewaard voor elke lijst...
        $result = mysql_query($query);
        campus::display_complex_table_header($properties, array(get_lang("colheadId"), get_lang("colheadClassRoom"), get_lang("colheadDate"), get_lang("colheadITDevice"), get_lang("colheadTeacher"), get_lang("colheadITDefect"), get_lang("colheadComment"), ""));
        $data = array();
        $previous = "";
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if (($previous <> $rij['code']) || ($display == 'all'))
            {
                $data[0] = $rij['id'];
                $data[1] = "<a href='" . $this->get_url() . "&resource_id=" . $rij['resource_id'] . "' title='" . get_lang("tooltipShow") . " " . $rij['classroom'] . "'>" . $rij['classroom'] . "</a>";
                $data[2] = DatetimeUtilities::format_locale_date('%Y-%m-%d %H:%M:%S', $rij['date']);
                $data[3] = $rij['code'];
                $data[4] = $rij['user'];
                $data[5] = $rij['category'];
                $data[6] = $rij['comment'];
                $data[7] = '<pre><a href="' . $this->get_url() . '&page=ITerrorlog&defect_id=' . $rij['id'] . '&action=edit"  title="' . get_lang("tooltipEditDefect") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>';
                if ($display == "all")
                {
                    $data[7].='<a href="' . $this->get_url() . '&page=ITerrorlog&defect_id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteDefect") . '\')) return false;" title="' . get_lang("tooltipDeleteDefect") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a>';
                }
                $data[7].='<a href="' . $this->get_url() . '&page=ITerrorlog&defect_id=' . $rij['id'] . '&action=repair" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmITRepair") . '\')) return false;"  title="' . get_lang("tooltipITRepair") . '"><img src="' . Theme::get_image_path('application\campus') . 'reference.gif" border=0 align="absmiddle"></a></pre>';
                campus::display_table_row($bgcolor, $data, true);
            }
            $previous = $rij['code'];
        }
        campus::display_table_footer();
    }
}
?>