<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if file is included...
if (intval($_uid) == 0)
{
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "list");
    $device_id = intval(campus::get_POST_GET("device_id"));
    $resource_id = intval(campus::get_POST_GET("resource_id"));
    $date = campus::get_POST_GET("date");
    $category_id = intval(campus::get_POST_GET("category_id"));
    $comment = campus::get_POST_GET("comment");
    $devicestate = intval(campus::get_POST_GET("devicestate"));

    $userinfo = campus::get_user_info($_uid);


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if ($resource_id == 0)
    {
        $message = get_lang('msgSelectResource');
    }
    else
    {
        if ($action == "list")
        {
            $message = get_lang('msgSelectDevice');
        }
        elseif ($action == "error")
        {
            $message = get_lang('msgSelectState');
        }
    }


    /* *******************************************************************************
     *
     * 	Computer status
     *
     * ******************************************************************************* */
    if ($device_id != 0)
    { // get identification (code) from device...
        $query = 'SELECT `code` FROM `campus_it_device` WHERE `id`=' . $device_id ;
        $result = mysql_query($query);
        list($code) = mysql_fetch_row($result);
    }


    if ($action == "insert")
    {
        if (trim($comment) != "")
        {
            if ($category_id != 0)
            {
                // update state of device...
                $result = mysql_query("UPDATE `campus_it_device` SET `state`=" . $devicestate . " WHERE `id`=" . $device_id . " ");
                // write defect report in error log
                $query = "INSERT INTO `campus_it_defect` SET ";
                $query .="`date`=" . $date . ", ";
                $query .="`device_id`=" . $device_id . ", ";
                $query .="`user`='" . $userinfo['official_code'] . "', ";
                $query .="`category_id`=" . $category_id . ", ";
                $query .="`comment`='" . $comment . "', ";
                $query .="`department_id`=" . $department_id . " ";

                $result = mysql_query($query);
                // select it_support administrators ....
                $query = 'SELECT `user_id` FROM `campus_rights` WHERE `department_id`=' . $department_id . ' AND `item`=4';
                $result = mysql_query($query);
                $user2warn = array();
                while (list($user_id) = mysql_fetch_row($result))
                {
                    $user2warn = array_merge($user2warn, array("u" . $user_id));
                }
                if (!empty($user2warn))
                {
                    // write message to IT admin....
                    $query = 'INSERT
					`campus_messageboard` SET
					`title`= "' . $code . ' DEFECT !",
					`date`=' . time() . ',
					`user_id`=' . $_uid . ',
					`content`="' . addslashes(get_lang('txtToLink') . ' <a href="' . $this->get_url() . '&page=ITerrorlog&department_id=' . $department_id . '">' . get_lang('page_ITerrorlog') . '</a><br>' . get_lang('txtDiscription') . ' :<br>' . $comment) . '"
					';
                    $result = mysql_query($query);
                    if ($result)
                    {
                        $message_id = mysql_insert_id();
                        campus::set_message_to($user2warn, $message_id);
                    }
                }
                $action = "list";
            }
            else
            {
                Display::error_message(get_lang('msgNoDefectCategorySelected'), false);
                $action = "error";
            }
        }
        else
        {
            Display::error_message(get_lang('msgNoDefectCommentGiven'), false);
            $action = "error";
        }
    }

    if ($message != "")
    {
        Display::normal_message($message, false);
    }


    switch ($action)
    {
        // show classroom
        case "error" :
            {
                if ($device_id != 0)
                {
                    echo '
				<SCRIPT LANGUAGE="JavaScript" xml:space="preserve">
				<!-- 
				function updateLeftChars()
				{
					max_len = 255
					msg_text = document.myform.comment.value
					msg_len = msg_text.length
					if (msg_len > max_len)
					{	
						document.myform.comment.value = msg_text.substring(0, max_len)
						document.myform.counter.value = 0
					}
					else
						document.myform.counter.value = (max_len - msg_len)
				}
				-->
				</script>
				<form method="post" action="' . $this->get_url() . '" name="myform">
			    	<input type="hidden" name="page" value="ITstate" >
				<input type="hidden" name="action" value="insert" >
				<input type="hidden" name="resource_id" value="' . $resource_id . '" >
				<table>
				<tr valign="top">
				<td colspan="2">
					<b>' . get_lang('labelDefectReporting') . '</b><br><br>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
					' . get_lang('labelDate') . ':
				</td>
				<td>
					<input type="hidden" name="date" size="16"  value="' . time() . '" />
					<input type="text" name="date_view" size="16"  value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d',time()) . '" readonly />
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
					' . get_lang('labelDeviceID') . ':
				</td>
				<td>
					<input type="hidden" name="device_id"  VALUE="' . $device_id . '"/>
					<input type="text" name="code" size="8" VALUE="' . $code . '" readonly />
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
					' . get_lang('labelState') . ':
				</td>
				<td>';
                    echo '<select name="devicestate">';

                    echo '<option value="0" >' . get_lang('devicestate_0') . '</option>';
                    echo '<option value="1" SELECTED>' . get_lang('devicestate_1') . '</option>';
                    echo '<option value="2" >' . get_lang('devicestate_2') . '</option>';
                    
                    echo '</select>';
                    echo '</select>
                                    </td>
				</tr>
				<tr valign="top">
				<td align="right">
					' . get_lang('labelDefectCategory') . ':
				</td>
				<td>
					<select name="category_id" />
					<option value="">' . get_lang('txtSelectCategory') . '</option>';
                    $result2 = mysql_query("SELECT * FROM `campus_it_defect_category` ORDER BY `id`");
                    while ($rij2 = mysql_fetch_array($result2))
                    {
                        echo '<option value="' . $rij2['id'] . '" ' . (($rij2['id'] == $category_id) ? 'SELECTED' : '') . '>' . $rij2['category'] . '</option>';
                    }
                    echo '</select>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
					' . get_lang('labelComment') . ':<br><br><br>
					<br>' . get_lang('labelCharsLeft') . '<br>(<input readonly name="counter" size="1" style="border:none">)<br />
				</td>
				<td  colspan="2">
					<textarea name="comment" onBlur="updateLeftChars()" onChange="updateLeftChars()" onFocus="updateLeftChars()" onKeyUp="updateLeftChars()" rows="7" cols="60">' . $comment . '</textarea>
			 	</td>
				</tr>
  				<tr valign="top">
				<td>
				</td>
				<td colspan="2">
					<input type="submit" name="submitmessage" value="OK" />
					<input type="submit" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';"/>
				</td>
				</tr>
			        </table>
				</form>';
                }
                else
                {
                    Display::error_message(get_lang('msgNoDeviceSelected'), false);
                }
            }
            break;
        case "list" :
        default:
            {
                $classroomlinks = "";
                $query ="SELECT DISTINCT `campus_resource`.`id`, `campus_resource`.`code`, `campus_resource`.`comment` ";
                $query.="FROM `campus_resource` ";
                $query.="INNER JOIN `campus_it_device` ON `campus_resource`.`id`=`resource_id` ";
                $query.="WHERE `campus_resource`.`department_id`=" . $department_id . " ORDER BY `campus_resource`.`code`";
                $result = mysql_query($query);
                while (list($id, $resourcecode,$comment) = mysql_fetch_row($result))
                {
                    $classroomlinks.='<a href="' . $this->get_url() . '&resource_id=' . $id . '" title="' . $comment . '">' . $resourcecode . '</a> ';
                    if ($resource_id == $id)
                    {
                        $resource = $resourcecode;
                    }
                }
                $opmerking = '';
                $categorie = "3";
                echo '<span  style=" float:right;width:80%; padding-top: 10px;">' . $classroomlinks . '</span>';
                echo '<div>';
                echo '<b style="font-size: 32px;">' . $resource . '</b>';
                echo '</div>';
                echo '<br clear="all">';
                echo '<span style="float:right; position: relative; left: 0px;top:0px;z-index: 1">';
                if (($department_id != 0) && ((isset($admin['IT']) && $admin['IT']) || $is_platformadmin))
                {
                    echo '<a href="' . $this->get_url() . '&page=ITdevicelist&filterresourceid=' . $resource_id . '">' . get_lang("page_manageITdevices") . '</a>&nbsp;|';
                    echo '&nbsp;<a href="' . $this->get_url() . '&page=ITerrorlog">' . get_lang("page_ITerrorlog") . '</a>';
                }
                echo '</span>';
                echo '<br clear="all">';

                echo '<div>';
                if ($resource_id != 0)
                {
                    // insert computers from selected room in classroom layout
                    $query ='SELECT t1.`id`, t1.`code`, `position`, `state`, t2.`info` as `devicetype`, `defects`.`category`, t1.`comment`
                                FROM `campus_it_device` t1
                                    INNER JOIN `campus_it_device_info` t2
                                        ON t2.`id` = t1.`type`
                                    INNER JOIN `campus_resource`
                                        ON t1.`resource_id` = `campus_resource`.`id`
                                    LEFT JOIN (SELECT `category`, `comment`, `device_id`, `date` FROM `campus_it_defect`
                                                    INNER JOIN `campus_it_defect_category`
                                                        ON `campus_it_defect`.`category_id`=`campus_it_defect_category`.`id` ) as `defects`
                                        ON t1.`id` = `defects`.`device_id`
                                    WHERE t1.`resource_id`=' . $resource_id . ' ORDER BY t1.`position`, `defects`.`date`';
                    $result = mysql_query($query) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $item[$rij['position']] = $rij;
                    }
                    echo "<table align=center>";
                    echo "<tr><td colspan='10' align='center'>[===============&nbsp;" . get_lang("txtFrontRoom") . "&nbsp;===============]</td></tr>";
                    for ($i = 1; $i < 10; $i++)
                    {
                        echo "<tr>";
                        for ($j = 'A'; $j <= 'F'; $j++)
                        {
                            if ($item[$j . $i]['code'] != "")
                            {
                                if ($item[$j . $i]['state'] == 'IO')
                                {
                                    $tooltip = $item[$j . $i]['comment'];
                                }
                                else
                                {
                                    $tooltip = $item[$j . $i]['category'];
                                }
                                echo '<td><div style="width:120px;heigth:100px;"><a style="font-size:10px" href="' . $this->get_url() . '&action=error&resource_id=' . $resource_id . '&device_id=' . $item[$j . $i]['id'] . '" TITLE="' . $tooltip . '">
										<img src="' . Theme::get_image_path('application\campus') . $item[$j . $i]['devicetype'] . '_' . $item[$j . $i]['state'] . '.png">
										<br>' . $item[$j . $i]['code'] . '</a></div></td>';
                            }
                            else
                            {
                                echo '<td><div style="width:120px;heigth:100px;">&nbsp;</div></td> ';
                            }
                        }
                        echo '</tr>';
                    }
                    echo '</table>';
                }
                else
                {
                    // insert computers from selected room in classroom layout
                    $query = 'SELECT COUNT(IF((`state` > 0),1,NULL)) as defects, COUNT(IF((`type` = 1),1,NULL)) as type_1, COUNT(IF((`type` = 2),1,NULL)) as type_2,COUNT(IF((`type` = 4),1,NULL)) as type_4,COUNT(IF((`type` = 5),1,NULL)) as type_5, COUNT(IF((`network` = "Network enabled"),1,NULL)) as internet
                                    FROM `campus_it_device` t1
                                        LEFT JOIN (SELECT t3.`info` as `network`, t2.device_id FROM `campus_it_device_rel_info` t2
                                                        INNER JOIN `campus_it_device_info` t3 ON t3.`id` = t2.`info_id` AND t3.`category_id`=10)
 								as t4 ON t1.`id`=t4.`device_id`
                                WHERE `department_id`=' . $department_id ;
                    $result = mysql_query($query) or die(mysql_error());
                    list($aantal, $aantalPC_S,$aantalLT_S, $aantalprinters, $aantalbeamers, $aantalI_NET) = mysql_fetch_row($result);
                    echo '<img style="float:left" src="' . Theme::get_image_path('application\campus') . 'practicer.png"><div><br><br><h1 style="color:red">Momenteel zijn er ' . $aantal . ' toestellen in herstelling.</h1><br><h2>Er bevinden zich ' . $aantalPC_S . ' computers,'. $aantalLT_S .' laptops, '.$aantalbeamers.' beamers en ' . $aantalprinters . ' printers in onze school.<br>' . $aantalI_NET . ' van deze toestellen zijn verbonden met het netwerk/internet.<br></h2></div>';
                }
                echo "</div>";
            }
            break;
    }
}
?>