<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\ResourceManager;
use common\libraries\Path;


//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['IT']) && !$is_platformadmin))
{
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $category_id = intval(campus::get_POST_GET("category_id"));
    $info_id = intval(campus::get_POST_GET("info_id"));
    $filter = campus::get_POST_GET("filter", "all");


    /*
     -----------------------------------------------------------
     Specials
     -----------------------------------------------------------
    */
    //echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_itinfostat_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/dialog.css');


    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "new" :
                {
                    $option_id = "";
                    $option = "";
                    $display = "form";
                }
                break;
            case "update" :
                {
                    //
                    $query = "select * FROM `campus_it_device_info` WHERE `id`=" . $info_id . " LIMIT 1";
                    $result = mysql_query($query);
                    while (list($info_id, $info, $category_id) = mysql_fetch_row($result))
                    {
                        break;
                    }
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    //
                    $result = mysql_query("DELETE FROM `campus_it_device_rel_info` WHERE `id`=" . $info_id . " ");
                    $result = mysql_query("DELETE FROM `campus_it_device_info` WHERE `id`=" . $info_id . " ");
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            case "remove" :
                {
                    // remove not used options of a particular type...
                    $result = mysql_query("DELETE `campus_it_device_info` FROM `campus_it_device_info`
						LEFT JOIN `campus_it_device_rel_info` ON `campus_it_device_info`.`id`=`campus_it_device_rel_info`.`info_id`
						WHERE `category_id`=" . $filter . " AND `device_id` is NULL ");
                    $message = get_lang("msgOptionsDeleted");
                    $display = "list";
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_it_device_info` WHERE `category_id`=' . $filter . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $info_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info` SET
								`display_order`=' . $line . ' WHERE `display_order`=' . ($line - 1) . ' AND `category_id`=' . $filter . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_it_device_info` SET
								`display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $display = "list";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_it_device_info` WHERE `category_id`=' . $filter . ' ORDER BY `display_order`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $info_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info` SET `display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info` SET `display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = 'SELECT `display_order` FROM `campus_it_device_info`
		 					WHERE `category_id`= ' . $category_id . ' ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_it_device_info` SET
					`info`="' . campus::get_POST_GET("info") . '",
					`category_id`=' . $category_id . ',
                                        `display_order`=' . ($display_order + 1) . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $info_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            case "update" :
                {
                    $query = "UPDATE `campus_it_device_info` SET
                    `info`='" . campus::get_POST_GET("info") . "',
                    `category_id`=" . $category_id . "
                    WHERE `id`='" . $info_id . "'";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $display = "list";
                    }
                }
                break;
            default :
                {
                    $display = "list";
                }
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message);
    }
    switch ($display)
    {
        case "form" :
            {
// ===============================================================
// diplay Resource form.........
// ===============================================================
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
		    		<input type="hidden" name="page" value="device_info" >
		    		<input type="hidden" name="filter" value="' . $filter . '" >
		    		<input type="hidden" name="info_id" value="' . $info_id . '" >
		    		<input type="hidden" name="action" value="' . $action . '" >
				<table>
				<tr valign="top">
				<td colspan="2">
				</td>
				</tr>
				<tr valign="top">
				<td  align="right">
					' . get_lang('labelItDeviceInfo') . '
				</td>
				<td>
					<input type="text" name="info" size="60" maxlength="255" value="' . $info . '" />
					<br />
				</td>
				</tr>
				<tr valign="top">
				<td  align="right">
					' . get_lang("labelItDeviceInfoCategory") . '
				</td>
				<td>
					<select name="category_id" >';
                $subquery = "SELECT `campus_it_device_info_category`.`id`, `category`, `info` FROM `campus_it_device_info_category`
                                    LEFT JOIN `campus_it_device_info`
                                            ON `campus_it_device_info_category`.`type`= `campus_it_device_info`.`id` AND `campus_it_device_info`.`category_id`=0
                         ORDER BY `system` DESC, `campus_it_device_info_category`.`display_order`";
                $subresult = mysql_query($subquery);
                while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij['id'] . '" ' . (($rij['id'] == $category_id) ? 'SELECTED' : '') . '>' . trim($rij['category']) . (($rij['info'] != '') ? ' (' . $rij['info'] . ')' : '') . '</option>';
                }
                echo "<option value='0' >" . get_lang("Devicetype") . "</option>";
                echo '				</select>
					<br />
				</td>
				</tr>
				<tr valign="top">
				<td>
				</td>
				<td>
					<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</td>
				</tr>
				</table></form>';
            }
            break;
        case "list" :
            {
                echo '<div id="campus_dialog"></div>';
                echo '<form action="' . $this->get_url() . '" METHOD="POST" NAME="myform" STYLE="display: inline;float: right;">
				<input type="hidden" name="action" value="list">
				<input type="hidden" name="page" value="device_info">
	    			<b>' . get_lang('txtFilter') . ':</b>&nbsp;&nbsp;
      				<select name="filter" STYLE="width:250px;" OnChange="javascript:myform.submit();">
		    		<option value="all" ' . (($filter == 'all') ? "SELECTED" : "") . '>' . get_lang('txtComplete') . '</option>';
                $subquery = "SELECT `campus_it_device_info_category`.`id`, `category`, `info` FROM `campus_it_device_info_category`
                                    LEFT JOIN `campus_it_device_info`
                                            ON `campus_it_device_info_category`.`type`= `campus_it_device_info`.`id` AND `campus_it_device_info`.`category_id`=0
                         ORDER BY `system` DESC, `campus_it_device_info_category`.`display_order`";
                $subresult = mysql_query($subquery);
                while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij['id'] . '" ' . (($rij['id'] == $filter) ? 'SELECTED' : '') . '>' . trim($rij['category']) . (($rij['info'] != '') ? ' (' . $rij['info'] . ')' : '') . '</option>';
                }
                echo "<option value='0' " . (($filter == '0') ? 'SELECTED' : '') . ">" . get_lang("Devicetype") . "</option>";
                echo '</select></form>';

                if ($is_platformadmin)
                {
                    echo '<div >';
                    echo '<a href="' . $this->get_url() . '&page=device_info&action=new">' . get_lang("txtAddITTypeOption") . '</a>';
                    if ($filter > 0)
                    {
                        echo '&nbsp;|&nbsp;<a href="' . $this->get_url() . '&page=device_info&action=remove&filter=' . $filter . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmRemoveEmptyOptions") . '\')) return false;">' . get_lang("txtRemoveEmptyOptions") . '</a>';
                    }
                    echo '</div>';
                }
                $query = "SELECT `campus_it_device_info`.`id`,`info`,`category`, CONCAT(COUNT(IF(`department_id`=" . $department_id . ",1,NULL)),' / ',COUNT(`device_id`) ) as `stats`, `department_id` FROM `campus_it_device_info`
						LEFT JOIN `campus_it_device_info_category` ON `campus_it_device_info_category`.`id`= `campus_it_device_info`.`category_id`
						LEFT JOIN (SELECT `campus_it_device_rel_info`.`info_id`, `campus_it_device_rel_info`.`device_id`, `department_id` FROM `campus_it_device_rel_info` INNER JOIN `campus_it_device` ON `campus_it_device_rel_info`.`device_id`=`campus_it_device`.`id`) as t1 ON t1.`info_id`=`campus_it_device_info`.`id` ";
                $query.= ( $filter == "all") ? " GROUP BY `campus_it_device_info`.`id` ORDER BY `campus_it_device_info_category`.`display_order`, `campus_it_device_info`.`display_order`" : " WHERE `campus_it_device_info`.`category_id`=" . intval($filter) . "  GROUP BY `campus_it_device_info`.`id` ORDER BY `campus_it_device_info`.`display_order`";
                $result = mysql_query($query);
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                campus::display_complex_table_header($properties, array(get_lang("colheadITType"), get_lang("colheadITTypeOption"), get_lang("colheadITStats"), ""));
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data[] = trim(preg_replace('/^.*::/', '', $rij['category']));
                    $data[] = '<div class="campus_show_dialog"  device_info_id="' . $rij['id'] . '" dialog_title="' . $rij['info'] . '">
					' . $rij['info'] . '</div>';
                    $data[] = $rij['stats'];
                    if ($filter != 'all')
                    {
                        if ($line == 1)
                        {
                            $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                        }
                        else
                        {
                            $link = '<a href="' . $this->get_url() . '&page=device_info&info_id=' . $rij['id'] . '&filter=' . $filter . '&action=moveup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                        }
                        if ($line == $nbrLines)
                        {
                            $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                        }
                        else
                        {
                            $link.= '<a href="' . $this->get_url() . '&page=device_info&info_id=' . $rij['id'] . '&filter=' . $filter . '&action=movedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                        }
                    }
                    $data[] = ($is_platformadmin) ? ('&nbsp;<a href="' . $this->get_url() . '&page=device_info&filter=' . $filter . '&info_id=' . $rij['id'] . '&action=update" title="' . get_lang("tooltipEditITOption") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                            '&nbsp;<a href="' . $this->get_url() . '&page=device_info&filter=' . $filter . '&info_id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteITOption") . '\')) return false;" title="' . get_lang("tooltipDeleteITOption") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"/></a>' . $link) : '';
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
    }
}
?>