<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\ResourceManager;
use common\libraries\Path;
use common\libraries\DatetimeUtilities;

//check if file is included...
if ((intval($_uid) == 0) || (empty($admin['IT']) && !$is_platformadmin))
{
    Display::normal_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
// initiatisatie van de variabelen die via POST of GET worden mee gezonden
    $action = campus::get_POST_GET('action');
    $submitmessage = campus::get_POST_GET('submitmessage');
    $device_id = intval(campus::get_POST_GET("device_id"));
    $old_device_id = intval(campus::get_POST_GET("old_device_id"));
    $code = campus::get_POST_GET("code");
    $devicetype = intval(campus::get_POST_GET("devicetype", 1));
    $devicestate = intval(campus::get_POST_GET("devicestate", 0));
    $comment = campus::get_POST_GET("comment");
    $resource_id = campus::get_POST_GET("resource_id");
    $info_id = campus::get_POST_GET("info_id");
    $it_infos = campus::get_POST_GET("it_infos");
    $position = campus::get_POST_GET("position");
    $macid = campus::get_POST_GET("macid");
    $purchase_date = strtotime(campus::get_POST_GET("purchase_date"));
    $purchase_info = campus::get_POST_GET("purchase_info");
    $device_rel_device = campus::get_POST_GET("device_rel_device");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $addinfo = campus::get_POST_GET("addinfo");
    $save_new_info = campus::get_POST_GET("save_new_info");

    $add_it_info = intval(campus::get_POST_GET("add_it_info"));
    if ($add_it_info > 0)
    {
        $info_id[$add_it_info] = '';
    }

    $IT_department_id = intval(campus::get_POST_GET("IT_department_id", $department_id));
//
    if ($addinfo != "")
    { // add info button is pressed to a new info...
        $form = 'readonly'; //make other form fields readonly...
    }
    if ($save_new_info != "")
    { // A new info is
        $category_id_new_info = campus::get_POST_GET("category_id_new_info");
        $newinfo = campus::get_POST_GET("newinfo");
        $query = 'INSERT `campus_it_device_info` SET
						`info`="' . $newinfo . '",
						`category_id`=' . $category_id_new_info . ' ';
        $result = mysql_query($query);
        if (!$result)
        {
            $message = get_lang("msgItemAddError");
        }
        else
        {
            $info_id[$category_id_new_info] = mysql_insert_id();
            $message = get_lang("msgItemAddSucces");
        }
    }

    $display = "form";

    if ($submitmessage == "")
    { //
        switch ($action)
        {
            case "edit" :
                { //to edit existing device take the data from the database...
                    $query = "SELECT `code`, `comment`, `resource_id`, `position`, `macid`, `purchase_date`, `purchase_info` , `type`, `state` ";
                    $query.="FROM `campus_it_device` ";
                    $query.=" WHERE `id`=" . $device_id . " LIMIT 1";
                    $result = mysql_query($query);
                    list($code, $comment, $resource_id, $position, $macid, $purchase_date, $purchase_info, $devicetype, $devicestate) = mysql_fetch_row($result);
                    $action = "update"; // when refreshing page by changing type or adding option the data will be taken from the submitted form not from database.
                }
                break;
            case "new" :
                {  //een leeg formulier van de nieuwe, individuele record tonen...
                    $purchase_date = time();
                    $macid = '00:00:00:00:00:00';
                }
                break;

            case "ITlist" :
                {
                    $display = "ITlist";
                }
                break;
        }
    }
    else
    { // the form data has to be written to database
        if ($code != "")
        { //only when these fields are filled in write or change data...
            switch ($action)
            {
                case "update":
                    { // update device data
                        $query = 'UPDATE `campus_it_device` SET
							`code`="' . $code . '",
							`comment`="' . $comment . '",
							`resource_id`=' . intval($resource_id) . ',
							`position`="' . $position . '",
							`macid`="' . $macid . '",
                                                        `purchase_date`=' . $purchase_date . ',
							`purchase_info`="' . $purchase_info . '",
							`type`=' . $devicetype . ',
							`state`=' . $devicestate . ',
							`department_id`=' . $IT_department_id . '
						WHERE `id`=' . $old_device_id . '';
                        $result = mysql_query($query) or die(mysql_error());
                        if ($result)
                        {
                            // first delete any existing relation to the device...
                            $result = mysql_query("DELETE FROM `campus_it_device_rel_info` WHERE `device_id`=" . $old_device_id . " ");
                            // fill in other device fields....
                            foreach ($info_id as $category_id => $value)
                            {
                                if (is_array($value))
                                { // multiple options selected
                                    foreach ($value as $key => $value2)
                                    {
                                        $query = "INSERT `campus_it_device_rel_info` SET
										`device_id`='" . $device_id . "',
										`info_id`=" . $value2 . " ";
                                        $result = mysql_query($query);
                                    }
                                }
                                else
                                {
                                    $query = "INSERT `campus_it_device_rel_info` SET
									`device_id`='" . $device_id . "',
									`info_id`=" . $value . " ";
                                    $result = mysql_query($query);
                                }
                            }
                            foreach ($device_rel_device as $value)
                            {
                                $query = "INSERT `campus_it_device_rel_device` SET
										`device_id`='" . $device_id . "',
										`device2_id`=" . $value . " ";
                                $result = mysql_query($query);
                            }
                            $message = get_lang("msgItemEditSucces");
                            $display = "ITlist";
                        }
                        else
                        {
                            $message = get_lang("msgItemEditError");
                        }
                    }
                    break;
                case "new" :
                    { // add new device
                        $query = 'INSERT `campus_it_device` SET
							`code`="' . $code . '",
							`comment`="' . $comment . '",
							`resource_id`=' . intval($resource_id) . ',
							`position`="' . $position . '",
							`macid`="' . $macid . '",
                                                        `purchase_date`=' . $purchase_date . ',
							`purchase_info`="' . $purchase_info . '",
							`type`=' . $devicetype . ',
							`state`=0,
							`department_id`=' . $department_id . '';
                        $query.= ( ($is_platformadmin) && ($device_id > 0)) ? ', `device_id`="' . $device_id . '" ' : '';
                        $result = mysql_query($query);
                        if ($result)
                        {
                            $device_id = mysql_insert_id();
                            // fill in other device fields....
                            foreach ($info_id as $category_id => $value)
                            {
                                if (is_array($value))
                                { // multiple options selected
                                    foreach ($value as $key => $value2)
                                    {
                                        $query = 'INSERT `campus_it_device_rel_info` SET
										`device_id`="' . $device_id . '",
										`info_id`=' . $value2 . ' ';
                                        $result = mysql_query($query);
                                    }
                                }
                                else
                                {
                                    $query = 'INSERT `campus_it_device_rel_info` SET
									`device_id`="' . $device_id . '",
									`info_id`=' . $value . ' ';
                                    $result = mysql_query($query);
                                }
                            }
                            foreach ($device_rel_device as $value)
                            {
                                $query = 'INSERT `campus_it_device_rel_device` SET
										`device_id`="' . $device_id . '",
										`device2_id`=' . $value . ' ';
                                $result = mysql_query($query);
                            }
                            $message = get_lang("msgItemAddSucces");
                            $display = "showlink";
                        }
                        else
                        {
                            $message = get_lang("msgItemAddError");
                        }
                    }
                    break;
            }
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if ($display == 'form')
    {
        echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');
        echo '<div class="maincontent" id="content">';

        if (!empty($message))
        {
            Display::normal_message($message);
        }
        //--------------------------------- formulier NIEUW, WIJZIGEN, WISSEN -------------------
        //style='background:black; filter:alpha(opacity=25); -moz-opacity:0.25; opacity: 0.25;'
        echo '<form action="' . $this->get_url() .'" METHOD="POST" NAME="myform">
        		<input type="hidden" name="page" value="editITdevices">
			<input type="hidden" name="action" value="' . $action . '">
			<input type="hidden" name="addinfo" value="">
			<input type="hidden" name="department_id" value="' . $department_id . '">
			<div>
				<table >';
        if ($is_platformadmin)
        {
            echo '	 <tr valign="top">
				  <td  align="right">
				   ' . get_lang('labelSelectDepartment') . '
				  </td>
				  <td>
				   <select name="IT_department_id">';
            foreach ($departmentStruc as $departmentid => $departmentinfo)
            {
                echo "<option value=\"" . $departmentid . "\" " . (($IT_department_id == $departmentid) ? 'SELECTED' : '') . ">" . $departmentinfo['code'] . "</option>";
            }
            echo '			</select>
				</td>
				  </td>
				 </tr>';
        }

        echo '		<tr>
					<td align="right">
						' . get_lang('labelUniqueID') . ':
					</td>
					<td>';
        echo '		<input type="hidden" name="old_device_id" value="' . (($old_device_id > 0) ? $old_device_id : $device_id) . '">';
        if ($is_platformadmin)
        {
            echo '		<input type="text" name="device_id" value="' . $device_id . '" >&nbsp;&nbsp;&nbsp;';
        }
        else
        {
            echo '<input type="hidden" name="device_id" value="' . $device_id . '" >&nbsp;&nbsp;&nbsp;[' . $device_id . ']';
        }
        echo '			</td>
				</tr>';
        echo '		<tr>
					<td align="right"> 
						' . get_lang('labelDeviceType') . ':
					</td>  
					<td>';
        $subquery = "SELECT `id`,`info` FROM `campus_it_device_info` WHERE `category_id`=0 ORDER BY `display_order`";
        $subresult = mysql_query($subquery);
        $selectlist = "";
        $selectedinfo = "";
        while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
        {
            $selected = (($rij['id'] == $devicetype) ? 'SELECTED' : '');
            $selectlist.="<option value='" . $rij['id'] . "' " . $selected . ">" . $rij['info'] . "</option>";
            if ($selected == 'SELECTED')
            {
                $selectedinfo = "<input type='text' size='" . (strlen($rij['info'] . " (" . get_lang('txtDeviceType_' . $rij['id']) . ")") + 3) . "' value='" . $rij['info'] . " (" . get_lang('txtDeviceType_' . $rij['id']) . ")' readonly>";
            }
        }
        if ($addinfo != "")
        {
            echo $selectedinfo;
        }
        echo "<select name='devicetype' " . (($form == "readonly") ? "style='display:none;'" : "") . " OnChange='javascript:myform.submit();'>";
        echo $selectlist;
        echo "</select>";
        echo '			</td>
				</tr>
				<tr>
					<td align="right"> 
						' . get_lang('labelDeviceIdentification') . ':
					</td>  
					<td>
						<input type="text" name="code" size="10" value="' . $code . '" ' . $form . '><span style="color:#ff0000;font-size:20px">*</span>
					</td>
				</tr>';
        echo '<tr>
					<td align="right">
						' . get_lang('labelResource') . ':
					</td>
					<td>';
        $subquery = "SELECT `id`,`code`, `comment` FROM `campus_resource` WHERE `department_id`=" . $department_id . " ORDER BY `code`";
        $subresult = mysql_query($subquery);
        $selectlist = "";
        $selectedoption = "<input type='text' size='8' value='' >";
        while ($resources = mysql_fetch_array($subresult, MYSQL_ASSOC))
        {
            $selected = (($resources['id'] == $resource_id) ? 'SELECTED' : '');
            $selectlist.="<option value='" . $resources['id'] . "' " . $selected . ">" . $resources['code'] . " (" . $resources['comment'] . ")</option>";
            if ($selected == 'SELECTED')
            {
                $selectedoption = "<input type='text' size='" . (strlen($resources['code'] . " (" . $resources['comment'] . ")") + 3) . "' value='" . $resources['code'] . " (" . $resources['comment'] . ")" . "' readonly>";
            }
        }
        if ($addinfo != "")
        {
            echo $selectedoption;
        }
        echo '<select name="resource_id" ' . (($form == 'readonly') ? 'style="display:none;"' : '') . ' OnChange="javascript:myform.submit();">';
        echo '<option value=""></option>';
        echo $selectlist;
        echo '</select>&nbsp;<span style="color:#ff8800;font-size:20px">!</span>';
        echo '<input type="hidden" name="filterresourceid" value="'.$resource_id.'">';
        echo '</td>
			</tr>
			<tr>
			<td align="right" valign="top">
				' . get_lang('labelPosition') . ':
			</td>
			<td>';
        echo '<input type="text" id="positionbutton" name="position" size="3" value="' . $position . '" style="display:;" ' . (($form == 'readonly') ? $form : 'onfocus="javascript: showID(\'positiontable\');hideID(\'positionbutton\');"') . ' >&nbsp;<span style="color:#ff8800;font-size:20px">!</span>';
        echo '<table id="positiontable" style="display:none;border: solid black;">';
        echo '<tr><td colspan=6 align="center">[===============&nbsp;' . get_lang('txtFrontRoom') . '&nbsp;===============]</td></tr>';
        // get resource occupation for given $resource_id...
        $positions = array();
        $positions[$position] = $it_id;
        $query = "SELECT `position`,`code` FROM `campus_it_device` WHERE `resource_id`=" . intval($resource_id) . " AND `department_id`=" . $department_id . " ORDER BY `position`";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $positions[$rij['position']] = $rij['code'];
        }
        for ($r = 1; $r < 10; $r++)
        {
            echo '<tr>';
            for ($c = 'A'; $c < 'G'; $c++)
            {
                echo '<td >';
                $used = ($position == $c . $r) ? ' style="color: #ff00ff;"' : ' style="color: #ff9900;"';
                echo '<input  value="' . $c . $r . '" type="submit" ' . (($positions[$c . $r] != '') ? ' ' . $used : '  onmousedown="javascript: document.myform.position.value=\'' . $c . $r . '\'"') . ' title="' . $positions[$c . $r] . '">';
                echo '</td>';
            }
            echo '</tr>';
        }
        echo '</table>';
        echo '		</td>
			</tr>';

        echo '<tr>
					<td align="right"> 
						' . get_lang('labelComment') . ':
					</td>
					<td>
						<input type="text" name="comment" value="' . $comment . '" size="40" ' . $form . '>
					</td>
				</tr>         
				<tr>
					<td align="right"> 
						' . get_lang('labelPurchaseDate') . ':
					</td>
					<td >
						<input type="text" name="purchase_date" size="10" value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $purchase_date) . '" ' . $form . '>(2005-01-24)
					</td>
				</tr>
				<tr>
					<td align="right"> 
						' . get_lang('labelPurchaseInfo') . ':
					</td>
					<td >
						<input type="text" name="purchase_info" size="40" value="' . $purchase_info . '" ' . $form . '>
					</td>
				</tr>';
        echo '<tr>
				<td align="right">
					' . get_lang('labelmacid') . ':
				</td>
				<td >
					<input type="text" name="macid" size="15" value="' . $macid . '" ' . $form . '>
				</td>
			</tr>
			<tr>
				<td  align="right">
					' . get_lang('labelDeviceState') . ':
				</td>
				<td>';
        echo '<select name="devicestate" ' . (($form == 'readonly') ? 'style="display:none;"' : '') . '>';

        echo '<option value="0" ' . (($devicestate == 0) ? 'SELECTED' : '') . '>' . get_lang('devicestate_0') . '</option>';
        echo '<option value="1" ' . (($devicestate == 1) ? 'SELECTED' : '') . '>' . get_lang('devicestate_1') . '</option>';
        echo '<option value="2" ' . (($devicestate == 2) ? 'SELECTED' : '') . '>' . get_lang('devicestate_2') . '</option>';

        echo '</select>';
        echo '</td></tr>';

        // GET existing device info

        $query = 'SELECT DISTINCT t1.`id`, `category`, `readonly`, `system`,`multiple`, `type`,t2.`category_id` as device_info_exists FROM `campus_it_device_info_category` t1
                        LEFT JOIN (`campus_it_device_info` as t2
                                INNER JOIN `campus_it_device_rel_info` t3
                                    ON t2.`id` = t3.`info_id` AND t3.`device_id`=' . $device_id . ')
                                ON t2.`category_id` = t1.`id` AND t2.`category_id` > 0
                        WHERE `type`=0 OR `type`=' . $devicetype . '   ORDER BY t1.`display_order`';
        $result = mysql_query($query) or die(mysql_error());
        $selectlist = "";
        $selectedinfo = '<input type="text" ID="field_' . $infocategory_id . '" size="8" value="' . get_lang('txtSelectInfo') . '"  >';
        while (list($infocategory_id, $infocategory, $readonly, $system, $multiple, $type, $device_info_exists) = mysql_fetch_row($result))
        {
            if (($device_info_exists > 0) || (array_key_exists($infocategory_id, $info_id))||($addinfo == $infocategory_id))
            {
                echo '<tr>
                    <td  align="right">
                        ' . $infocategory . (($add_it_info == $infocategory_id) ? '<img src="' . Theme::get_image_path('application\campus') . 'status_warning_mini.png" border=0 align="absmiddle">' : '') . '
                    </td>
		<td>';
                echo '<a name="' . $infocategory_id . '">';

                $subquery = 'SELECT t1.`id`, `info`, IF(t2.`device_id`,"SELECTED","") as `present` FROM `campus_it_device_info` t1
                            LEFT JOIN `campus_it_device_rel_info` t2 ON t1.`id` = t2.`info_id` AND t2.`device_id`=' . $device_id . '
                        WHERE `category_id`=' . $infocategory_id . ' ORDER BY `present` DESC,t1.`info`';
                $subresult = mysql_query($subquery);
                $selectlist = "";
                $selectedinfo = '<input type="text" ID="field_' . $infocategory_id . '" size="8" value="' . get_lang('txtSelectInfo') . '" ' . (($form == 'readonly') ? $form : 'onfocus="javascript: showID(\'multi_' . $infocategory_id . '\');hideID(\'field_' . $infocategory_id . '\');"') . ' >';
                while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
                {
                    $selected = (is_array($info_id[$infocategory_id])) ? (in_array($rij['id'], $info_id[$infocategory_id]) ? 'SELECTED' : '') : (($info_id[$infocategory_id] == $rij['id']) ? 'SELECTED' : $rij['present']);
                    $selectlist.="<option value='" . $rij['id'] . "' " . $selected . ">" . $rij['info'] . "</option>";
                    if ($selected == 'SELECTED')
                    {
                        $selectedinfo = "<input type='text' ID='field_" . $infocategory_id . "' size='" . (strlen($rij['info']) + 3) . "' value='" . $rij['info'] . "' " . (($form == 'readonly') ? $form : "onfocus=\"javascript: showID('multi_" . $infocategory_id . "');hideID('field_" . $infocategory_id . "');\"") . " >";
                    }
                }
                if ($addinfo == $infocategory_id)
                {
                    echo "<input type='hidden' name='category_id_new_info' value='" . $infocategory_id . "'>";
                    echo "<input type='hidden' name='newinfo_array' value='true'>";
                    echo '<input type="text" name="newinfo" style="width:230px; background-color: yellow;">';
                    echo "<input type='submit'  name='save_new_info' value='OK' /> <input type='submit' value='Cancel' >";
                }
                else
                {
                    echo (!$readonly || ($addinfo != "")) ? $selectedinfo : "";
                }
                if (!$readonly)
                {
                    echo "<select ID='multi_" . $infocategory_id . "' name='info_id[" . $infocategory_id . "][]' multiple='multiple' size=8 style='display:none;'>";
                }
                else
                {
                    echo "<select name='info_id[" . $infocategory_id . "]' " . (($form == "readonly") ? "style='display:none;'" : "") . ">";
                }
                echo "<option value=''></option>";
                echo $selectlist;
                echo "</select>";
                echo (!$readonly && ($addinfo == "")) ? "<input type='submit' value='" . get_lang('txtAddInfo') . "' onMouseDown=\"javascript: document.myform.addinfo.value='" . $infocategory_id . "';\">" : "";
                echo "</td>";
                echo "</tr>";
            }
            else
            {
                $option.= "<option value='" . $infocategory_id . "'>" . trim($infocategory) . "</option>";
            }
        }


        echo "<tr>";

        echo "<td  align='right' valign='top'>";
        echo "Andere info:";
        echo "</td>";
        echo "<td>";
        echo '<select name="add_it_info" ' . (($form == "readonly") ? "style='display:none;'" : "") . ' onchange="javascript: submit()">';
        echo '<option value="" >' . get_lang('txtAddInfoCategory') . '</option>';
        echo $option;
        echo "</select>";
        echo "</td>";
        echo "</tr>";



        echo "<tr>";
        echo "<td  align='right' valign='top'>";
        echo "</td>";
        echo "</tr>";
        if ($addinfo == "")
        {
            echo "<tr valign='top'>";
            echo "<td>";
            echo "</td>";
            echo "<td colspan='2' ID='savebutton' style='display:'>";
            echo '<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelSave').'" />&nbsp;<input type="submit" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'ITlist\';">';
            if ($action!='new')
                echo '&nbsp;<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelSaveAsNew').'" onMouseDown="javascript:document.myform.action.value=\'new\';document.myform.device_id.value=\'\';">';
            echo "</td>";
            echo "</tr>";
        }
        echo '</table></div></form>';
        echo '</div>';
    }
    else
    {
        include ("ITdevicelist.php"); // the content of this plugin....
    }
}
?>