<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;

//check if file is included...
if ((intval($_uid) == 0) || (empty($admin['IT']) && !$is_platformadmin))
{
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{

//display title and messages
        /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
// initiatisatie van de variabelen die via POST of GET worden mee gezonden
    $data = array();
    $pc_updates = 0;
    $pc_new = 0;
    if (!empty($_FILES))
    {
        // bestand regels in lezen
        $lines = file($_FILES['uploadfile']['tmp_name']);
        foreach ($lines as $key => $value)
        {
            //de positie bepalen van het eerste ':', geen ':' wordt geen geldige data.
            $pos = strpos($value, ":");
            if (!$pos)
            {
                
            }
            else
            {
                //read data from file ...
                $veld = ereg_replace("[0-9]", "", substr($value, 0, $pos));
                $waarde = trim(substr($value . " ", $pos + 1, -1));
                Switch ($veld)
                {
                    case "Computer" :
                        { // the computer name set as 'it_id'
                            $it_id = $waarde;
                        }
                        Break;
                    case "Baseboard" :
                        { // the motherboard is type_id=11 in campus_IT_field_types
                            $data[11][] = $waarde;
                        }
                        Break;
                    case "Processor" :
                        { // the processor is type_id=12 in campus_IT_field_types
                            $data[12][] = $waarde;
                        }
                        Break;
                    case "Memory" :
                        { // the memory is type_id=13 in campus_IT_field_types
                            $data[13][] = $waarde;
                        }
                        Break;
                    case "VideoController" :
                        { // the VideoController is type_id=14 in campus_IT_field_types
                            $data[14][] = $waarde;
                        }
                        Break;
                    case "NetworkAdapter" :
                        { // the networkadapter is type_id=15 in campus_IT_field_types
                            if (strstr($waarde, "minipoort") == false)
                            {
                                $data[15][] = $waarde;
                            }
                        }
                        Break;
                    case "FloppyDrive" :
                    case "CDROMDrive" :
                    case "DiskDrive" :
                        { // the floppydrive,cdromdrive,diskdrive (media) is type_id=16 in campus_IT_field_types
                            $data[16][] = $waarde;
                        }
                        Break;
                    case "OperatingSystem" :
                        { // the operatingsystem is type_id=17 in campus_IT_field_types
                            $data[17][] = $waarde;
                        }
                        Break;
                    case "SoftWare" :
                        { // the Software is type_id=18 in campus_IT_field_types
                            $data[18][] = $waarde;
                        }
                        Break;
                    case "By" :
                        {
                            //computergegevens schrijven in data bank.
                            //controleren of de computer al gegevens heeft in de databank. afhankelijk hier van het type mysql opdracht kiezen.
                            $it_id = ereg_replace(" ", "", $it_id);
                            $query = 'SELECT `id` ';
                            $query.='FROM `campus_it_device` ';
                            $query.='WHERE `code`="' . $it_id . '" AND `department_id`=' . $department_id;
                            $result = mysql_query($query);
                            if (mysql_num_rows($result) == 0)
                            {//....wijzigen...
                                $query2 = 'INSERT `campus_it_device` SET
								`code`="' . $it_id . '",
                                                                `type`= 1,
                                                                `state`=0,
								`department_id`=' . $department_id;
                                $result2 = mysql_query($query2);
                                if ($result2)
                                {
                                    $device_id = mysql_insert_id();
                                    $pc_new++;
                                }
                            }
                            elseif (mysql_num_rows($result) == 1)
                            {// get device_id of existing computer...
                                list($device_id) = mysql_fetch_row($result);

                                $result = mysql_query('DELETE `campus_it_device_rel_info` FROM `campus_it_device_rel_info`
										INNER JOIN `campus_it_device_info` ON `campus_it_device_info`.`id`=`campus_it_device_rel_info`.`info_id`
										 WHERE `category_id`>10 AND `category_id`<19 AND `device_id`=' . $device_id);
                                // remove selected options that will be imported by import routine...
                                $pc_updates++;
                            }
                            else
                            {
                                $device_id = 0;
                                $message = get_lang('msgMultipleDevicesFound');
                            }
                            if ($device_id > 0)
                            {
                                // check if values of options exist, add new options....
                                foreach ($data as $category_id => $value)
                                {
                                    foreach ($value as $key => $info)
                                    {
                                        $query = 'select `id` FROM `campus_it_device_info` WHERE `info`="' . $info . '" AND `category_id`=' . $category_id;
                                        $result = mysql_query($query);
                                        list($info_id) = mysql_fetch_row($result);
                                        if ($info_id == 0)
                                        { // add new options wenn not available
                                            $query = 'INSERT `campus_it_device_info` SET
													`info`="' . $info . '",
													`category_id`=' .  $category_id;
                                            $result = mysql_query($query);
                                            if ($result)
                                            {
                                                $info_id = mysql_insert_id();
                                            }
                                        }
                                        if ($info_id > 0)
                                        {
                                            $query = 'INSERT `campus_it_device_rel_info` SET
											`device_id`=' . $device_id . ',
											`info_id`=' . $info_id;
                                            $result = mysql_query($query);
                                        }
                                    }
                                }
                            }
                            // ARRAY leegmaken voor de volgende computer...
                            $data = array();
                        }
                        Break;
                }
            }
        }
        if (!empty($message))
        {
            Display::error_message($message);
        }
        else
        {
            Display::normal_message($pc_new . " " . get_lang('msgDevicesAdded') . "<br>" . $pc_updates . " " . get_lang('msgDevicesUpdated'), false);
        }
    }
    else
    {
        // no files selected display form to select file....
        echo '<table>
			<tr>
			<td>
		        ' . get_lang('txtExecHardwarevbs') . '
			</td>
			<td>
                            <form action="' . $this->get_url() . '" method="POST" name="formnieuw" style="display:inline;">
                                        <input type="hidden" name="page"  value="hardwarescan">
                                        <input type="submit" value="Hardware.vbs" >' . get_lang('txtOnlyWindows') . '
			    </form>
		    	</td>
		    	</tr>
		    	<tr>
			<td valign="top">
			    ' . get_lang('txtSelectFile') . '
		    	</td>
	    		<td>
			    <form action="' . $this->get_url() . '" METHOD="POST" NAME="myform" enctype="multipart/form-data">
				    <input type="hidden" name="page" value="importIT">	
					<input type="hidden" name="department_id" value="' . $department_id . '">
					<input type="hidden" name="MAX_FILE_SIZE" value="500000">
					<input type="file" name="uploadfile"><br>
					<input type="submit" value="Upload" >
			    </form>
			</td>
			</tr>
			</table>';
    }
    echo '<BR><BR><a href="' .$this->get_url()  . '&page=ITdevicelist" >' . get_lang('page_ITdevicelist') . '&nbsp;</A>';
}
?>