<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\WebApplication;
use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    require_once (api_get_path(LIBRARY_PATH) . 'classmanager.lib.php');

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    ***
    $action = campus::get_POST_GET("action", "step1");
    $lastnameCol = campus::get_POST_GET("lastnameCol");
    $firstnameCol = campus::get_POST_GET("firstnameCol");
    $officialcodeCol = campus::get_POST_GET("officialcodeCol");
    $usernameCol = campus::get_POST_GET("usernameCol");
    $birthCol = campus::get_POST_GET("birthCol");
    $adressCol = campus::get_POST_GET("adressCol");
    $mailCol = campus::get_POST_GET("mailCol");
    $telCol = campus::get_POST_GET("telCol");
    $photoCol = campus::get_POST_GET("photoCol");
    $row1 = campus::get_POST_GET("row1", "on");
    $result = mysql_query("SELECT `id`,`name` FROM `campus_department_rel_group`
				INNER JOIN `group_group`
                                    ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
				WHERE `campus_department_rel_group`.`department_id` = '" . $department_id . "'
 												 LIMIT 1");
    list ($groupid, $groupname) = mysql_fetch_row($result);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (intval($groupid) == 0)
    {
        Display::error_message(get_lang('msgNoParentClass'), false);
    }
    else
    {

        //display messages
        if (!empty($message))
        {
            Display::normal_message($message, false);
        }

        switch ($action)
        {
            case "step1" :
                {
                    /* ==============================================================================
                      Step 1: display importform.....
                      Select import-file and select cols....
                      ============================================================================== */
                    // reset session....
                    unset($_SESSION['userdata']);
                    echo '
			<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
			<input type="hidden" name="action" value="step2" >
			<input type="hidden" name="page" value="addparents" >
			<input type="hidden" name="MAX_FILE_SIZE" value="100000">
			<table>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelNameCol') . '
					</td>
					<td>
						<input type="text" name="lastnameCol" size="2" maxlength="2" value="0" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" ' . (($row1 == 'on') ? 'checked' : '') . '>
					</td>
					<td width="50%" rowspan="10">
						' . get_lang("helpParentImport") . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Voornaam;achternaam;geb.datum;gebruikersnaam;Adres;Telefoon;Afkorting;e-mail<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Achternaam;Voornaam;geb.datum;gebruikersnaam;Adres;Telefoon;Afkorting;e-mail<br>
						 Edison;Thomas;1847-02-11;;;EDTH;edison.thomas@tussen.be<br>
						 Einstein;Albert;1879-03-14;;;EIAL;einstein.albert@tussen.be<br>
					</div>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelFirstNameCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="firstnameCol" size="2" maxlength="2" value="1" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelBirthCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="birthCol" size="2" maxlength="2" value="2" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelUsernameCol') . '
					</td>
					<td>
						<input type="text" name="usernameCol" size="2" maxlength="2" value="3" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelAdressCol') . '
					</td>
					<td>
						<input type="text" name="adressCol" size="2" maxlength="2" value="4" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelPhoneCol') . '
					</td>
					<td>
							<input type="text" name="telCol" size="2" maxlength="2" value="5" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelMailCol') . '
					</td>
					<td>
						<input type="text" name="mailCol" size="2" maxlength="2" value="6" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelOfficialcodeCol') . '
					</td>
					<td>
						<input type="text" name="officialcodeCol" size="2" maxlength="2" value="7" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelSelectFile2Import') . '
						</td>
					<td colspan="3">
						<input type="file" name="uploadfile" >
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td colspan="5">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">
					</td>
				</tr>
			</table>
			</form>';
                }
                break;
            case "step2":
                {
                    /*
                      ==============================================================================
                      Step 2: check new users with existing platform users...
                      Show import options....
                      ==============================================================================
                     */
                    if (!empty($_FILES)) // het bestand lezen...
                    {
                        if ((trim($lastnameCol) != "") AND (trim($firstnameCol) != "") AND (trim($usernameCol) != ""))
                        {
                            //Het bestand inlezen ....
                            $lines = file($_FILES['uploadfile']['tmp_name']);
                            // existing usernames in array...
                            $sql = "SELECT `username` FROM `user_user`";
                            $result = mysql_query($sql);
                            while ($rij = mysql_fetch_array($result))
                            {
                                $existingusernames[] = $rij['username'];
                            }
                            echo '
				<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" >
				<input type="hidden" name="action" value="step3" >
				<input type="hidden" name="page" value="addparents" >
				<input type="hidden" name="lastnameCol" size="2" maxlength="2" value="' . intval($lastnameCol) . '" />
				<input type="hidden" name="firstnameCol" size="2" maxlength="2" value="' . intval($firstnameCol) . '" />
				<input type="hidden" name="usernameCol" size="2" maxlength="2" value="' . intval($usernameCol) . '" />
				<input type="hidden" name="officialcodeCol" size="2" maxlength="2" value="' . $officialcodeCol . '" />
				<input type="hidden" name="birthCol" size="2" maxlength="2" value="' . $birthCol . '" />
				<input type="hidden" name="adressCol" size="2" maxlength="2" value="' . $adressCol . '" />
				<input type="hidden" name="mailCol" size="2" maxlength="2" value="' . $mailCol . '" />
				<input type="hidden" name="telCol" size="2" maxlength="2" value="' . $telCol . '" />
				<input type="hidden" name="listChar" size="2" maxlength="2" value="' . $listChar . '" />
				<input type="hidden" name="textChar" size="2" maxlength="2" value="' . htmlspecialchars(stripslashes($textChar)) . '" />
				<input type="hidden" name="row1" size="2" maxlength="2" value="' . $row1 . '" />';
                            $_SESSION['userdata'] = $lines;
                            Display::display_complex_table_header($properties, array(get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadUsername"), get_lang("colheadOfficialCode"), get_lang("colheadBirth"), get_lang("colheadAdress"), get_lang("colheadMail"), get_lang("colheadPhone"), ""));
                            $records = 0;
                            foreach ($lines as $lijnnr => $value)
                            {
                                if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                                {
                                    $records++;
                                    $data = array();
                                    $values = explode(";", $value);
                                    // extract values...
                                    $valName = (trim($values[intval($lastnameCol)]));
                                    $valFirstName = (trim($values[intval($firstnameCol)]));
                                    $valBirth = trim($values[intval($birthCol)]);
                                    $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                                    $valOfficialcode = addslashes(trim($values[intval(((trim($officialcodeCol) == "") ? $usernamecol : $officialcodeCol))]));
                                    $valUsername = addslashes(trim($values[intval($usernameCol)]));
                                    $valAdress = (trim($values[intval($adressCol)]));
                                    $valMail = (trim($mailCol) == "") ? "" : (trim($values[intval($mailCol)]));
                                    $valPhone = (trim($values[intval($telCol)]));
                                    if (($valName != "") AND ($valFirstName != "") AND ($valBirth != "") AND ($valUsername != ""))
                                    {
                                        $sql = 'SELECT `lastname`,`firstname`,`birth`,`adress`,`email`,`phone`,`user_id`,`official_code`,`username` FROM `' . $_configuration['main_database'] . '`.`user` WHERE (`lastname` = "' . $valName . '" AND `firstname`="' . $valFirstName . '" AND `birth`="' . $valBirth . '") LIMIT 1';
                                        $result = mysql_query($sql);
                                        $aantal = mysql_num_rows($result);
                                        if ($aantal == 0)
                                        { // de naam en voornaam bestaan nog niet dus worden deze toegevoegd.
                                            // if username is allready used, get user details
                                            $inputusername = campus::get_POST_GET('username' . $lijnnr);
                                            if (trim($usernameCol) != "")
                                            {
                                                $suggestedusername = $valUsername;
                                                $generated = get_lang("txtImportUsername");
                                            }
                                            else
                                            {
                                                $suggestedusername = campus::get_POST_GET('username' . $lijnnr);
                                                $generated = "";
                                            }
                                            // check generated username....
                                            $exists = in_array($suggestedusername, $existingusernames);
                                            if (!$exists)
                                            {
                                                $existingusernames[] = $suggestedusername;
                                            }
                                            else
                                            {
                                                // if username is allready used, get user details
                                                $sql2 = "SELECT concat(`lastname`,' ',`firstname`,' (',`birth`,' ',`adress`,')') as userdetail FROM `" . $_configuration['main_database'] . "`.`user` WHERE `username` = '" . $suggestedusername . "'";
                                                $result2 = mysql_query($sql2);
                                                list($userdetail) = mysql_fetch_row($result2);
                                            }
                                            $usernameline = "<input type=\"text\" name=\"username" . $lijnnr . "\" value=\"" . $suggestedusername . "\" style=\"background-color:" . (($exists) ? 'red' : 'white') . "\" " . ($exists ? 'title="' . $userdetail . '" ' : 'READONLY') . ">" . $generated;
                                            if (!$exists)
                                            {
                                                $actionline = "<div>" . get_lang("txtInsertNewParent") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"insert\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "</div>";
                                            }
                                            else
                                            {
                                                $actionline = "<div >" . get_lang("txtNoAction") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">";
                                            }
                                        }
                                        else
                                        { // de naam, voornaam bestaat al update of toevoegen...
                                            $rij = mysql_fetch_array($result);
                                            $changed = FALSE;
                                            if (($rij['username'] != $valUsername) && (trim($usernameCol) != ""))
                                            {
                                                $usernameline = "<input type=\"text\" style=\"background-color: red\" name=\"username" . $lijnnr . "\" value=\"" . $valUsername . "\" title=\"" . get_lang("txtOldValue") . " " . $rij['username'] . "\" READONLY>";
                                                $changed = true;
                                            }
                                            else
                                            {
                                                $usernameline = "<input type=\"text\" name=\"username" . $lijnnr . "\" value=\"" . $rij['username'] . "\" READONLY>";
                                            }
                                            if (($rij['official_code'] != $valOfficialcode) && (trim($officialcodeCol) != ""))
                                            {
                                                $valOfficialcode = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['official_code'] . "\">&nbsp;" . $valOfficialcode . "&nbsp;</b>";
                                                $changed = TRUE;
                                            }
                                            if (($rij['adress'] != $valAdress) && (trim($adressCol) != ""))
                                            {
                                                $valAdress = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['adress'] . "\">&nbsp;" . $valAdress . "&nbsp;</b>";
                                                $changed = TRUE;
                                            }
                                            if (($rij['email'] != $valMail) && (trim($mailCol) != ""))
                                            {
                                                $valMail = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['email'] . "\">&nbsp;" . $valMail . "&nbsp;</b>";
                                                $changed = TRUE;
                                            }
                                            if (($rij['phone'] != $valPhone) && (trim($telCol) != ""))
                                            {
                                                $valPhone = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['phone'] . "\">&nbsp;" . $valPhone . "&nbsp;</b>";
                                                $changed = TRUE;
                                            }
                                            if ($changed)
                                            {
                                                $actionline = "<div>" . get_lang("txtOverWriteUser") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"update\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "<input type=\"hidden\" name=\"userid" . $lijnnr . "\" value=\"" . $rij['user_id'] . "\"></div>";
                                            }
                                            else
                                            {
                                                $actionline = "<div >" . get_lang("txtNoChange") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">";
                                            }
                                        }
                                        $data[] = $valName;
                                        $data[] = $valFirstName;
                                        $data[] = $usernameline;
                                        $data[] = $valOfficialcode;
                                        $data[] = $valBirth;
                                        $data[] = $valAdress;
                                        $data[] = $valMail;
                                        $data[] = $valPhone;
                                        $data[] = $actionline;
                                        Display::display_table_row($bgcolor, $data, true);
                                    }
                                }
                            }
                            Display::display_table_footer();
                            echo get_lang("txtNoRecords") . " " . $records;
                            echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelExecute') . '">&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">';
                            echo '</form>';
                        }
                        else
                        {
                            Display::display_error_message(get_lang("msgMissingData"), false);
                        }
                    }
                }
                break;
            case "step3":
                {
                    /*
                      ============================================================================
                      Stap 3: controleer of in het gebruikers bestand al gebruikers met
                      identieke naam en voornaam bestaan.....
                      Geeft de mogelijkheid om deze gegevens over te nemen....
                      ============================================================================
                     */
                    if (!empty($_SESSION['userdata'])) // het bestand lezen...
                    {
                        //Het bestand inlezen ....
                        $lines = $_SESSION['userdata'];
                        $records = 0;
                        $change = 0;
                        $new = 0;
                        Display::display_complex_table_header($properties, array(get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadDepartmentShort"), get_lang("colheadUsername"), get_lang("colheadPasswd"), ""));
                        foreach ($lines as $lijnnr => $value)
                        {
                            if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                            {
                                $records++;
                                $data = array();
                                $values = explode(";", $value);
                                // extract values...
                                $valName = (trim($values[intval($lastnameCol)]));
                                $valFirstName = (trim($values[intval($firstnameCol)]));
                                $valBirth = trim($values[intval($birthCol)]);
                                $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                                $valOfficialcode = trim($values[intval($officialcodeCol)]);
                                $valUsername = campus::get_POST_GET('username' . $lijnnr);
                                $valAdress = (trim($values[intval($adressCol)]));
                                $valMail = ($mailCol == "") ? "" : (trim($values[intval($mailCol)]));
                                $valPhone = (trim($values[intval($telCol)]));
                                $data[] = $valName;
                                $data[] = $valFirstName;
                                $data[] = $valOfficialcode;
                                $data[] = $valUsername; //campus::get_POST_GET('username'.$lijnnr);
                                switch (campus::get_POST_GET('queryaction' . $lijnnr))
                                {
                                    case "insert":
                                        {
                                            $password = api_generate_password();
                                            $data[] = $password;
                                            $sql = 'INSERT `' . $_configuration['main_database'] . '`.`user` SET
										`lastname`="' . $valName . '",
										`firstname`="' . $valFirstName . '",
										`username`="' . $valUsername . '",
										`birth`="' . $valBirth . '",
										' . (($adressCol != '') ? '`adress`="' . $valAdress . '",' : ' ') . '
										' . (($mailCol != '') ? '`email`="' . $valMail . '",' : ' ') . '
										' . (($telCol != '') ? '`phone`="' . $valPhone . '",' : ' ') . '
										' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '",' : ' ') . '
										`password`="' . $password . '", `status`=5 ';
                                            $result = mysql_query($sql);
                                            if ($result != false)
                                            {
                                                $parent_user_id = mysql_insert_id();
                                                // insert order nummer...
                                                $data[] = get_lang('txtUserInsertOK') . ', ' . get_lang('txtUserAdded2') . ' ' . $classname;
                                                $new++;
                                            }
                                            else
                                            {
                                                $data[] = get_lang("txtUserInsertError") . ', ' . get_lang('txtUserAdded2') . ' ' . $classname;
                                            }
                                            Display::display_table_row($bgcolor, $data, true);
                                        }
                                        break;
                                    case "update":
                                        {
                                            $parent_user_id = intval(campus::get_POST_GET('userid' . $lijnnr));
                                            $data[] = get_lang('txtUserPasswdKept');
                                            $sql = 'UPDATE `' . $_configuration['main_database'] . '`.`user` SET';
                                            $sql.='	' . (($adressCol != '') ? '`adress`="' . $valAdress . '",' : ' ');
                                            $sql.='	' . (($mailCol != '') ? '`email`="' . $valMail . '",' : ' ');
                                            $sql.='	' . (($telCol != '') ? '`phone`="' . $valPhone . '",' : ' ');
                                            $sql.='	' . (($birthCol != '') ? '`birth`="' . $valBirth . '",' : ' ');
                                            $sql.=' ' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '",' : ' ');
                                            $sql.=' `username`="' . $valUsername . '"';
                                            $sql.='	WHERE `user_id` = ' . $parent_user_id . ' ';
                                            $result = mysql_query($sql);
                                            if ($result != false)
                                            {
                                                // insert order nummer...
                                                $data[] = get_lang('txtUserUpdateOK') . ', ' . get_lang('txtUserAdded2') . ' ' . $classname;
                                                $change++;
                                            }
                                            else
                                            {
                                                $data[] = get_lang('txtUserUpdateError') . ', ' . get_lang('txtUserAdded2') . ' ' . $classname;
                                            }
                                            Display::display_table_row($bgcolor, $data, true);
                                        }
                                        break;
                                }
                                ClassManager :: add_user($parent_user_id, $classid);
                            }
                        }
                        Display::display_table_footer();
                        echo get_lang('txtNoRecords') . ' ' . $records . '&nbsp;&nbsp;' . get_lang('txtNewRecords') . ' ' . $new . '&nbsp;&nbsp;' . get_lang('txtChangedRecords') . ' ' . $change;
                    }
                }
                break;
        }
    }
}
?>
