<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  This is a studentlist to excell Export utility.
  ==============================================================================
 */
/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!"; //get_lang("msgNoRights4ThisDepartment");
}
else
{//only rosteradmins and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $rooster = campus::get_POST_GET("rooster");
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $roster_id = intval(campus::get_POST_GET("roster_id", $activeroster['roster_id']));
    $curriculum_id= campus::get_roster2curriculum($roster_id);
    /*
     *
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($roster_id>0)
    {
        // ===============================================================
        // generate Assignment list details........
        // ===============================================================
        // TEACHER ARRAY...

        $sql = "SELECT `campus_assignment_rel_teacher`.`assignment_id`, `campus_assignment_rel_teacher`.`user_id`, `official_code`, `lastname`, `firstname`
			FROM `campus_assignment_rel_teacher`
				INNER JOIN `user_user`
					ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
			WHERE `campus_assignment_rel_teacher`.`roster_id`=" . $roster_id . " ORDER BY `lastname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teachers_array[$rij['assignment_id']][$rij['user_id']]['official_code'] = $rij['official_code'];
        }
        // CLASSES ARRAY...
        $sql = 'SELECT `campus_assignment_rel_group`.`assignment_id`, `group_id`, `code`, `name`
			FROM `campus_assignment_rel_group`
                            INNER JOIN `campus_assignment`
                                ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
                            INNER JOIN `group_group`
				ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
                   WHERE `curriculum_id`= '.$curriculum_id.'
			 ORDER BY `code`';
        $result = mysql_query($sql) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $group_array[$rij['assignment_id']][$rij['group_id']]['code'] = $rij['code'];
        }
        // DISCIPLINE ARRAY...
        /*$sql = "SELECT `campus_assignment_discipline`.`assignment_id`, `campus_assignment_discipline`.`discipline_id`, `code`, `name`
			FROM `" . $campusDb . "`.`campus_assignment_discipline`
				INNER JOIN `" . $campusDb . "`.`campus_discipline`
					USING (`discipline_id`)
				INNER JOIN `" . $campusDb . "`.`campus_assignment`
					USING (`assignment_id`)
				WHERE `campus_assignment`.`rosternumber`=" . $rosternumber . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_array[$rij['assignment_id']][$rij['discipline_id']]['code'] = $rij['code'];
        }
*/
        // make list
        $data = ";Leerkacht(en);Klas(sen);Vk(ken);Uren\n";
        $row = 1;
        $query = "SELECT `campus_assignment`.`id`, `code`, SUM(`duration`) as `houres` FROM `campus_assignment`
				INNER JOIN `campus_college`
                                    ON `campus_college`.`assignment_id`=`campus_assignment`.`id`
				INNER JOIN `campus_discipline`
                                    ON 	`campus_discipline`.`id`= `campus_assignment`.`discipline_id`
				WHERE `roster_id`=" . $roster_id . " GROUP BY `campus_assignment`.`id`";
        $result = mysql_query($query) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            //$row++;
            $teachers = "";
            foreach ($teachers_array[$rij['id']] as $teacher_id => $value)
            {
                $teachers.=$value['official_code'] . " ";
            }
            $classes = "";
            foreach ($group_array[$rij['id']] as $class_id => $value)
            {
                $classes.=$value['code'] . " ";
                ;
            }
            $data.=$row++ . ';';
            $data.=$teachers . ';';
            $data.=$classes . ';';
            $data.=$rij['code'] . ';';
            $data.=$rij['houres'] . "\n";
        }
        /*
          -----------------------------------------------------------
          Header
          -----------------------------------------------------------
         */
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=assignment_export.csv");
        header('Content-transfer-encoding: binary');
        header("Pragma: no-cache");
        header("Expires: 0");
        // de rijen opsturen.
        print $data;
    }
    else
    {
        Display::display_normal_message(get_lang("msgNoActiveRoster"), false);
    }
}
?>
