<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

//check if user is allowed here...
if ((intval($_uid) == 0) || !($is_platformadmin))
{// not allowed here!
 	Display::error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only teachers and platform administrator are allowed here...


    // Query van het gegevensbestand....
    $query = "SELECT `display_order`, `lastname`, `firstname`, `birth`, `group_group`.`code`
            FROM `user_user`
                INNER JOIN `campus_user`
                   ON `user_user`.`id` = `campus_user`.`user_id`
                LEFT JOIN `group_group_rel_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                INNER JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id`
                LEFT JOIN `campus_department_rel_group`
                   ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
              WHERE `type`=2 AND `campus_department_rel_group`.`department_id`=" . $department_id . "
              ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";

    /*
      ==============================================================================
      Klas selecteren
      ==============================================================================
     */
    $result = mysql_query($query);

    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */

    $data = '';
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $data.=$rij['lastname'] . ";" . $rij['firstname'] . ";" . $rij['birth'] . ";" . $rij['code'] . ";" . $rij['display_order'] . "\n";
    }
     /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header("Content-type: application/octet-stream; charset=UTF-8");
    header("Content-Disposition: attachment; filename=klaslijst.csv");
    header('Content-transfer-encoding: binary');
    header("Pragma: no-cache");
    header("Expires: 0");
    // de rijen opsturen.
    print $data;
}
?>
