<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // de department detail info ophalen.
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $department_id = intval(campus::get_POST_GET("department_id"));

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //
        switch ($action)
        {
            case "new" :
                {
                    $department_id = "";
                    $code = "";
                    $name = "";
                    $department_url = "";
                    $logo = "Chamilo.jpg";
                    $department_admin_course = "";
                    $department_students_course = "";
                    $department_address = '';
                    $department_phone = '';
                    $agenda_layout=1;
                    $teacher_pics = "";
                    $student_pics = "";
                    $display = "form";
                }
                break;
            case "update" :
                {
                    // De gegevens van het bericht inlezen.
                    $query = "select `id`,`code`, `name`,`department_url`,`logo`,`teacher_pics`,`student_pics`,`department_admin_course`,`department_students_course`,`department_address`,`department_phone`,`agenda_layout` FROM `campus_department` WHERE `id`=" . $department_id . " LIMIT 1";
                    $result = mysql_query($query) or die(mysql_error());
                    list($department_id, $code, $name, $department_url, $logo,$teacher_pics, $student_pics, $department_admin_course, $department_students_course, $department_address, $department_phone,$agenda_layout) = mysql_fetch_row($result);
                    $display = "form";
                }
                break;
            case "delete" :
                {

                    /*
                     * @todo delete department related objects..
                     */
                    // delete linked teachers classes...
                    $result = mysql_query("DELETE FROM `campus_attentionpoint` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("DELETE FROM `campus_calender` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("DELETE FROM `campus_discipline` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("DELETE FROM `campus_info` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("DELETE FROM `campus_rights` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("DELETE FROM `campus_department_rel_group` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    /*$result = mysql_query("DELETE FROM `campus_timetable` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    $result = mysql_query("SELECT `rosternumber` FROM `campus_rosternumber` WHERE `department_id`=" . $department_id) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $result2 = mysql_query("SELECT `assignment_id`,`roster_id` FROM `campus_assignment` INNER JOIN  `campus_roster` USING(`assignment_id`) WHERE `rosternumber`=" . $rij['rosternumber']) or die(mysql_error());
                        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {
                            $result = mysql_query("DELETE FROM `campus_assignment_class` WHERE `assignment_id`=" . $rij2['assignment_id']) or die(mysql_error());
                            $result = mysql_query("DELETE FROM `campus_assignment_discipline` WHERE `assignment_id`=" . $rij2['assignment_id']) or die(mysql_error());
                            $result = mysql_query("DELETE FROM `campus_assignment_teacher` WHERE `assignment_id`=" . $rij2['assignment_id']) or die(mysql_error());
                            $result = mysql_query("DELETE FROM `campus_roster_resource` WHERE `roster_id`=" . $rij2['roster_id']) or die(mysql_error());
                        }
                        $result = mysql_query("DELETE `campus_assignment`,`campus_roster` FROM `campus_assignment` INNER JOIN  `campus_roster` USING(`assignment_id`) WHERE `rosternumber`=" . $rij['rosternumber']) or die(mysql_error());
                    }
                    $result = mysql_query("DELETE FROM `campus_rosternumber` WHERE `department_id`=" . $department_id) or die(mysql_error());*/
                    $result = mysql_query("DELETE FROM `campus_department` WHERE `id`=" . $department_id) or die(mysql_error());
                    $message = get_lang("msgDepartmentDeleted");
                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        $code = campus::get_POST_GET("code");
        $name = campus::get_POST_GET("name");
        $department_url = campus::get_POST_GET("department_url");
        $logo = campus::get_POST_GET("logo");
        $teacher_pics = campus::get_POST_GET("teacher_pics");
        $student_pics = campus::get_POST_GET("student_pics");
        $department_admin_course = campus::get_POST_GET("department_admin_course");
        $department_students_course = campus::get_POST_GET("department_students_course");
        $department_address = campus::get_POST_GET("department_address");
        $department_phone = campus::get_POST_GET("department_phone");
        $agenda_layout = intval(campus::get_POST_GET("agenda_layout"));
        if (!empty($code) && !empty($name))
        {
            switch ($action)
            {
                case "new" :
                    {
                        $query = "INSERT `campus_department` SET
                                    ".(($department_id>0)?"`id`=".$department_id.",":"")."
                                    `code`='" . $code . "',
						`name`='" . $name . "',
						`department_url`='" . $department_url . "',
						`logo`='" . $logo . "',
						`department_admin_course`='" . $department_admin_course . "',
						`department_students_course`='" . $department_students_course . "',
						`department_address`='" . $department_address . "',
						`department_phone`='" . $department_phone . "',
						`agenda_layout`='" . $agenda_layout . "',
						`teacher_pics`='" . $teacher_pics . "',
						`student_pics`='" . $student_pics . "'
				";
                        $result = mysql_query($query);
                        if (!$result)
                        {
                            $message = get_lang("msgNoDepartmentAdded");
                            $display = "form";
                        }
                        else
                        {
                            $newdepartment = mysql_insert_id();
                            $message = get_lang("msgDepartmentAdded");
                            $display = "list";
                        }
                    }
                    break;
                case "update" :
                    {
                        $query = "UPDATE `campus_department` SET
						`code`='" . $code . "',
						`name`='" . $name . "',
						`department_url`='" . $department_url . "',
						`logo`='" . $logo . "',
						`department_admin_course`='" . $department_admin_course . "',
						`department_students_course`='" . $department_students_course . "',
						`department_address`='" . $department_address . "',
						`department_phone`='" . $department_phone . "',
						`agenda_layout`='" . $agenda_layout . "',
						`teacher_pics`='" . $teacher_pics . "',
						`student_pics`='" . $student_pics . "'
						WHERE `id`=" . $department_id . "
				";
                        $result = mysql_query($query);
                        if (!$result)
                        {
                            $message = get_lang("msgDepartmentNotChanged");
                            $display = "form";
                        }
                        else
                        {
                            $message = get_lang("msgDepartmentChanged");
                            $display = "list";
                        }
                    }
                    break;
                default :
                    {
                        $display = "list";
                    }
                    break;
            }
        }
        else
        {
            $message = get_lang("msgDepartmentNotChanged");
            $display = "form";
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {

        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "form" :
            {
                // ===============================================================
                // .......
                // ===============================================================
                echo '<b>' . get_lang('page_adddepartment') . '</b><br>';
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
                echo '<input type="hidden" name="page" value="editdepartment" >';
                echo '<input type="hidden" name="action" value="' . $action . '" >';
                echo '<table>
			 <tr valign="top">
			  <td colspan="2">
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentId') . '
			  </td>
			  <td>
			   <input type="text" name="department_id" size="8" maxlength="16" value="' . $department_id . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentCode') . '
			  </td>
			  <td>
			   <input type="text" name="code" size="8" maxlength="16" value="' . $code . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentName') . '
			  </td>
			  <td>
			   <input type="text" name="name" size="50" maxlength="50" value="' . $name . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentLogo') . '
			  </td>
			  <td>
			   <input type="text" name="logo" size="50" maxlength="50" value="' . $logo . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentUrl') . '
			  </td>
			  <td>
			   <input type="text" name="department_url" size="50" maxlength="255" value="' . $department_url . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentAddress') . '
			  </td>
			  <td>
			   <input type="text" name="department_address" size="50" maxlength="255" value="' . $department_address . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentPhone') . '
			  </td>
			  <td>
			   <input type="text" name="department_phone" size="50" maxlength="255" value="' . $department_phone . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentAdminCourse') . '
			  </td>
			  <td>
			   <input type="text" name="department_admin_course" size="50" maxlength="255" value="' . $department_admin_course . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDepartmentStudentsCourse') . '
			   </td>
			   <td>
			    <input type="text" name="department_students_course" size="50" maxlength="255" value="' . $department_students_course . '" />
			    <br />
			   </td>
			  </tr>
			  <tr valign="top">
			   <td  align="right">
			    ' . get_lang('labelTeacherPics') . '
			   </td>
			   <td>
			    <input type="text" name="teacher_pics" size="50" maxlength="255" value="' . $teacher_pics . '" />
			    <br />
			   </td>
			  </tr>
			  <tr valign="top">
			   <td  align="right">
			    ' . get_lang('labelStudentPics') . '
			   </td>
			   <td>
			    <input type="text" name="student_pics" size="50" maxlength="255" value="' . $student_pics . '" />
			    <br />
			   </td>
			  </tr>
			 <tr valign="top">
			   <td  align="right">
			    ' . get_lang('labelAgendaLayout') . '
			   </td>
			   <td>
			    <input type="text" name="agenda_layout" size="50" maxlength="255" value="' . $agenda_layout . '" />
			    <br />
			   </td>
			  </tr>
			  <tr valign="top">
			   <td>
			   </td>
			   <td colspan="2">
			    <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
			   </td>
			  </tr>
			 </table>
			</form>';
            }
            break;
        case "list" :
            {
                // ===============================================================
                // display departments
                // ===============================================================
                $query = "SELECT `id`,`code`, `name` FROM `campus_department`";
                $result = mysql_query($query);
                echo "<div>";
                echo "&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=editdepartment&action=new&department_id=\">" . get_lang("txtAddNewDepartment") . "</a>";
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadDepartmentId"), get_lang("colheadDepartmentShort"), get_lang("colheadDepartmentName"), ""));
                while ($rij = mysql_fetch_array($result, MYSQL_NUM))
                {
                    $rij[3] = "<a href=\"" . $this->get_campus_admin_url() . "&page=editdepartment&department_id=" . $rij[0] . "&action=update\" title=\"" . get_lang("tooltipEditDepartment") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/edit.gif\" border=0 align=\"absmiddle\"></a>" .
                            "&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=editdepartment&department_id=" . $rij[0] . "&action=delete\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmDeleteDepartment") . "')) return false;\" title=\"" . get_lang("tooltipDeleteDepartment") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/delete.gif\" border=0 align=\"absmiddle\"></a>";
                    campus::display_table_row($bgcolor, $rij, true);
                }
                campus::display_table_footer();
            }
            break;
    }
}
?>