<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\ResourceManager;
use common\libraries\Path;

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */
// the language file
$language_file = array('courses', 'index');
$cidReset = true; /* Flag forcing the 'current course' reset,
  as we're not inside a course anymore */


// get department from user
/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */

$departmentStruc = campus::get_department($_uid);
$department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
// get rights of user in campus plugin .....
$admin = campus::get_rights($_uid, $department_id);
$action = campus::get_POST_GET('action');
$submitmessage = campus::get_POST_GET('submitmessage');
$id = intval(campus::get_POST_GET('id'));
//$activerosternumber = campus::get_rosternumber($department_id);
//$rosternumber = intval(campus::get_POST_GET("rosternumber", $activerosternumber));
//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang('msgNoRights4ThisDepartment'), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == '')
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case 'new' :
                {
                    $id = '';
                    $code = '';
                    $name = '';
                    $display = 'form';
                }
                break;
            case 'update' :
                {
                    // De gegevens van het bericht inlezen.
                    $query = "select * FROM `campus_discipline` WHERE `id`='" . $id . "' LIMIT 1";
                    $result = mysql_query($query);
                    while (list($id, $code, $name) = mysql_fetch_row($result))
                    {
                        break;
                    }
                    $display = 'form';
                }
                break;
            case 'delete' :
                {
                    // het vak verwijderen.....
                    $result = mysql_query("DELETE FROM `campus_discipline` WHERE `id`='" . $id . "' LIMIT 1");
                    $message = get_lang("msgItemDeleted");
                    $display = 'list';
                }
                break;
            case 'import' :
                {
                    $display = 'import';
                }
                break;
            case 'moveup' :
                { // move the selected line in the form list one up
                    $query = "SELECT * FROM `campus_discipline` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $id)
                        {
                            $result2 = mysql_query("UPDATE `campus_discipline` SET `display_order`=" . $line . " WHERE `department_id`=" . $department_id . " AND `display_order`=" . ($line - 1) . " "); //move previous down..
                            $result2 = mysql_query("UPDATE `campus_discipline` SET `display_order`=" . ($line - 1) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_discipline` SET `display_order`=" . $line . " WHERE `department_id`=" . $deparmtent_id . " AND `id`=" . $rij['id'] . " ");
                        }
                    }
                    $display = 'list';
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = "SELECT * FROM `campus_discipline` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $id)
                        {
                            $result2 = mysql_query("UPDATE `campus_discipline` SET `display_order`=" . ($line + 1) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_discipline` SET `display_order`=" . ($line + $moveup) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = 0;
                        }
                    }

                    $display = 'list';
                }
                break;
            default :
                {
                    $display = 'list';
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case 'new' :
                {
                    $result = mysql_query('select `display_order` FROM `campus_discipline` WHERE `department_id`= ' . $department_id . ' ORDER BY `display_order` DESC');
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_discipline` SET
					`code`="' . campus::get_POST_GET("code") . '",
					`name`="' . campus::get_POST_GET("name") . '",
					`department_id`= ' . $department_id . ',
                                                 `display_order`= ' . ($display_order + 1) . '   ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            case 'update' :
                {
                    $query = "UPDATE `campus_discipline` SET
					`code`='" . campus::get_POST_GET("code") . "',
					`name`='" . campus::get_POST_GET("name") . "'
					WHERE `id`='" . $id . "'
				";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $display = "list";
                    }
                }
                break;
            case 'import' :
                {
                    $row1 = campus::get_POST_GET("row1", "off");
                    if (!empty($_FILES))
                    {
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $i = 1;
                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                // als textChar leeg is een
                                $values = explode(";", $value);
                                $code = trim(addslashes($values[0]));
                                $display_order = intval(addslashes($values[2]));
                                if ($code != "")
                                {
                                    $result = mysql_query("INSERT INTO `campus_discipline` SET `code`='" . $code . "', `name`='" . trim(addslashes($values[1])) . "', `display_order`=" . (($display_order > 0) ? $display_order : $i) . ", `department_id`=" . $department_id);
                                }
                                else
                                {
                                    $result = false;
                                }
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                            }
                            $i++;
                        }
                    }
                    $display = "list";
                }
                break;
        }
    }
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "form" :
            {
// ===============================================================
// Het vak formulier weergeven.........
// ===============================================================
                echo '<b>' . get_lang('page_adddiscipline') . '</b><br>';
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
			<input type="hidden" name="page" value="editdiscipline" >
			<input type="hidden" name="id" value="' . $id . '" >
			<input type="hidden" name="action" value="' . $action . '" >
			<table>
			 <tr valign="top">
			  <td colspan="2">
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDisciplineCode') . '
			  </td>
			  <td>
			   <input type="text" name="code" size="8" maxlength="16" value="' . $code . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelDisciplineName') . '
			  </td>
			  <td>
			   <input type="text" name="name" size="32" maxlength="255" value="' . $name . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td>
			  </td>
			  <td>
			   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
			  </td>
			 </tr>
			</table>
		       </form>';
            }
            break;
        case "import" :
            {
                // ===============================================================
                // Discipline importform
                // ===============================================================
                echo '<b>' . get_lang('page_importdisciplines') . '</b><br>';
                echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">
                                <input type="hidden" name="page" value="editdiscipline" >
				<input type="hidden" name="action" value="import" >
				<input type="hidden" name="MAX_FILE_SIZE" value="100000">
				<table>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelDisableRow1') . '
				  </td>
				  <td >
				   <input type="checkbox" name="row1" value="on" checked>
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectFile2Import') . '
				  </td>
				  <td >
				   <input type="file" name="uploadfile" >
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td >
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td colspan=2>
				   ' . get_lang('helpDisciplineImport') . '<br>
				    <div style="color: #777777">
				     <u>' . get_lang('txtCsvImport') . '</u><br>
				     vakcode;naam<br>
				     xxx;xxxx<br>
				     xxx;xxx<br>
				     <br><u>' . get_lang('txtCsvExample') . '</u><br>
				     vakcode;naam<br>
				     INF;Informatica<br>
				     NED;Nederlands1<br>
				     WIS;Wiskunde2<br>
				    </div>
				   </td>
				  </tr>
				 </table>
				</form>';
            }
            break;
        case "list" :
            {
                echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_rosteradmin_ajax.js');
                echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/tooltip.css');
                echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');
                // ===============================================================
                // vaklijst weergeven........
                // ===============================================================
                $query = "SELECT * FROM `campus_discipline`
  					WHERE `department_id`=" . $department_id . " ORDER BY `display_order`,`code`";
                $result = mysql_query($query);
                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=editdiscipline&action=new">' . get_lang('txtAddDiscipline') . '</a>&nbsp;|&nbsp;';
                echo '<a href="' . $this->get_url() . '&page=editdiscipline&action=import">' . get_lang('txtImportDiscipline') . '</a>&nbsp;|&nbsp;';
                echo '</div>';
                campus::display_complex_table_header($properties, array(get_lang('colheadDisciplineCode'), get_lang('colheadDiscipline'), ''));
                $line = 0;
                $nbrLines = mysql_num_rows($result);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data[] = '<a name="' . $rij['id'] . '"></a>' . $rij['code'];
                    $data[] = '<div class="campus_tooltip_info"  title="" discipline_id="' . $rij['id'] . '">
					' . $rij['name'] . '</div>';
                    $data[] = '<a href="' . $this->get_url() . '&page=editdiscipline&id=' . $rij['id'] . '&action=update" title="' . get_lang('tooltipEditDiscipline') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle"></a>' .
                            '&nbsp;<a href="' . $this->get_url() . '&page=editdiscipline&id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteDiscipline') . '\')) return false;" title="' . get_lang('tooltipDeleteDiscipline') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a>' .
                            (($line == 1) ? '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">' : '<a href="' . $this->get_url() . '&page=editdiscipline&id=' . $rij['id'] . '&action=moveup&unique=' . $line . '#' . $rij['id'] . '"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>') .
                            (($line == $nbrLines) ? '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">' : '<a href="' . $this->get_url() . '&page=editdiscipline&id=' . $rij['id'] . '&action=movedown&unique=' . $line . '#' . $rij['id'] . '"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>');
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
    }
    /*
      ==============================================================================
      FOOTER
      ==============================================================================
     */
}
?>