<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $id = intval(campus::get_POST_GET("id"));

    $week = DatetimeUtilities::get_days_long();
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "new" :
                {
                    $id = "";
                    $code = "";
                    $weekday = "";
                    $start_time = "";
                    $end_time = "";
                    $display = "form";
                }
                break;
            case "update" :
                {
                    // De gegevens van het bericht inlezen.
                    $result = mysql_query('select * FROM `campus_period` WHERE `id`=' . $id);
                    list($id, $code, $weekday, $start_time, $end_time) = mysql_fetch_row($result);
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    // het vak verwijderen.....
                    $result = mysql_query('select `display_order`,`weekday` FROM `campus_period` WHERE `id`=' . $id);
                    list($display_order, $weekday) = mysql_fetch_row($result);
                    // delete row
                    $result = mysql_query('DELETE FROM `campus_period` WHERE `id`=' . $id);
                    // recalculate display_order.
                    $result = mysql_query('UPDATE `campus_period` SET `display_order`=`display_order`-1 WHERE `weekday`=' . $weekday . ' AND `display_order`> ' . $display_order . ' ORDER by `display_order`') or die(mysql_error());

                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            case 'moveup' :
                { // move the selected line in the form list one up
                    $result = mysql_query('select `weekday` FROM `campus_period` WHERE `id`=' . $id);
                    list($weekday) = mysql_fetch_row($result);
                    $query = 'SELECT * FROM `campus_period` WHERE `department_id`=' . $department_id . ' AND `weekday` = ' . $weekday . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $id)
                        {
                            $result2 = mysql_query('UPDATE `campus_period` SET `display_order`=' . $line . ' WHERE `department_id`=' . $department_id . ' AND `weekday` = ' . $weekday . ' AND `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_period` SET `display_order`=' . ($line - 1) . ' WHERE `department_id`=' . $department_id . ' AND `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_period` SET `display_order`=' . $line . ' WHERE `department_id`=' . $deparmtent_id . ' AND `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $display = 'list';
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $result = mysql_query('select `weekday` FROM `campus_period` WHERE `id`=' . $id);
                    list($weekday) = mysql_fetch_row($result);
                    $query = 'SELECT * FROM `campus_period` WHERE `department_id`=' . $department_id . ' AND `weekday` = ' . $weekday . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $id)
                        {
                            $result2 = mysql_query('UPDATE `campus_period` SET `display_order`=' . ($line + 1) . ' WHERE `department_id`=' . $department_id . ' AND `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_period` SET `display_order`=' . ($line + $moveup) . ' WHERE `department_id`=' . $department_id . ' AND `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $display = 'list';
                }
                break;
            case "import" :
                {
                    $display = "import";
                }
                break;
            default:
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $result = mysql_query('select `display_order` FROM `campus_period` WHERE `weekday`=' . intval(campus::get_POST_GET("weekday")) . ' AND `department_id`= ' . $department_id . ' ORDER BY `display_order` DESC');
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_period` SET
						`code`="' . campus::get_POST_GET("code") . '",
						`weekday`=' . intval(campus::get_POST_GET("weekday")) . ',
						`start_time`=' . strtotime('1970-01-01 ' . campus::get_POST_GET("start_time") . ':00') . ',
						`end_time`=' . strtotime('1970-01-01 ' . campus::get_POST_GET("end_time") . ':00') . ',
						`department_id`= ' . $department_id . ',
                                                 `display_order`= ' . ($display_order + 1) . '   ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $discipline_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            case "update" :
                {
                    $query = 'UPDATE `campus_period` SET
						`code`="' . campus::get_POST_GET("code") . '",
						`weekday`=' . intval(campus::get_POST_GET("weekday")) . ',
						`start_time`=' . strtotime('1970-01-01 ' . campus::get_POST_GET("start_time") . ':00') . ',
						`end_time`=' . strtotime('1970-01-01 ' . campus::get_POST_GET("end_time") . ':00') . '
					WHERE `id`=' . $id . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $display = "list";
                    }
                }
                break;
            case "import" :
                {
                    $week_key = array_change_key_case(array_flip($week));
                    $row1 = campus::get_POST_GET("row1", "off");
                    if (!empty($_FILES))
                    {
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $i = 1;
                        // for each weekday a separate display order counter....
                        $display_order=array(0=>1,1=>1,2=>1,3=>1,4=>1,5=>1,6=>1,7=>1);
                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                $values = explode(";", $value);
                                if ($values[0] != "")
                                {
                                    $weekday=intval($week_key[trim(strtolower($values[1]))]);
                                    $result = mysql_query("INSERT INTO `campus_period` SET `code`='" . trim($values[0]) . "', `weekday`=" . $weekday . ", `start_time`=" . strtotime('1970-01-01 ' . trim($values[2])) . ", `end_time`=" . strtotime('1970-01-01 ' . trim($values[3])) . ",  `display_order`=" . $display_order[$weekday]++ . ", `department_id`=" . $department_id);
                                }
                                else
                                {
                                    $result = false;
                                }
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                            }
                            $i++;
                        }
                    }
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      MAIN CODE
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "form" :
            {

                // ===============================================================
                // input/edit form...
                // ===============================================================
                echo "<b>" . get_lang("page_addtimetable") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">';
                echo '<input type="hidden" name="page" value="editperiod" >';
                echo '<input type="hidden" name="id" value="' . $id . '" >';
                echo '<input type="hidden" name="action" value="' . $action . '" >';
                echo '<table>
				<tr valign="top">
					<td colspan="2">
					</td>
				</tr>
				<tr valign="top">
					<td  align="right">
						' . get_lang('labelHour') . '
					</td>
					<td>
						<input type="text" name="code" size="2" maxlength="8" value="' . $code . '" />
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td  align="right">
						' . get_lang('labelDay') . '
					</td>
					<td>
						<select name="weekday" SIZE="1" >';
                foreach ($week as $key => $value)
                {
                    echo '<option value="' . $key . '" ' . (($weekday == $key) ? 'SELECTED' : (($action == 'update') ? 'disabled="disabled"' : '')) . '>' . $value . '</OPTION>';
                }
                echo '	</select>
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td  align="right">
						' . get_lang('labelTimingStart') . '
					</td>
					<td>
						<input type="text" name="start_time" value="' . DatetimeUtilities::format_locale_date('%H:%M', $start_time) . '" />(HH:MM)
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td  align="right">
						' . get_lang('labelTimingEnd') . '
					</td>
					<td>
						<input type="text" name="end_time" value="' . DatetimeUtilities::format_locale_date('%H:%M', $end_time) . '" />(HH:MM)
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td>
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
					</td>
				</tr>
			      </table>
			   </form>';
            }
            break;
        case "import" :
            {
                // ===============================================================
                // TimeSChedule importform
                // ===============================================================
                echo "<b>" . get_lang("page_importtimetable") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
                echo '<input type="hidden" name="page" value="editperiod" >';
                echo '<input type="hidden" name="action" value="import" >';
                echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000">';
                echo '<table>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td >
						<input type="checkbox" name="row1" value="on" checked >
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelSelectFile2Import') . '
					</td>
					<td >
						<input type="file" name="uploadfile" >
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td >
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
					</td>
				</tr>
				<tr valign="top">
					<td colspan=2>
						' . get_lang('helpScheduleImport') . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Lesuur;dag;begin;einde<br>
						 nn;xxxx;hh:mm;hh:mm<br>
						 nn;xxxx;hh:mm;hh:mm<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Lesuur;dag;begin;einde<br>
						 1;maandag;08:15;09:05<br>
						 2;maandag;09:05;09:55<br>
						 3;maandag;10:05;10:55<br>
					</div>
					</td>
				</tr>
			       </table>
			      </form>';
            }
            break;
        case "list" :
            {

                // ===============================================================
                // display timeschedule........
                // ===============================================================
                echo "<div >";
                echo "<a href=\"" . $this->get_url() . "&page=editperiod&action=new\">" . get_lang("txtAddTiming") . "</a>&nbsp;|&nbsp;";
                echo "<a href=\"" . $this->get_url() . "&page=editperiod&action=import\">" . get_lang("txtImportTimeSchedule") . "</a>";
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadPeriod"), get_lang("colheadDay"), get_lang("colheadStartTiming"), get_lang("colheadEndTiming"), ""));
                foreach ($week as $key => $weekday)
                {
                    $query = 'SELECT * FROM `campus_period` WHERE `department_id`=' . $department_id . ' AND `weekday`=' . $key . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $nbrLines = mysql_num_rows($result);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        $data = array();
                        $data[] = '<a name="' . $rij['id'] . '"></a>'. $rij['code'];
                        $data[] = $weekday;
                        $data[] = DatetimeUtilities::format_locale_date('%H:%M', $rij['start_time']);
                        $data[] = DatetimeUtilities::format_locale_date('%H:%M', $rij['end_time']);
                        $data[] = '<a href="' . $this->get_url() . '&page=editperiod&id=' . $rij['id'] . '&action=update" title="' . get_lang("tooltipEditTiming") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle"></a>' .
                                '&nbsp;<a href="' . $this->get_url() . '&page=editperiod&id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteTiming") . '\')) return false;" title="' . get_lang("tooltipDeleteTiming") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a>' .
                                (($line == 1) ? '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">' : '<a href="' . $this->get_url() . '&page=editperiod&id=' . $rij['id'] . '&unique=' . $line . '&action=moveup#' . $rij['id'] . '"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>') .
                                (($line == $nbrLines) ? '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">' : '<a href="' . $this->get_url() . '&page=editperiod&id=' . $rij['id'] . '&unique=' . $line . '&action=movedown#' . $rij['id'] . '"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>');
                        campus::display_table_row($bgcolor, $data, true);
                    }
                }
                campus::display_table_footer();
            }
    }
}
?>