<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;


/*
==============================================================================
	This is a content file included in the index.php file in this directory. 
==============================================================================
*/
/*
============================================================================== 
		MAIN CODE
============================================================================== 
*/ 

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($admin['roster']) && !$is_platformadmin)) 
{// not allowed here!
	Display::error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$id=intval(campus::get_POST_GET("id"));
	$resource_department_id=intval(campus::get_POST_GET("resource_department_id",$department_id));
/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/ 
	if ($submitmessage=="")
	{ //
		// de scholen ophalen waar de gebruiker deel van uitmaakt.
		switch ($action) 
		{
			case "new" :
			{ 
				$id="";
				$code="";
				$comment="";
				$reservable=2;
				$msg2Tchr="";
				$display="form";
			}
			break;
			case "update" :
			{
				// 
				$query="select `id`, `code`, `comment`, `reservable`, `user_id`, `department_id` FROM `campus_resource` WHERE `id`=".$id." ";
				$result = mysql_query($query) ;
				list($id,$code, $comment, $reservable,$msg2Tchr, $resource_department_id)= mysql_fetch_row($result);
				$display="form";
			}
			break;
			case "delete" :
			{
				// het vak verwijderen.....
				$result=mysql_query("DELETE FROM `campus_resource` WHERE `id`=".$id." ");
				$message = get_lang("msgItemDeleted");
				$display="list";
			}
			break;
			case "import" :
			{
				$display="import";
			}
			break;
			case "show" :
			{
			// 
				$result=mysql_query("UPDATE `campus_resource` SET `reservable`=2 WHERE `id`=".$id." ");
				$message = get_lang("msgResourceVisible");
				$display="list";
			}
			break;
			case "hide" :
			{
				$result=mysql_query("UPDATE `campus_resource` SET `reservable`=0 WHERE `id`=".$id." ");
				$message = get_lang("msgResourceHidden");
				$display="list";
			}
			break;
			default :
			{
				$display="list";
			}
			break;
		}
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				$query='INSERT 
						`campus_resource` SET
						`code`="'.campus::get_POST_GET("code").'",
						`comment`="'.addslashes(campus::get_POST_GET("comment")).'",
						`reservable`='.intval(campus::get_POST_GET("reservable")).',
						`user_id`='.intval(campus::get_POST_GET('msg2Tchr')).',
						`department_id`= '.$resource_department_id.'
					';
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
					$display="form";
				}
				else
				{
					$discipline_id=mysql_insert_id();
					$message = get_lang("msgItemAddSucces");
					$display="list";
				}
			}
			break;
			case "update" :
			{ 
				$query='UPDATE 
						`campus_resource` SET
						`code`="'.campus::get_POST_GET("code").'",
						`comment`="'.addslashes(campus::get_POST_GET("comment")).'",
						`reservable`='.intval(campus::get_POST_GET("reservable")).',
						`user_id`='.intval(campus::get_POST_GET("msg2Tchr")).',
						`department_id`= '.$resource_department_id.'
					WHERE `id`='.$id.' ';
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
					$display="form";
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
					$display="list";
				}
			}
			break;
			case "import" :
			{
				$row1=campus::get_POST_GET("row1","off");
				if (!empty($_FILES)) 
				{
					$lines=file($_FILES['uploadfile']['tmp_name']); 
					$i=1;
					foreach ($lines as $key => $value) 
					{
						if ((($row1=='off') && ($i==1)) || ($i>1))
						{
							// als textChar leeg is een 
							$values=explode(";",$value);	
							$code=trim(addslashes($values[0]));
							if ($code!="")
							{
								$result=mysql_query("INSERT INTO `campus_resource` SET `code`='".$code."', `comment`='".trim(addslashes($values[1]))."', `reservable`=".intval(trim(addslashes($values[2]))).", `department_id`=".$department_id);
 							}
							else
							{
								$result=false;
							}
							if (!$result)
							{
								$message = get_lang("msgImportErrors");
							}
						}
						$i++;
					}
				}
				$display="list";
			}
			break;
		}
	}
/*
============================================================================== 
		display ...
============================================================================== 
*/

        if (!empty($message))
	{		
		Display::normal_message($message);
	}
	switch ($display)
	{
		case "form" :
		{ 
// ===============================================================
// diplay Resource form.........
// ===============================================================
			echo "<b>".get_lang("page_addresource")."</b><br>";
			echo '<form method="post" action="'.$this->get_url().'" name="myform">
    				<input type="hidden" name="page" value="editresource" >
		    		<input type="hidden" name="id" value="'.$id.'" >
    				<input type="hidden" name="action" value="'.$action.'" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang("labelResource").'
				  </td>
				  <td>
				   <input type="text" name="code" size="8" maxlength="16" value="'.$code.'" />
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelComment').'
				  </td>
				  <td>
				   <input type="text" name="comment" size="32" maxlength="255" value="'.  ($comment).'" />
				  </td>
				 </tr>';
			if ($is_platformadmin)
			{
				echo '	 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelSelectDepartment').'
				  </td>
				  <td>
				   <select name="resource_department_id">
				   <option value="0" '.(($resource_department_id==0)? "SELECTED" :"").'>'.get_lang("txtNoDepartmentSelected").'</option>';
		 	  	foreach ($departmentStruc as $departmentid=>$departmentinfo)
		 	 	{
		 	  		echo "<option value=\"".$departmentid."\" ".(($resource_department_id==$departmentid)? 'SELECTED' : '').">".$departmentinfo['code']."</option>";
		     		}
		     		echo '			</select>
				</td>
				  </td>
				 </tr>';
			}
			echo '   <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelReservable').'
				  </td>
				  <td>
				   <input type="text" name="reservable" size="2" maxlength="2" value="'.$reservable.'"> 
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   '.get_lang('labelSelectTeacher').'
				  </td>
				  <td>
				   <select name="msg2Tchr" SIZE="1">';
			echo "<option value=\"null\" ".((($msg2Tchr=="")||($msg2Tchr==null))? "SELECTED":"")."> </option>";
			// de platform beheerder toevoegen als te adresseren persoon
  			$query="SELECT `id`,`lastname`, `firstname`, `official_code` FROM `user_user` WHERE `admin`=1 ";
   			$result = mysql_query($query) ;
	  		$rij=mysql_fetch_array($result,MYSQL_ASSOC);
	 	  	echo "<option value=\"".$rij['id']."\" ".(($msg2Tchr==$rij['id'])? "SELECTED":"").">".get_lang("txtPlatformAdmin").": ".$rij['lastname']." ".$rij['firstname']."</option>";
			// Al de leerkrachten van de department selecteren...
    			$query="SELECT DISTINCT `id`,`lastname`, `firstname`, `official_code`
           			FROM `group_group_rel_user`
               			LEFT JOIN `user_user`
                  			ON `user_user`.`id` = `group_group_rel_user`.`user_id`
           			WHERE (";
			// al de personeelsklassen van de department selecteren....
			$filter="";
 			$classes=campus::get_teacherclasses ($department_id);
	  		foreach ($classes as $class_id=>$classinfo)
 	  		{
 				$filter.=" `group_group_rel_user`.`group_id` = ".$class_id." OR ";
    			}
			$filter=substr($filter,0,-3);
			$sql=$query.$filter.") ORDER BY `lastname`,`firstname`";
			$result = mysql_query($sql) ;
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
	 	  		echo '<option value="'.$rij['id'].'" '.(($rij['id']==$msg2Tchr)? "SELECTED":"").'>'.$rij['official_code'].': '.$rij['lastname'].' '.$rij['firstname'].'</option>';
			}
    			echo '      </select>
				   </td>
				  </tr>
				  <tr valign="top">
				   <td>
				   </td>
				   <td>
				    <input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang("buttonlabelCancel").'" onMouseDown="javascript:document.myform.action.value=\'list\';">
				   </td>
			          </tr>
		                 </table>
				</form>';
		}
		break;
		case "import" :
		{
			// ===============================================================
			// Resource importform
			// ===============================================================
			echo "<b>".get_lang("page_importresource")."</b><br>";
   	 		echo '<form method="post" action="'.$this->get_url().'" name="importform" enctype="multipart/form-data">
			       <input type="hidden" name="page" value="editresource" >
    			       <input type="hidden" name="action" value="import" >
    			       <input type="hidden" name="MAX_FILE_SIZE" value="100000">
			       <table>
				<tr valign="top">
				 <td align="right">
				  '.get_lang('labelDisableRow1').'
				 </td>
				 <td >
				  <input type="checkbox" name="row1" value="on" checked>
				 </td>
				</tr>
				<tr valign="top">
				 <td align="right">
				  '.get_lang("labelSelectFile2Import").'
				 </td>
				 <td >
				  <input type="file" name="uploadfile" >
				  <br />
				 </td>
				</tr>
				<tr valign="top">
				 <td>
				 </td>
				 <td >
				  <input type="submit" name="submitmessage" value="'.get_lang('buttonlabelUpload').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.importform.action.value=\'list\';">
				 </td>
				</tr>
				<tr valign="top">
				 <td colspan=2>
				  '.get_lang('helpResourceImport').'<br>
				  <div style="color: #777777">
				   <u>'.get_lang('txtCsvImport').'</u><br>
				   klascode;naam;reserveerbaar<br>
				   xxx;xxxx;nn<br>
				   xxx;xxx;nn<br>
				   <br><u>'.get_lang('txtCsvExample').'</u><br>
				   klascode;naam;reserveerbaar<br>
				   A001;Informatica lokaal (15PC);2<br>
				   B101;KlaslokaalNederlands1;0<br>
				  </div>
				 </td>
				</tr>
			       </table>
			      </form>';
		}
		break;
		case "list" :
		{ 
		// ===============================================================
		// lokaallijst weergeven........
		// ===============================================================
			$query="SELECT `campus_resource`.`id`,`code`,`comment`,`official_code`,`reservable`,`department_id`
  					FROM `campus_resource`
             				LEFT JOIN `user_user`
                  					ON `user_user`.`id` = `campus_resource`.`user_id`
     					WHERE `department_id`=".$department_id." OR `department_id`=0 ORDER BY `code`";
			$result = mysql_query($query) ;
			echo "<div >";
			echo "<a href=\"".$this->get_url()."&page=editresource&action=new\">".get_lang("txtAddResource")."</a>&nbsp;|&nbsp;";
			echo "<a href=\"".$this->get_url()."&page=editresource&action=import\">".get_lang("txtImportResource")."</a>";
			echo "</div>";
			campus::display_complex_table_header($properties, array(get_lang("colheadResource"),get_lang("colheadComment"),get_lang("colheadWarning"),""));
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$data=array();
				$data[0]=$rij['code'];
				$data[1]=$rij['comment'];
				$data[2]=$rij['official_code'];
				$data[3]=($rij['department_id']==0)?'-':'';
				if (($rij['department_id']!=0) || $is_platformadmin)
				{
					$data[3]=(($rij['reservable']== 0)? "<a href=\"".$this->get_url()."&page=editresource&id=".$rij['id']."&action=show\" title=\"".get_lang("tooltipShowResource")."\"><img src=\"".Theme::get_image_path('application\campus')."invisible.gif\" border=0 align=\"absmiddle\"></a>" :
					  		"<a href=\"".$this->get_url()."&page=editresource&id=".$rij['id']."&action=hide\" title=\"".get_lang("tooltipHideResource")."\"><img src=\"".Theme::get_image_path('application\campus')."visible.gif\" border=0 align=\"absmiddle\"></a>");
    					$data[3].="&nbsp;<a href=\"".$this->get_url()."&page=editresource&id=".$rij['id']."&action=update\"  title=\"".get_lang("tooltipEditResource")."\"><img src=\"".Theme::get_image_path('application\campus')."edit.gif\" border=0 align=\"absmiddle\"></a>".
					  		"&nbsp;<a href=\"".$this->get_url()."&page=editresource&id=".$rij['id']."&action=delete\" onclick=\"javascript:if(!confirm('".get_lang("msgboxConfirmDeleteResource")."')) return false;\" title=\"".get_lang("tooltipDeleteResource")."\"><img src=\"".Theme::get_image_path('application\campus')."delete.gif\" border=0 align=\"absmiddle\">";
				}
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
		}
	}
}
?>