<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (!$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $submitmessage = campus::get_POST_GET("submitmessage");
    $row1 = campus::get_POST_GET("row1", "off");


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if ($submitmessage != "")
    {
        echo "<p><u><b>" . get_lang("txtImportTrackingForm") . "</b></u></p>";
        if (!empty($_FILES)) // het bestand lezen...
        {
            //Het bestand inlezen ....
            $type_array['text']=1;
            $type_array['mtext']=2;
            $type_array['input']=3;
            $type_array['textarea']=4;
            $type_array['select']=5;
            $type_array['mselect']=6;
            $type_array['mteachers']=7;
            $type_array['teachers']=8;
            $type_array['disciplines']=9;
            $type_array['mdisciplines']=10;
            $lines = file($_FILES['uploadfile']['tmp_name']);
            //generate importID department code + date + time
            $i = 1;
            foreach ($lines as $key => $value)
            {
                if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                {
                    $value = substr($value, 1);
                    $value = substr($value, 0, -2);
                    $values = explode('";"', $value);
                    //ignore $values[0]= id
                    //ignore $values[3]= teacher_id
                    $query = 'INSERT INTO `campus_trackingform_line` SET
				`id` = ' . $values[0] . ',
				`trackingform_id` = ' . $values[1] . ',
				`linebegin` = "' . addslashes(str_replace('<br>',"\n",$values[2])) . '",
				`linebegin_type` = ' . $type_array[$values[3]] . ',
                                `linebegin_value` = "' . addslashes(str_replace('<br>',"\n",$values[4])) . '",
                                `linemid` = "' . addslashes(str_replace('<br>',"\n",$values[5])) . '",
				`linemid_type` = ' . $type_array[$values[6]] . ',
                                `linemid_value` = "' . addslashes(str_replace('<br>',"\n",$values[7])) . '",
                                `lineend` = "' . addslashes(str_replace('<br>',"\n",$values[8])) . '",
				`lineend_type` = ' . $type_array[$values[9]] . ',
                                `lineend_value` = "' . addslashes(str_replace('<br>',"\n",$values[10])) . '",
                                `display_order` = ' . intval($values[11]) . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        dump ($values);
                        $errormessage = get_lang("msgImportErrors");
                    }
                    else
                    {
                        $message = get_lang("msgFileImported");
                    }
                }
                $i++;
            }
        }
    }
    if ($errormessage!="")
    {
       Display::error_message(get_lang($errormessage), false);
    }
    elseif ($message!="")
    {
        Display::normal_message($message);
    }
   // ===============================================================
    // het importformulier weergeven.....
    // Het import bestand wordt geselecteerd en ingesteld....
    // ===============================================================
    // reset session....
    echo "<b>" . get_lang("page_importagendacontent") . "</b><br>";
    echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
    echo '<input type="hidden" name="page" value="importtrackingformlines">';
    echo '<input type="hidden" name="action" value="import">';
    echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000000">';
    echo '	<table>
				<tr valign="top">
					<td colspan="2">
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" ' . (($_POST['row1'] == 'on') ? "checked" : "") . '>
					</td>
					<td width="50%" >
						<div style="color: #777777">
							<u>' . get_lang('txtCsvImport') . '</u><br>
							 klas(sen);datum;lesuur;duur;vak;leerkracht(en);inhoud;lokaal<br>
							 xxx;yyyy-mm-dd;nnn;nnn;xxx;xxx;xxx;xxx<br>
							 xxx;yyyy-mm-dd;nnn;nnn;xxx;xxx;xxx;xxx<br>
							<br><u>' . get_lang('txtCsvExample') . '</u><br>
							 klas(sen);datum;lesuur;duur;vak;leerkracht(en);inhoud;lokaal<br>
							 1A1;2008-02-28;1;2;INF;THLU;;A001<br>
							 1A2 1A1;2008-02-28;3;2;INF;THLU LKR2;PRAKTISCH;A001<br>
						</div>
					</td>
				</tr>';
    echo '	<tr valign="top">
				<td align="right">
					' . get_lang('labelSelectFile2Import') . '
				</td>
				<td colspan="3">
					<input type="file" name="uploadfile" >
					<br />
				</td>
				</tr>';
    echo '		<tr valign="top">
					<td>
					</td>
					<td colspan="3">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
					</td>
				</tr>
			</table>
			</form>';
}
?>