<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Path;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...



    /*
      -----------------------------------------------------------
      Specials
      -----------------------------------------------------------
     */
    /*  $xajax = new xajax();
      $xajax->setCharEncoding('iso-8859-15');
      $xajax->registerFunction('dropbox_files');
      $xajax->processRequests();

      function dropbox_files($arg)
      {
      // do some stuff based on $arg like query data from a database and
      // put it into a variable like $newContent
      $path = "../../../courses/" . $arg . "/dropbox";
      $this_folder = getcwd();
      //	$tcn_img_folder="website/photoalbum";
      $dropbox_folder = $path . "/";
      chdir($dropbox_folder);
      $handle = opendir('.');
      $newContent = '';
      while (false !== ($file = readdir($handle)))
      {
      if (substr($file, 0, 1) != ".")
      {
      $newContent.= $file . " (" . round((filesize($file) / 1024), 1) . "Kb)<br>";
      }
      //$newContent .= htmlentities($file).' :'.filesize($file).'<br />';
      }
      chdir($this_folder);

      // Instantiate the xajaxResponse object
      $objResponse = new xajaxResponse();

      // add a command to the response to assign the innerHTML attribute of
      // the element with id="SomeElementId" to whatever the new content is
      $objResponse->addAssign("files_" . $arg, "innerHTML", $newContent);

      //return the  xajaxResponse object
      return $objResponse;
      }
     */

    function dropbox_size($arg)
    {
        // do some stuff based on $arg like query data from a database and
        // put it into a variable like $newContent
        $path = Path::get_common_path() . "../../www/dokeos/courses/" . $arg . "/dropbox";
        $this_folder = getcwd();
        //	$tcn_img_folder="website/photoalbum";
        $dropbox_folder = $path . "/";
        chdir($dropbox_folder);
        $handle = opendir('.');
        $array = array();
        $filecount = 0;
        $filesize = 0;
        while (false !== ($file = readdir($handle)))
        {
            if (strtolower(substr($file, 0, 1)) != ".")
            {
                $filecount++;
                $filesize+=filesize($file);
            }
            //$newContent .= htmlentities($file).' :'.filesize($file).'<br />';
        }
        chdir($this_folder);

        if ($filecount > 0)
        {
            $array[] = $dropbox_folder . $filecount;
            $array[] = $filesize;
        }
        else
        {
            $array[] = 0;
            $array[] = 0;
        }
        return $array;
    }

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $deletedropbox = campus::get_POST_GET("deletedropbox");

    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */
    if (($deletedropbox != "") && ($is_platformadmin))
    {

        // check database for directory and db_name
        $query = "SELECT `directory`, `db_name` FROM  `DOKEOS_main`.`course` WHERE `code`='" . $deletedropbox . "'";
        $result = mysql_query($query);
        list($directory, $db_name) = mysql_fetch_row($result);
        // delete files from dropbox dirphoto with dokeos funtions...
        $path = Path::get_common_path() . "../../www/dokeos/courses/" . $directory . "/dropbox";
        $this_folder = getcwd();
        //	$tcn_img_folder="website/photoalbum";
        $dropbox_folder = $path . "/";
        chdir($dropbox_folder);
        $handle = opendir('.');
        $filecount = 0;
        while (false !== ($file = readdir($handle)))
        {
            if (strtolower(substr($file, 0, 1)) != ".")
            {
                $filecount++;
                //echo $file;
                unlink($file);
            }
            //$newContent .= htmlentities($file).' :'.filesize($file).'<br />';
        }
        chdir($this_folder);
        $query = "DELETE FROM " . $db_name.".dropbox_file";
        $result = mysql_query($query);
        $query = "DELETE FROM " . $db_name.".dropbox_feedback";
        $result = mysql_query($query);
        $query = "DELETE FROM " . $db_name.".dropbox_person";
        $result = mysql_query($query);
        $query = "DELETE FROM " . $db_name.".dropbox_post";
        $result = mysql_query($query);
        $message = get_lang("msgFilesDeleted");
    }



    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //display messages
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    // de verschillende klassen die tot een bepaalde department behoren ophalen....
    $classes = campus::get_studentclasses($department_id);


    // existing students of department in array...
    campus::display_complex_table_header($properties, array(get_lang("colheadCourseCode"), get_lang("colheadCourseTitle"), get_lang("colheadCourseTutor"), get_lang("colheadDbDropboxUse"), get_lang("colheadDropboxUse"), ""));
    // Query van het gegevensbestand....
    $query = "SELECT DISTINCT `course`.`code`,`title`, `tutor_name`, `last_visit`, `directory`, `db_name`
				FROM  `DOKEOS_main`.`course`
				INNER JOIN `DOKEOS_main`.`course_rel_user`
					ON `course`.`code`=`course_rel_user`.`course_code`
				INNER JOIN `DOKEOS_main`.`class_user`
					using ( `user_id`)
				INNER JOIN `campus_department_rel_group`
					on `class_user`.`class_id`= `campus_department_rel_group`.`group_id` AND `campus_department_rel_group`.`type`=1
       	        WHERE `department_id`=" . $department_id . " ORDER BY `course_code`,`tutor_name`";

    //$query="SELECT `code`,`title`, `tutor_name`, `last_visit`, `directory`, `db_name`
    //           FROM  `".$_configuration['main_database']."`.`course`	
    //           ORDER BY `code`,`tutor_name`";;
    $result = mysql_query($query) or die(mysql_error());
    $total_files = 0;
    $total_size = 0;
    $courses = 0;
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $data = array();
        $courses++;
        $data[] = "<a name='" . $rij['code'] . "'>" . $rij['code'] . "</a>";
        $data[] = $rij['title'];
        $data[] = $rij['tutor_name'];
        $query2 = "SELECT COUNT(*) as 'filecount', SUM(`filesize`) as 'totalsize' 
            FROM " . $rij['db_name'] . ".dropbox_file ";
        $result2 = mysql_query($query2);
        list($dbfilecount, $dbfilesize) = mysql_fetch_row($result2);
        $data[] = "DROPBOX  :" . $dbfilecount . " " . get_lang('txtFiles') . " - " . round((($dbfilesize / 1024) / 1024), 1) . " Mb";
        /* $data[]=$rij['db_name']."<a class='campus_agenda_info' href='#' onmouseover=\"xajax_dropbox_of_content('".$rij['db_name']."');\">
          <img src='../img/course_info.gif' style='vertical-align:middle; z-index:1;' >
          <span id='dropbox_".$rij['db_name']."'>
          <img src='../img/anim-loader.gif' height='20' /></span></a>"; */
        //$data[]=dropbox_size($rij['directory']);		
        list($filecount, $filesize) = dropbox_size($rij['directory']);
        $data[] = "<a class='campus_tooltip' href='#' >
					" . $filecount . " " . get_lang('txtFiles') . " - " . round((($filesize / 1024) / 1024), 1) . " Mb
					</a>";
        /*    $data[] = "<a class='campus_tooltip' href='#' onmouseover=\"xajax_dropbox_files('" . $rij['directory'] . "');\">
          " . $filecount . " " . get_lang('txtFiles') . " - " . round((($filesize / 1024) / 1024), 1) . " Mb
          <span id='files_" . $rij['directory'] . "'>
          <img src='../img/anim-loader.gif' height='20' /></span></a>"; */
        if (($dbfilesize > 0) && ($filesize > 0))
        {
            $data[] = '<a href="' . $this->get_campus_admin_url(). '&page=managedropboxes&deletedropbox=' . $rij['code'] . '#' . $rij['code'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmCleanDropbox") . '\')) return false;">DELETE</a>';
        }
        else
        {
            $data[] = " - ";
        }
        $total_size+=$filesize;
        $total_files+=$filecount;
        campus::display_table_row($bgcolor, $data, true);
    }
    campus::display_table_footer();
    echo $courses . ' ' . get_lang('txtCourses') . '     ' . $total_files . ' ' . get_lang('txtFiles') . '    ' . round((($total_size / 1024) / 1024), 1) . 'Mb';
    echo '</div>';
}
?>
