<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // delete relations to deleted classes...
    // delete relations to deleted groupes...
    $result = mysql_query("DELETE `campus_department_rel_group` FROM `campus_department_rel_group`
				LEFT JOIN `group_group`
					ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
				WHERE  `type`=3 AND `group_group`.`name` is NULL");

    $result = "";

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    $formSent = intval(campus::get_POST_GET("formSent"));
    $message = '';

    if ($_POST['formSent'])
    {
        $Group2Sub = intval(campus::get_POST_GET("Group2Sub"));


        $result = mysql_query('DELETE FROM `campus_department_rel_group` WHERE `department_id`=' . $department_id.' AND `type`=3');
        // formsent=1: subscribe classes selected in array $Group2Sub to current department
        if (($formSent == 1) && ($Group2Sub > 0))
        {
            $query = 'INSERT INTO `campus_department_rel_group` SET department_id=' . $department_id . ',group_id=' . $Group2Sub . ',type=3';
            $result = mysql_query($query) or die(mysql_error());
            }
    }


    $result = mysql_query('SELECT `id`,`name`,`code` FROM `campus_department_rel_group`
				INNER JOIN `group_group`
					ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=3
				WHERE `campus_department_rel_group`.`department_id` = ' . $department_id . '
        				 LIMIT 1');
    list ($groupid, $groupname, $groupcode) = mysql_fetch_row($result);
    $Group2Sub = intval($groupid);
    $query = "SELECT `id`,`name`,`code` FROM `group_group` WHERE NOT `id`=" . $Group2Sub . " ORDER BY name LIMIT 0,1000";
    $result = mysql_query($query);
    $db_subscribeclasses = api_store_result($result);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    echo '<form name="myform" method="post" action="' .$this->get_campus_admin_url()  . '" style="margin:0px;">';
    echo '<input type="hidden" name="formSent" value="1">';
    echo '<input type="hidden" name="page" value="parentclass2department" >';
    echo '	<table border="0" cellpadding="5" cellspacing="0" width="100%">
			<tr>
				<td width="40%" align="center"><b>' . get_lang('txtAvailableClasses') . '</b><br><br>
						</td>
				<td width="40%" align="center"><b>' . get_lang('txtParentClass') . '</b><br><br><br>
				</td>
			</tr>
			<tr>
				<td width="40%" align="center">
					<select name="Group2Sub" size="10" OnChange="javascript:myform.submit();">
					<option value="" ' . (($Group2Sub == 0 ) ? 'selected' : '') . ' >' . get_lang('txtNoParentClass') . '</option>';

    foreach ($db_subscribeclasses as $enreg)
    {
        echo '<option value="' . $enreg['id'] . '" ' . (((!$formSent && in_array($enreg['id'], $subscribeclasses)) || ($formSent && in_array($enreg['id'], $Group2Sub))) ? 'selected' : '') . ' title="'.$enreg['code'].'">' . $enreg['name'] . '</option>';
    }
    unset($db_subscribeclasses);
    echo '			</select>
				</td>
				<td width="40%" align="center">
					<input value="' . $groupname . '" readonly title="'.$groupcode.'">
				</td>
			</tr>
		</table>
		<input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.myform.page.value=\'\';">
		</form>';
}

function api_store_result($result)
{
    $tab = array();
    while ($row = mysql_fetch_array($result))
    {
        $tab[] = $row;
    }
    return $tab;
}

?>