<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

$allowed = ((isset($admin['roster']) && $admin['roster']) || $is_platformadmin);

//check if user is allowed here...
if ((intval($_uid) == 0) || ! ($allowed))
{ // not allowed here!
    Echo "NOT ALLOWED!!!"; //get_lang("msgNoRights4ThisDepartment");
}
else
{ //only rosteradmins and platform administrator are allowed here...

    $schedule_id = intval(campus::get_POST_GET("schedule_id"));
    if ($schedule_id > 0)
    {
        $roster_id = campus::get_schedule2roster($schedule_id);
        $curriculum_id = campus::get_roster2curriculum($roster_id);

        // ===============================================================
        // generate Assignment list details........
        // ===============================================================
        // TEACHER ARRAY...
        $sql = "SELECT `assignment_id`, `user_id`, `official_code`, `lastname`, `firstname`
					FROM `campus_assignment_rel_teacher`
						INNER JOIN `user_user`
							ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
						INNER JOIN `campus_assignment`
							ON `campus_assignment`.`id` = `campus_assignment_rel_teacher`.`assignment_id`
						WHERE `campus_assignment_rel_teacher`.`roster_id`=" . $roster_id . " ORDER BY `lastname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teacher_array[$rij['assignment_id']][$rij['user_id']]['official_code'] = $rij['official_code'];
        }
        // GROUP ARRAY...
        $sql = "SELECT  `assignment_id`, `group_id`, `code`, `name`
					FROM `campus_assignment_rel_group`
						INNER JOIN `group_group`
							ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
						INNER JOIN `campus_assignment`
							ON `campus_assignment`.`id` = `campus_assignment_rel_group`.`assignment_id`
						WHERE `campus_assignment`.`curriculum_id`=" . $curriculum_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $group_array[$rij['assignment_id']][$rij['group_id']]['code'] = $rij['code'];
        }

        // RESOURCE ARRAY...
        $sql = "SELECT `college_id`,`resource_id`, `code`, `comment`
					FROM `campus_college_rel_resource`
						INNER JOIN `campus_resource`
							ON `campus_resource`.`id` = `campus_college_rel_resource`.`resource_id`
						INNER JOIN `campus_college`
							ON `campus_college`.`id` = `campus_college_rel_resource`.`college_id`
						WHERE `roster_id`=" . $roster_id . " ORDER BY `code`";
        $result = mysql_query($sql) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $resource_array[$rij['college_id']][$rij['resource_id']]['code'] = $rij['code'];
        }

        $query = "SELECT `campus_assignment`.`id` as assignment_id, `roster_id`, `campus_period`.`code` as period,`campus_discipline`.`code` as discipline_code, `campus_discipline`.`name` as tooltip, `weekday`, `duration`, `campus_college`.`id` as `college_id`
						FROM `campus_assignment`
							LEFT JOIN `campus_discipline`
                                                                ON `campus_discipline`.`id`= `campus_assignment`.`discipline_id`
                                                        INNER JOIN `campus_roster`
								ON `campus_roster`.`curriculum_id`= `campus_assignment`.`curriculum_id`
							LEFT JOIN `campus_college`
								ON `campus_assignment`.`id`=`campus_college`.`assignment_id` AND `campus_college`.`roster_id` = `campus_roster`.`id`
							LEFT JOIN `campus_period`
								ON `campus_period`.`id` = `campus_college`.`period_id`
						WHERE `campus_roster`.`id`=" .
            $roster_id . " ORDER BY  `campus_discipline`.`display_order`,`assignment_id`";
        $result = mysql_query($query);

        $data = "leerkracht;klas;vak;lesuur;duur;lokalen\n";
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teacher = "";
            foreach ($teacher_array[$rij['assignment_id']] as $teacher_id => $value)
            {
                $teacher .= " " . $value['official_code'];
            }
            $group = "";
            foreach ($group_array[$rij['assignment_id']] as $class_id => $value)
            {
                $group .= " " . $value['code'];
            }

            $resource = "";
            foreach ($resource_array[$rij['college_id']] as $resource_id => $value)
            {
                $resource .= " " . $value['code'];
            }

            $data .= trim($teacher) . ";" . trim($group) . ";" . $rij['discipline_code'] . ";" . $rij['period'] . ";" .
                $rij['duration'] . ";" .
                trim($resource) . "\n";
        }

        /*
    -----------------------------------------------------------
        Header
    -----------------------------------------------------------
    */
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=rooster_export.csv");
        header('Content-transfer-encoding: binary');
        header("Pragma: no-cache");
        header("Expires: 0");
        // de rijen opsturen.
        print $data;
    }
}
?>
