<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  MAIN CODE
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (!(isset($admin['student']) && $admin['student']) && !(isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $user_id = intval(campus::get_POST_GET("user_id"));


    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */
    if (($action == "addstudent") && ($user_id != 0))
    {
        $query = "SELECT `content` FROM `campus_student_tracking` WHERE `department_code`='' AND `tracking_title`='' AND `student_id`=" . $user_id;
        $result = mysql_query($query);
        list($student) = mysql_fetch_row($result);
        $studentinfo = explode(";", $student);
        $password = Text::generate_password(6);
        $sql = 'INSERT `user_user` SET
					`id`=' . $user_id . ',
					`lastname`="' . $studentinfo[0] . '",
					`firstname`="' . $studentinfo[1] . '",
					`email`="' . $studentinfo[6] . '",
					`phone`="' . $studentinfo[5] . '",
					`username`="' . $studentinfo[2] . '",
					`password`="' . $password . '", `active`=0';
        $result = mysql_query($sql);
        if (!$result)
        {
            $message = get_lang("txtUserInsertError");
        }
        else
        {
            $result = mysql_query('DELETE FROM `campus_user` WHERE `user_id`=' . $user_id);
            $sql = 'INSERT `campus_user` SET
					`user_id`=' . $user_id . ',
					`birth`="' . $studentinfo[3] . '",
					`address`="' . $studentinfo[4] . '",
					`initialpassword`="' . $password . '" ';
            $result = mysql_query($sql) or die(mysql_error());

            $message = get_lang("txtUserInsertOK");
        }
    }
        /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    
    // create a list of studentclasses off the department
    // Query van het gegevensbestand....
    $query = "SELECT *	FROM `campus_student_tracking`
					LEFT JOIN `group_group_rel_user`
						ON `student_id`=`user_id`
                WHERE `department_code`='' AND `tracking_title`='' AND `group_group_rel_user`.`group_id` is NULL
 	            ORDER BY `content`";
    $result = mysql_query($query);
    campus::display_complex_table_header($properties, array(get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadBirth"), get_lang("colheadUsername"), get_lang("colheadState"), ""));
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $query2 = "SELECT `active` FROM `user_user` WHERE `id`=" . $rij['student_id'];
        $result2 = mysql_query($query2);
        $state = get_lang("txtNotPresent");
        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
        {
            $state = ($rij2['active'] ? '<img src="' . Theme::get_image_path('application\campus') . 'right.gif" border=0 align="absmiddle">' : '<img src="' . Theme::get_image_path('application\campus') . 'wrong.gif" border=0 align="absmiddle">');
        }
        $studentinfo = explode(";", $rij['content']);
        $data = array();
        $data[] = '<a name="' . $rij['student_id'] . '"></a>' . $studentinfo[0];
        $data[] = $studentinfo[1];
        $data[] = $studentinfo[3];
        $data[] = $studentinfo[2];
        $data[] = $state;
        $data[] = "&nbsp;" . (((isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $is_platformadmin) ? '<a href="' . $this->get_studenttracking_url() . '&student_id=' . $rij['student_id'] . '&class_id=0" title="' . get_lang("tooltipStudentTracking") . "\"><img src=\"" . Theme::get_image_path('application\campus') . '/studenttracking.gif" border=0 align="absmiddle" /></a>' : '') .
                (($state == get_lang("txtNotPresent") && ((isset($admin['student']) && $admin['student']) || $is_platformadmin)) ? '&nbsp;<a href="' . $this->get_url() . '&page=studentarchive&user_id=' . $rij['student_id'] . '&action=addstudent#' . $rij['student_id'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmAddStudent2Dokeos") . '\')) return false;"  title="' . get_lang("tooltipAddStudent2Dokeos") . '"><img src="' . Theme::get_image_path('application\campus') . 'add_user.gif" border=0 align="absmiddle" /></a>' : '');
        campus::display_table_row($bgcolor, $data, true);
    }
    campus::display_table_footer();
}
?>