<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // delete relations to deleted groups...
    $result = mysql_query("DELETE `campus_department_rel_group` FROM `campus_department_rel_group`
				LEFT JOIN `group_group`
					ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
				WHERE `type`=1 AND `group_group`.`name` is NULL");

    $result = "";
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    $formSent = intval(campus::get_POST_GET("formSent"));
    $message = '';

    if ($_POST['formSent'])
    {
        $group2Sub = campus::get_POST_GET("group2Sub");
        $group2Unsub = campus::get_POST_GET("group2Unsub");
        $filtergroup = campus::get_POST_GET("filtergroup");

        if (!is_array($group2Sub))
        {
            $group2Sub = array();
        }

        if (!is_array($group2Unsub))
        {
            $group2Unsub = array();
        }
        // formsent=1: subscribe group selected in array $group2Sub to current department
        if ($formSent == 1)
        {
            if (!sizeof($group2Sub))
                $message = get_lang("msgAtLeastOneGroup2Subscribe");
            else
            {
                $query1 = "INSERT IGNORE INTO `campus_department_rel_group`(department_id,group_id,type) VALUES";

                foreach ($group2Sub as $enreg_group)
                {
                    $query1.="('" . $department_id . "','" . $enreg_group . "',1),";
                }

                $query1 = substr($query1, 0, -1);

                mysql_query($query1);
            }
        }

        // formsent=2: unsubscribe group selected in array $group2Unsub of current course
        if ($formSent == 2)
        {
            if (!sizeof($group2Unsub))
                $message = get_lang("msgAtLeastOneGroup2Unsubscribe");
            else
            {
                $query1 = "DELETE FROM `campus_department_rel_group` WHERE";

                foreach ($group2Unsub as $enreg_group)
                {
                    $query1.=" (department_id='" . $department_id . "' AND group_id=$enreg_group) OR";
                }

                $query1 = substr($query1, 0, -3);
                mysql_query($query1);
            }
        }

        if (sizeof($group2Sub))
        {
            $subscribegroup = $group2Sub;
        }

        if (sizeof($group2Unsub))
        {
            $unsububscribegroup = $group2Unsub;
        }
    }

    if (empty($subscribegroup))
    {
        $subscribegroup = array();
    }
    elseif (!is_array($subscribegroup))
    {
        $subscribegroup = explode(',', $subscribegroup);

        foreach ($subscribegroup as $key => $enreg)
        {
            $subscribegroup[$key] = intval($enreg);
        }
    }
    else
    {
        foreach ($subscribegroup as $key => $enreg)
        {
            $subscribegroup[$key] = intval($enreg);
        }
    }
    if (empty($unsubscribegroup))
    {
        $unsubscribegroup = array();
    }
    elseif (!is_array($unsubscribegroup))
    {
        $unsubscribegroup = explode(',', $unsubscribegroup);

        foreach ($unsubscribegroup as $key => $enreg)
        {
            $unsubscribegroup[$key] = intval($enreg);
        }
    }
    else
    {
        foreach ($unsubscribegroup as $key => $enreg)
        {
            $unsubscribegroup[$key] = intval($enreg);
        }
    }

    $result = mysql_query('SELECT DISTINCT `id`,`group_group`.`name` FROM `campus_department_rel_group`
				INNER JOIN `group_group`
                                	ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=1
				WHERE `campus_department_rel_group`.`department_id` = ' . $department_id . '
 					ORDER BY ' . (sizeof($subscribegroup) ? '(id IN("' . implode(',', $subscribegroup) . '")) DESC,' : '') . ' name LIMIT 0,1000');

    $db_unsubscribegroup = api_store_result($result);
    $selectedgroup = '0';
    foreach ($db_unsubscribegroup as $enreg)
    {
        $selectedgroup.=',' . $enreg['id'];
    }
    $query = 'SELECT DISTINCT `id`,`group_group`.`name` FROM `group_group`
						LEFT JOIN `campus_department_rel_group`
							ON `group_group`.`id` =  `campus_department_rel_group`.`group_id` AND (`type`=1 OR `type`=2)
						WHERE `name` LIKE "%' . $filtergroup . '%" AND `id` NOT IN('.$selectedgroup.')
 												ORDER BY ' . (sizeof($unsubscribegroup) ? '(id IN(' . implode(',', $unsubscribegroup) . ')) DESC,' : '') . ' name LIMIT 0,1000';
    $result = mysql_query($query);

    $db_subscribegroup = api_store_result($result);
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    echo '<form name="formulaire" method="post" action="' . $this->get_campus_admin_url() . '" style="margin:0px;">';
    echo '<input type="hidden" name="page" value="teacherclass2department" >';
    echo '<input type="hidden" name="formSent" value="1">';
    echo '<table border="0" cellpadding="5" cellspacing="0" width="100%">
			<tr>
				<td width="40%" align="center"><b>' . get_lang('txtAvailableGroups') . '</b><br><br>
					' . get_lang('Filtergroup') . ' :
					<select name="filtergroup" onchange="javascript:document.formulaire.formSent.value=\'3\'; document.formulaire.submit();">
					<option value="">--</option>';
    foreach ($departmentStruc as $key => $array)
    {
        echo '<option value="' . $array['code'] . '"';
        if ($filtergroup == $array['code'])
        {
            echo ' selected="selected"';
        }
        echo '>' . $array['code'] . '</option>';
    
    }
    echo '				</select>
				</td>
				<td width="20%">&nbsp;</td>
				<td width="40%" align="center">
					<b>' . get_lang("txtSelectedTeacherGroups") . '</b><br><br><br>
				</td>
			</tr>
			<tr>
				<td width="40%" align="center">
					<select name="group2Sub[]" multiple="multiple" size="20" style="width:230px;">';
    foreach ($db_subscribegroup as $enreg)
    {
        echo '<option value="' . $enreg['id'] . '" ' . (((!$formSent && in_array($enreg['id'], $subscribegroup)) || ($formSent && in_array($enreg['id'], $group2Sub))) ? 'selected' : '') . '>' . $enreg['name'] . '</option>';
    }
    unset($db_subscribegroup);
    echo '		</select>
				</td>
				<td width="20%" valign="middle" align="center">
					<input type="submit" onmousedown="javascript:document.formulaire.formSent.value=\'1\';" value="' . get_lang('buttonlabelAdd2Department') . '"><BR><BR>
					<input type="submit" onmousedown="javascript:document.formulaire.formSent.value=\'2\';" value="' . get_lang('buttonlabelRemoveFromDepartment') . '">
				</td>
				<td width="40%" align="center">
					<select name="group2Unsub[]" multiple="multiple" size="20" style="width:230px;">';
    foreach ($db_unsubscribegroup as $enreg)
    {
        echo '			<option value="' . $enreg['id'] . '" ' . ((($formSent && in_array($enreg['id'], $unsubscribegroup)) || ($formSent && in_array($enreg['id'], $group2Unsub))) ? 'selected' : '') . '>' . $enreg['name'] . '</option>';
    }
    unset($db_unsubscribegroup);
    echo '			</select>
				</td>
			</tr>
		</table>
		<input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.formulaire.page.value=\'\';">
	 </form>';
}

function api_store_result($result)
{
    $tab = array();
    while ($row = mysql_fetch_array($result))
    {
        $tab[] = $row;
    }
    return $tab;
}

/**
 * Print an <option>-list with all letters (A-Z).
 * @param char $selected_letter The letter that should be selected
 */
function get_alphabet_options($selected_letter = '')
{
    $result = '';
    for ($i = 65; $i <= 90; $i++)
    {
        $letter = chr($i);
        $result .= '<option value="' . $letter . '"';
        if ($selected_letter == $letter)
        {
            $result .= ' selected="selected"';
        }
        $result .= '>' . $letter . '</option>';
    }
    return $result;
}

?>