<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\Theme;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::warning_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");

    $platformgroup = array(array('name' => 'VTI', 'class' => 328, 'admin_group' => 36, 'SG_group' => 90),
        array('name' => 'SLI', 'class' => 277, 'admin_group' => 31, 'SG_group' => 91),
        array('name' => 'OLVI', 'class' => 201, 'admin_group' => 31, 'SG_group' => 92),
        array('name' => 'MSJ', 'class' => 138, 'admin_group' => 37, 'SG_group' => 93),
        array('name' => 'SJC', 'class' => 229, 'admin_group' => 47, 'SG_group' => 94),
        array('name' => 'DVTI', 'class' => 3, 'admin_group' => 42, 'SG_group' => 95),
        array('name' => 'OHVM', 'class' => 83, 'admin_group' => 32, 'SG_group' => 97));

    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */
    $message = "";
    switch ($action)
    {
        case "update" :
            {
                foreach ($platformgroup as $school)
                {

                    $result = mysql_query("DELETE FROM `crs_" . $school['name'] . "`.`group_rel_user` WHERE `group_rel_user`.`group_id`= " . $school['admin_group'] . "");
                    $result = mysql_query("DELETE FROM `crs_SG`.`group_rel_user` WHERE `group_rel_user`.`group_id`= " . $school['SG_group'] . "");

                    $query = "SELECT `user`.`user_id`,`lastname`, `firstname`
                            FROM `DOKEOS_main`.`user`
                                INNER JOIN `DOKEOS_main`.`class_user`
                                    ON `user`.`user_id` = `class_user`.`user_id` AND `class_user`.`class_id`= " . $school['class'] . "
                                ORDER BY `lastname`, `firstname`";
                    $result = mysql_query($query) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $result2 = mysql_query('SELECT * FROM `DOKEOS_main`.`course_rel_user` WHERE `course_code`= "' . $school['name'] . '",`user_id`= ' . $rij['user_id']);
                        if (mysql_num_rows($result2) == 0)
                        {
                            $result2 = mysql_query('INSERT `DOKEOS_main`.`course_rel_user` SET `course_code`= "' . $school['name'] . '",`user_id`= ' . $rij['user_id'] . ',`status`=5, `group_id`=0, `tutor_id`=0');
                        }
                        $result2 = mysql_query("SELECT * FROM `DOKEOS_main`.`course_rel_user` WHERE `course_code`= " . $school['name'] . ",`user_id`= " . $rij['user_id'] . "");
                        if (mysql_num_rows($result2) == 0)
                        {
                            $result2 = mysql_query('INSERT `DOKEOS_main`.`course_rel_user` SET `course_code`= "SG",`user_id`= ' . $rij['user_id'] . ',`status`=5, `group_id`=0, `tutor_id`=0');
                        }
                        $result2 = mysql_query("INSERT `crs_" . $school['name'] . "`.`group_rel_user` SET `group_id`= " . $school['admin_group'] . ",`user_id`= " . $rij['user_id'] . "");
                        $result2 = mysql_query("INSERT `crs_SG`.`group_rel_user` SET `group_id`= " . $school['SG_group'] . ",`user_id`= " . $rij['user_id'] . "");
                    }
                }
                $display = "list";
            }

        case "delete":
        {
            $user_id = intval(campus::get_POST_GET("user_id"));
            $course = campus::get_POST_GET("course");
            $course_code_ok=FALSE;
            foreach ($platformgroup as $school)
            {
                if (in_array($course,$school))
                    $course_code_ok=TRUE;
            }

            if (($course_code_ok) and ($user_id>0))
            {
                $result = mysql_query('DELETE FROM `crs_' . $course . '`.`group_rel_user` WHERE `group_rel_user`.`user_id`= ' . $user_id . '');
                $result = mysql_query('DELETE FROM `crs_SG`.`group_rel_user` WHERE `group_rel_user`.`user_id`= ' . $user_id . '');
                $result = mysql_query('DELETE FROM `DOKEOS_main`.`course_rel_user` WHERE `course_rel_user`.`user_id`= ' . $user_id . ' AND (`course_code`= "SG" OR `course_code`="'.$course.'")');


            }


        }
        default :
            {
                $display = "list";
            }
            break;
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    if ($display == "list")
    {
        // create a list of studentclasses off the department
        campus::get_teacherclasses($department_id);
        // De klaslijst tonen.....

        foreach ($platformgroup as $school)
        {
            echo "<b style=\"font-size: 24px;\">" . $school['name'] . "</b>";
            // Query van het gegevensbestand....
            $query = 'SELECT t1.`user_id`, `lastname`, `firstname`, `official_code`, admin_course.`course_code` as course1,admin_group.`group_id` as group1,SG_course.`course_code` as course2, SG_group.`group_id` as group2, t3.`name`, t2.`class_id`
                            FROM `DOKEOS_main`.`user` t1
                                LEFT JOIN (`DOKEOS_main`.`class_user` t2,`DOKEOS_main`.`class` t3)
                                    ON (t2.`class_id`=t3.`id` AND  t1.`user_id` = t2.`user_id` AND (t2.`class_id`= ' . $school['class'] . ' OR t2.`class_id`=380 OR t2.`class_id`=381))
                                LEFT JOIN `DOKEOS_main`.`course_rel_user` as admin_course
                                    ON t1.`user_id` = admin_course.`user_id` AND admin_course.`course_code`= "' . $school['name'] . '"
                                LEFT JOIN `crs_' . $school['name'] . '`.`group_rel_user` as admin_group
                                    ON t1.`user_id` = admin_group.`user_id` AND admin_group.`group_id`= ' . $school['admin_group'] . '
                               LEFT JOIN `DOKEOS_main`.`course_rel_user` as SG_course
                                    ON t1.`user_id` = SG_course.`user_id` AND SG_course.`course_code`= "SG"
                                LEFT JOIN `crs_SG`.`group_rel_user` as SG_group
                                    ON t1.`user_id` = SG_group.`user_id` AND SG_group.`group_id`= ' . $school['SG_group'] . '
                              WHERE  t2.`class_id` is not null  OR admin_course.`course_code` is not null
                                ORDER BY t3.`name`, `lastname`, `firstname`';//OR SG_course.`course_code` is not null
            //


/*$query = 'SELECT `lastname`, `firstname`, `official_code`, `course_code`,admin_group.`group_id`,SG_course.`course_code`, SG_group.`group_id`
                            FROM `DOKEOS_main`.`user`
                                INNER JOIN `DOKEOS_main`.`course_rel_user`
                                    ON `user`.`user_id` = `course_rel_user`.`user_id` AND (`course_rel_user`.`course_code`= "SG" OR `course_rel_user`.`course_code`= "' . $school['name'] . '")
                                LEFT JOIN `DOKEOS_main`.`class_user`
                                    ON `user`.`user_id` = `class_user`.`user_id` AND `class_user`.`class_id`= ' . $school['class'] . '
                                LEFT JOIN `crs_' . $school['name'] . '`.`group_rel_user` as admin_group
                                    ON `user`.`user_id` = admin_group.`user_id` AND admin_group.`group_id`= ' . $school['admin_group'] . '
                                LEFT JOIN `crs_SG`.`group_rel_user` as SG_group
                                    ON `user`.`user_id` = SG_group.`user_id` AND SG_group.`group_id`= ' . $school['SG_group'] . '
                                ORDER BY `lastname`, `firstname`';
*/

            $result = mysql_query($query) or die(mysql_error());
            echo "<div style='width:100%;
                        '></div><br clear=\"all\">";
            campus::display_complex_table_header($properties, array(get_lang("colheadId"), get_lang("colheadName"), get_lang("colheadFirstName"),get_lang("colheadUsername"), "", "","","",get_lang("colheadGroup"),""));
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $data=array();
                $data[]=$rij['user_id'];
                $data[]=$rij['lastname'];
                $data[]=$rij['firstname'];
                $data[]=$rij['official_code'];
                $data[]=$rij['course1'];
                $data[]=$rij['group1'];
                $data[]=$rij['course2'];
                $data[]=$rij['group2'];
                $data[]=$rij['name'];
                $data[]='<a href="' . $this->get_campus_admin_url() . '&page=teacherclassupdategroups&action=delete&user_id=' . $rij['user_id']. '&course='.$rij['course1'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDelete") . '\')) return false;" ><img src="' . Theme::get_image_path('application\campus') . '/delete.gif" border=0 align="absmiddle"></a>';

                campus::display_table_row($bgcolor, $data, true);
            }
            campus::display_table_footer();
        }
        echo ' <a href="' . $this->get_url() . '&page=teacherclassupdategroups&action=update" >update groups</a>';
    }
}
?>
