<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $department_id = intval(campus::get_SESSION("department_id"));
    $department_code = $departmentStruc[$department_id]['code'];
    $assignment_code = campus::get_POST_GET("assignment_code");
    $selectAcYear = campus::get_POST_GET("selectAcYear");
    $teacher_code = campus::get_POST_GET("teacher_code"); //$this->get_user()->get_official_code();
    $group_code = campus::get_POST_GET("group_code"); //$this->get_user()->get_official_code();
    if (($assignment_code != '')||($teacher_code!='')||($group_code!=''))
    {
        $departmentStruc = campus::get_department_info($department_code);
        if (!empty($departmentStruc))
        {
            $assignment = explode(",", $assignment_code);
            if ($teacher_code != '')
            {

                $result = mysql_query(
                    'SELECT `lastname`,`firstname`,`official_code` FROM `user_user` WHERE `official_code`="' .
                    $teacher_code . '"'
                );
                $user = mysql_fetch_array($result, MYSQL_ASSOC);
                $document_title=$user['firstname'] . " " . $user['lastname'];
                $selection=' AND `assignment_code`="' . $assignment_code . '" AND `teacher_code`="' . $teacher_code . '" ';
                $document_subtitle=($grouplist == '') ? $assignment[1] : $grouplist;
            }
            elseif ($assignment_code!='')
            {

                $selection=' AND `assignment_code`="' . $assignment_code . '" ';
                $query = 'SELECT `discipline`,`grouplist` FROM `campus_agenda_archive`
						WHERE `academic_year`= "' . $selectAcYear . '" AND `department_code` = "' . $department_code .'"
                         ' . $selection . '
						LIMIT 1';
                $result = mysql_query($query) or die (mysql_error());
                list($discipline, $group_list)= mysql_fetch_row($result);

                $document_title=$discipline;
                $document_subtitle=($grouplist == '') ? $assignment[1] : $grouplist;
            }
            elseif ($group_code!='')
            {
                $selection=' AND (`grouplist` like  "%' . trim($group_code) . '%" OR  `assignment_code` like  "%' . trim($group_code) . '%")';
                $document_title=$group_code;
            }

            // de gegevens van de agenda gesorteerd per week in een array inlezen.
            $query = 'SELECT `date`,`period_code`,`content`,`tasks`,`comment`,`grouplist`,`studentlist`,`discipline` FROM `campus_agenda_archive`
						WHERE `academic_year`= "' . $selectAcYear . '" AND `department_code` = "' . $department_code . '"
						' . $selection . '
						ORDER BY `date`,`period_code`';
            $result = mysql_query($query) or die(mysql_error());
            $data = "Datum;Lesuur;Inhoud;Taken/Lessen;Opmerking;Klas(sen);Leerling(en)\n";
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $data.='"' . DatetimeUtilities::format_locale_date("%A %d %B %Y", $rij['date']) . '";"' . $rij['period_code'] . '";"' . $rij['content'] . '";"' . $rij['tasks'] . '";"' . $rij['comment'] . '";"' . $rij['grouplist'] . '";"' . $rij['studentlist'] . '"' . "\n";
            }
            /*
              -----------------------------------------------------------
              Header
              -----------------------------------------------------------
             */
            header("Content-type: application/vnd.ms-excel; charset=UTF-8");
            header("Content-Disposition: attachment; filename=" . "AGENDA_" . $selectAcYear . "_" . ereg_replace(" ", "_", $document_title) . ".csv");
            header("Pragma: no-cache");
            header("Expires: 0");
            // de rijen opsturen.
            print $data;
        }
    }
}
?>