<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $agendaselect = intval(campus::get_POST_GET("agendaselect"));

    $result = mysql_query("SELECT `lastname`,`firstname` FROM `user_user` WHERE `id`=" . $_uid);
    $user = mysql_fetch_array($result, MYSQL_ASSOC);
    $discipline_info = campus::get_assignment2discipline($agendaselect);
    $groups = campus::get_assignment2group($agendaselect);
    foreach ($groups as $group_id => $groupinfo)
    {
        $groupnames.=$groupinfo['code'] . " ";
    }
    // Pagina instellingen
    $data = "Datum;Lesuur;Inhoud;Taken/Lessen;Opmerking;Klas(sen);Leerling(en)\n";
    $query = "SELECT DISTINCT `date`,`campus_period`.`code`, `content` , `tasks`, `comment`, `discipline_id`, `campus_agenda`.`id` as agenda_id
	          	FROM `campus_agenda`
                            LEFT JOIN `campus_assignment` ON `campus_assignment`.`id`=`campus_agenda`.`assignment_id`
                            INNER JOIN `campus_assignment_rel_teacher` ON `campus_agenda`.`assignment_id`=`campus_assignment_rel_teacher`.`assignment_id`
                            INNER JOIN `campus_period` ON `campus_period`.`id`=`campus_agenda`.`period_id`
      	           	WHERE  `campus_assignment_rel_teacher`.`user_id`=" . $_uid . " AND `campus_agenda`.`assignment_id`=" . $agendaselect . " order by `date`, `display_order`";

    $result = mysql_query($query);
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $groupcombi = "";
        $rij['students'] = "";
        $groups = campus::get_agenda2group($rij['agenda_id']);
        $students = campus::get_agenda2student($rij['agenda_id']);
        $discipline = campus::get_discipline_info($rij['discipline_id']);
        $rij['discipline_id'] = $discipline[$rij['discipline_id']]['name'];
        foreach ($groups as $group_id => $groupinfo)
        {
            $groupcombi.=$groupinfo['code'] . " ";
        }
        $rij['groups'] = ($groupcombi == '') ? "" : "(" . substr($groupcombi, 0, -1) . ")";
        foreach ($students as $student_id => $studentinfo)
        {
            $rij['students'].=$studentinfo['firstname'] . " " . $studentinfo['lastname'] . "\n ";
        }
        $rij['students'] = substr($rij['students'], 0, -2);
        $data.='"' . DatetimeUtilities::format_locale_date("%A %d %B %Y", $rij['date']) . '";"' . $rij['code'] . '";"' . $rij['content'] . '";"' . $rij['tasks'] . '";"' . $rij['comment'] . '";"' . $rij['groups'] . '";"' . $rij['students'] . '"' . "\n";
    }
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header("Content-type: application/octet-stream");
    header("Content-Disposition: attachment; filename=" . "AGENDA_" . $discipline_info[$discipline_id]['code'] . "_" . $agendaclass . ".csv");
    header('Content-transfer-encoding: binary');
    header("Pragma: no-cache");
    header("Expires: 0");
// de rijen opsturen.
    print $data;
}
?>