<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $submitmessage = campus::get_POST_GET("submitmessage");
    $message_id = intval(campus::get_POST_GET("message_id"));
    $title = campus::get_POST_GET("title");
    $from = campus::get_POST_GET("from");
    $to = campus::get_POST_GET("to");
    $content = campus::get_POST_GET("content");
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    {
        if ($to != "")
        {

            $teachers = explode(",", trim($to));
            $query = "SELECT `id`, `official_code` FROM `user_user` WHERE (";
            foreach ($teachers as $officialcode)
            {
                $query.="`official_code`='" . $officialcode . "' OR ";
            }
            $query = substr($query, 0, -3) . ") ORDER BY `official_code`";
            $result = mysql_query($query);
            $aantal = mysql_num_rows($result);
            if ($aantal > 0)
            {
                while (list($user_id, $official_code) = mysql_fetch_row($result))
                {
                    $list_to['user'][$user_id] = $official_code;
                }
                $content = "";
                $display = "form";
            }
            else
            {
                Display::error_message(get_lang("msgMsgAddError"));
                $display = "";
            }
        }
        else
        {
            Display::error_message(get_lang("msgMsgAddError"));
            $display = "";
        }
    }
    else
    {
        if ($content == "")
        {
            Display::error_message(get_lang("msgMsgAddError"));
            $display = "";
        }
        else
        {
            $query = 'INSERT `campus_messageboard` SET
				`title`="' . $title . '",
				`date`=' . time() . ',
				`user_id`=' . $from . ',
				`content`="' . $content . '"';
            $result = mysql_query($query);
            if (!$result)
            {
                Display::error_message(get_lang("msgMsgAddError"));
                $display = "";
            }
            else
            {
                $message_id = mysql_insert_id();
                campus::set_message_to($to, $message_id);
                Display::normal_message(get_lang("msgMsgAddSucces"));
                $display = "";
            }
        }
    }
    /*
      ==============================================================================
      DISPLAY
      ==============================================================================
     */
    /*
      -----------------------------------------------------------
      Infoboard ....
      -----------------------------------------------------------
     */
    if ($display == 'form')
    {
        // ===============================================================
// Het bericht formulier weergeven.........
// ===============================================================
        echo '<script language="JavaScript" xml:space="preserve">
	<!-- 
	 function updateLeftChars()
	  {
	   max_len = 412
	   msg_text = document.myform.content.value
	   msg_len = msg_text.length
	   if (msg_len > max_len)
	    {
	     document.myform.content.value = msg_text.substring(0, max_len)
	     document.myform.counter.value = 0
	    }
	   else
	    document.myform.counter.value = (max_len - msg_len)
	  }
	-->
	</script>';
        echo '<form method="post" action="' . $this->get_url() . '" name="myform">
	    <input type="hidden" name="department_id" value="' . $department_id . '" >
	    <input type="hidden" name="page" value="directmessage" >
        <input type="hidden" name="message_id" value="' . $message_id . '" >
    	<input type="hidden" name="from" value="' . $_uid . '" >
	<input type="hidden" name="nameTools" value="' . $nameTools . '" >
		<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelDate") . '
				</td>
				<td>
					<input type="text" name="date" size="12" value="' .  DatetimeUtilities::format_locale_date('%Y-%m-%d',time()) . '" readonly/>
					<br />
				</td>
				<td>
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelTo") . '
				</td>
				<td>' . $to;
        $selected = array();
        foreach ($list_to['user'] as $id => $value)
        {
            $selected[] = 'u' . $id;
            echo '				<input  type="hidden" name="to[]" value="u' . $id . '" />';
        }

        echo '
				</td>
				<td>
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
	   			' . get_lang("labelSubject") . '
				</td>
				<td colspan="2">
					<input type="text" name="title" size="32" maxlength="32" value="' . $title . '" readonly />
					<br />
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					<br>' . get_lang("labelContent") . '<br><br><br>
					<br>' . get_lang("labelCharsLeft") . '<br>(<input readonly name="counter" size="1" style="border:none">)<br />
				</td>
				<td  colspan="2">
					<textarea name="content" onBlur="updateLeftChars()" onChange="updateLeftChars()" onFocus="updateLeftChars()" onKeyUp="updateLeftChars()" rows="7" cols="60">' . $content . '</textarea>
			 	</td>
				<td >
				</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td colspan="2">
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelOK") . '" >&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" >
				</td>
			</tr>
		</table>
	</form>';
    }
}
?>