<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($admin)) && !($is_platformadmin))
{// not allowed here!
	Display::display_error_message(get_lang("msgNoDepartmentMember"),false);
}
else
{//only users assigned to a department and platform administrator is allowed here...


/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$attention_id=intval(campus::get_POST_GET("attention_id")); 
	$display_order=intval(campus::get_POST_GET("display_order"));
	$title=ereg_replace("\"","'",campus::get_POST_GET("title"));
	$content=campus::get_POST_GET("content","",FALSE);	
	$next=intval(campus::get_POST_GET("next"));

/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/
	if ($submitmessage=="")
	{
		Switch ($action) 
		{
			case "new" :
			{ 
				$attention_id="";
				$display_order="";
				$title="";
				$cont="";
				$display = "form";
			}
			break;
			case "update" :
			{
 		 		// De gegevens van de aandachtspunt inlezen.
 		 		$query="select * FROM `campus_attentionpoint` WHERE `id`=".$attention_id." LIMIT 1";
				$result = mysql_query($query) ;
				list($attention_id, $display_order, $title, $content, $department_id)= mysql_fetch_row($result);
				$display = "form";
 			}
			break;
			case "show" :
			{
				// de aandachtspunt zichtbaar.....
				$result=mysql_query('UPDATE `campus_attentionpoint` SET `display_order`='.$next.' WHERE `id`='.$attention_id.' LIMIT 1');
				$message = get_lang("msgAttentionVisible")." ".$next;
				$display = "";
			}
			break;
			case "hide" :
			{
				// de aandachtspunt naar archief.
				$result=mysql_query('UPDATE `campus_attentionpoint` SET `display_order`=0 WHERE `id`='.$attention_id.' LIMIT 1');
				$message = get_lang("msgAttentionHidden");
				$display = "";
			}
			break;
			case "delete" :
			{
				// de aandachtspunt verwijderen.....
				$result=mysql_query('DELETE FROM `campus_attentionpoint` WHERE `id`='.$attention_id.' LIMIT 1');
				$message = get_lang("msgAttentionDeleted");
				$display = "";
			}
			break;
			default :
			{
				$message = "ERROR ACTION UNKNOWN !!!";
				$display="";
			}
			break;
		}
	}
	else
	{
		Switch ($action) 
		{
			case "new" :
			{ 
				$query='INSERT `campus_attentionpoint` SET
						`display_order`='.$display_order.',
						`title`="'.addslashes($title).'",
						`content`="'.addslashes($content).'",
						`department_id`='.$department_id;
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgAttentionAddError");
					$display="form";
				}
				else
				{
					$info_id=mysql_insert_id();
					$message = get_lang("msgAttentionAddSucces");
					$display="";
				}
			}
			break;
			case "update" :
			{ 
				$query='UPDATE `campus_attentionpoint` SET
						`display_order`='.$display_order.',
						`title`="'.addslashes($title).'",
						`content`="'.addslashes($content).'",
						`department_id`='.$department_id.'
						WHERE `id`='.$attention_id;
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgAttentionEditError");
					$display="form";
				}
				else
				{
					$message = get_lang("msgAttentionEditSucces");
					$display="";
				}
			}
			break;
			default :
			{
				$message = "ERROR ACTION UNKNOWN !!!";
			}
			break;
		}
	}
/*
============================================================================== 
		DISPLAY
============================================================================== 
*/ 
	if (!empty($message))
	{		
		Display::normal_message($message);
	}
	if ($display=='form')
	{ 

// ===============================================================
// Het info formulier weergeven.........
// ===============================================================
	//echo '<IFRAME style="display:none;" SRC="'.$_configuration['root_web'].'plugin/campus/inc/session_refresh.php"></IFRAME>';
	echo '<form method="post" action="'.$this->get_url().'" name="myform">';
	echo '<input type="hidden" name="attention_id" value="'.$attention_id.'" >';
	echo '<input type="hidden" name="action" value="'.$action.'" >';
	echo '<input type="hidden" name="page" value="editattention" >';
	echo '	<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang("labelOrder").'
				</td>
				<td>
					<input type="text" name="display_order" size="2" value="'.$display_order.'">
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang("labelTitle").'
				</td>
				<td  colspan="2">
 					<input type="text" name="title" size="60" value="'.stripslashes($title).'">
			 	</td>
				<td >
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang("labelContent").'
				</td>
				<td>
					<textarea name="content" rows="7" cols="60" style="font-family: arial;font-size:12px;">'.$content.'</textarea>
			 	</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td>
					<input type="submit" name="submitmessage" value="'.get_lang("buttonlabelOK").'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang("buttonlabelCancel").'" onMouseDown="javascript:document.myform.page.value=\'\';">
				</td>
			</tr>
		</table>
		</form>';
	}
	else
	{
		include('content.php');
	}
}
?>
