<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($admin)) && !($is_platformadmin))
{// not allowed here!
	Display::display_error_message(get_lang("msgNoDepartmentMember"),false);
}
else
{//only users assigned to a department and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$info_id=intval(campus::get_POST_GET("info_id"));
	$date=campus::get_POST_GET("date");
	$studentinfo=campus::get_POST_GET("studentinfo","",FALSE);
	$teacherinfo=campus::get_POST_GET("teacherinfo","",FALSE);	

/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/
	if ($submitmessage=="")
	{
		switch ($action) 
		{
 	 		case "new" :
  			{ 
				$info_id="";
				$date="";
				$studentinfo="";
				$teacherinfo="";
				$display="form";
			}
			break;
			case "update" :
			{
				// De gegevens van de info inlezen.
				$query='select * FROM `campus_info` WHERE `id`='.$info_id.' LIMIT 1';
				$result = mysql_query($query) ;
				list($info_id, $date, $studentinfo, $teacherinfo, $department_id)= mysql_fetch_row($result);
                                $date = DatetimeUtilities::format_locale_date('%Y-%m-%d',$date);
				$display="form";
			}
			break;
			case "delete" :
			{
				// de info verwijderen.....
				$result=mysql_query('DELETE FROM `campus_info` WHERE `id`='.$info_id.' LIMIT 1');
				$message = get_lang("msgInfoDeleted");
				$display="";
			}
			break;
			default :
			{
				$message = "ERROR ACTION UNKNOWN !!!";
				$display="";
			}
			break;
		}
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				//if (strtotime($date)>(time()-86400))
				//{
					$query='INSERT `campus_info` SET
							`date`='.strtotime($date).',
							`studentinfo`="'.addslashes($studentinfo).'",
							`teacherinfo`="'.addslashes($teacherinfo).'",
							`department_id`='.$department_id;
					$result=mysql_query($query);
					if (!$result)
					{
						$message = get_lang("msgInfoAddError");
						$display="form";
					}
					else
					{
						$info_id=mysql_insert_id();
						$message = get_lang("msgInfoAddSucces");
						$display="";
					}
				/*}
				else
				{
					$message = get_lang("msgDateErrors");
					$display="form";
				}*/
			}
			break;
			case "update" :
			{ 
				if (strtotime($date)>(time()-86400))
				{
					$query='UPDATE `campus_info` SET
						`date`='.strtotime($date).',
						`studentinfo`="'.addslashes($studentinfo).'",
						`teacherinfo`="'.addslashes($teacherinfo).'",
						`department_id`='.$department_id.'
						WHERE `id`='.$info_id;
					$result=mysql_query($query);
					if (!$result)
					{
						$message = get_lang("msgInfoEditError");
						$display="form";
					}
					else
					{
						$message =  get_lang("msgInfoEditSucces");
						$display="";
					}
				}
				else
				{
					$message = get_lang("msgDateErrors");
					$display="form";
				}
			}
			break;
			default :
			{
				$message = "ERROR ACTION UNKNOWN !!!";
			}
			break;
		}
	}
/*
============================================================================== 
		DISPLAY
============================================================================== 
*/ 
	if (!empty($message))
	{		
		Display::normal_message($message);
	}
	if ($display=='form')
	{ 

		// ===============================================================
		// Het info formulier weergeven.........
		// ===============================================================
		//echo '<IFRAME style="display:none;" SRC="'.$_configuration['root_web'].'plugin/campus/inc/session_refresh.php"></IFRAME>';
		echo '<form method="post" action="'.$this->get_url().'" name="myform">';
	    	echo '<input type="hidden" name="info_id" value="'.$info_id.'" >';
	    	echo '<input type="hidden" name="action" value="'.$action.'" >';
	    	echo '<input type="hidden" name="page" value="editinfo" >';
		echo '<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang('labelDate').'
				</td>
				<td>
					<input type="text" name="date" size="12" value="'.$date.'"> (YYYY-MM-DD)
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang('labelStudentInfo').'
				</td>
				<td  colspan="2">
					<textarea name="studentinfo" rows="7" cols="60" style="font-family: arial;font-size:12px;">'.$studentinfo.'</textarea>
			 	</td>
				<td >
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					'.get_lang('labelTeacherInfo').'
				</td>
				<td>
					<textarea name="teacherinfo" rows="7" cols="60" style="font-family: arial;font-size:12px;">'.$teacherinfo.'</textarea>
			 	</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td>
					<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.page.value=\'\';">
				</td>
			</tr>
		</table>
		</form>';
	}
	else
	{ // display info list
		include('content.php');
	}
}
?>