<?php

/*
  /*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if (intval($_uid) == 0)
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      MAIN CODE
      ==============================================================================
     */
    if (!empty($_GET))
    {
        $info_id = intval($_GET['info_id']); // Hacking tegen gaan alleen integer is toegelaten.
        $query = "SELECT `date`, `studentinfo`, `teacherinfo`, `code` FROM `campus_info` LEFT JOIN `campus_department`
	 						ON `campus_department`.`department_id`=`campus_info`.`department_id`
					WHERE `id`=" . $info_id . " LIMIT 1";
        $result = mysql_query($query);
        list($date, $studentinfo, $teachersinfo, $departmentcode) = mysql_fetch_row($result);
        if (strlen($studentinfo) > 1)
        {
            $content = ereg_replace(13, '=0D', ereg_replace(10, '=0A', $studentinfo)) . "=0D=0A";
        }
        else
        {
            $content = "";
        }
        $content.=ereg_replace(13, '=0D', ereg_replace(10, '=0A', $teachersinfo));
        $title = $departmentcode . "-INFO " . DatetimeUtilities::format_locale_date('%Y-%m-%d', $date);
        //  mysql_close();
        // controle of de info begint op een bepaald uur. Dit is te vinden in het begin van de info.(het eerste woord)
        //$eerstewoord=ereg_replace(":","",strtok($inhoud," "));
        $eerstewoord = strtok($inhoud, ":");

        /* if ((strlen($eerstewoord)<7) AND ereg("u",$eerstewoord)) { // de tijd mag niet meer dan 6 karakters bevatten en er moet een u in staan.
          $uur=intval(strtok($eerstewoord,"u"));
          $minuten=intval(strtok("u"));
          } */
        if ((strlen($eerstewoord) < 14) AND ereg("u", $eerstewoord))
        { // de tijd mag niet meer dan 13 karakters bevatten en er moet een u in staan.
            $uren = explode("-", $eerstewoord);
            $uur = intval(strtok($uren[0], "."));
            $minuten = intval(strtok("."));
            $starttime = DatetimeUtilities::format_locale_date("%Y%m%dT%H%M%S", $date + 3600 * $uur + 60 * $minuten);
            if (!empty($uren[1]))
            {
                $uur = intval(strtok($uren[1], "."));
                $minuten = intval(strtok("."));
                $endtime = DatetimeUtilities::format_locale_date("%Y%m%dT%H%M%S", $date + 3600 * $uur + 60 * $minuten);
            }
            else
            {
                $endtime = $starttime;
            }
        }
        else
        {
            $starttime = $endtime = DatetimeUtilities::format_locale_date("%Y%m%dT%H%M%S", $date + 29700); // 29700 is 8u15 in seconden....default uur.
        }
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=" . $titel . ".vcs");
        header("Pragma: no-cache");
        header("Expires: 0");
        $data = "BEGIN:VCALENDAR
PRODID: " . $rij['code'] . " INFORMATIE
VERSION:1.0
BEGIN:VEVENT
CATEGORIES:" . $departmentcode . "-INFO
DTSTART:" . $starttime . "
DTEND:" . $endtime . "
DESCRIPTION;ENCODING=QUOTED-PRINTABLE:" . $content . "=0D=0A=0D=0A
SUMMARY;ENCODING=QUOTED-PRINTABLE:" . $title . "
PRIORITY:3
END:VEVENT
END:VCALENDAR
";
        print $data;
    }
    else
    {
        echo "MISLUKT";
    }
}
?>
