<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 1.8.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */
/*
  ==============================================================================
  Chamilo - E-earning & Collaboration Software

  Copyright (c) various contributors

  For a full list of contributors detaining copyrights over parts of
  the Chamilo software, see "documentation/credits.html".
  The full license can be read in "documentation/license.html".

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  See the GNU General Public License for more details.

  Mail: info@chamilo.org
  ==============================================================================
 */
/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  MAIN CODE
  ==============================================================================
 */

//check if user is allowed here...
if (!isset($_uid) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "selectfile");
    $submitmessage = campus::get_POST_GET("submitmessage");


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if ($submitmessage != "")
    {
        echo "<p><u><b>" . get_lang("txtImportReport") . "</b></u></p>";
        if (!empty($_FILES)) // het bestand lezen...
        {
            //Het bestand inlezen ....
            $lines = file($_FILES['uploadfile']['tmp_name']);
            foreach ($lines as $key => $value)
            {
                $values = explode(",", $value);
                // extract values...
                $id = intval(trim($values[0]));
                $class_id = trim($values[1]);
                $class_code = trim($values[2]);
                if ($class_id > 0)
                {
                    $query2 = "UPDATE `" . $campusDb . "`.`campus_qualification_tracking_rel_class` SET
						`class_code`= '". $class_code ."'
						WHERE `qualification_tracking_id`=" . $id . " AND `class_id`=" . $class_id . ""; //***
                    $result2 = mysql_query($query2) or die(mysql_error());
                    $message = "aangepast";
                }
            }
        }
        else
        {
            $errormessage = "Geen bestand gevonden?";
        }
    }
    if (!empty($message))
    {
        Display::display_normal_message($message, false);
    }
    elseif (!empty($errormessage))
    {
        Display::display_error_message($errormessage, false);
        $action = 'selectfile';
    }
    if ($action == "selectfile")
    {
        // ===============================================================
        // het importformulier weergeven.....
        // Het import bestand wordt geselecteerd en ingesteld....
        // ===============================================================
        // reset session....
        echo "<b>" . get_lang("page_importagendacontent") . "</b><br>";
        echo '<form method="post" action="' . $_SERVER['PHP_SELF'] . '?page=importrelclass" name="importform" enctype="multipart/form-data">';
        echo '<input type="hidden" name="action" value="import">';
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000">';
        echo get_lang('labelSelectFile2Import') . '
					<input type="file" name="uploadfile" >
					<br />';
        echo '<input type="submit" name="submitmessage" value="UPLOAD" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
			</form>';
    }
    else
    {
        echo 'OK?';
    }
}
?>
