<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $objective_tracking_id = intval(campus::get_POST_GET('objective_tracking_id'));
    $info = campus::get_POST_GET('info');

    // get objective tracking name and comment.....
    $query = 'SELECT `teacher_code`, `name`, `comment`,`date` FROM `campus_objective_tracking`
							WHERE `id`=' . $objective_tracking_id . ' ';
    $result = mysql_query($query) or die(mysql_error());
    list($teacher_code, $name, $comment, $date) = mysql_fetch_row($result);
    $filename = utf8_decode($name);
    if ($teacher['official_code'] == $teacher_code || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']) || $is_platformadmin)
    {
        // update objective tracking info...
        foreach ($info as $varname => $content)
        {
            if ($varname != '')
            {
                // delete previous info...
                $result = mysql_query('DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="' . $varname . '"');
                // write new info....
                $result = mysql_query('INSERT `campus_objective_tracking_info` SET `objective_tracking_id`=' . $objective_tracking_id . ', `varname`="' . $varname . '", `content`="' . $content . '"');
            }
        }
        // get all the info of the objective tracking....
        $query = "SELECT `varname`, `content`  FROM `campus_objective_tracking_info`
 					WHERE `objective_tracking_id`=" . $objective_tracking_id . " "; //***
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if (empty($info[$rij['varname']]))
            {
                $info[$rij['varname']] = $rij['content'];
            }
        }
        // get the classess
        $grouplist = '';
        $query = 'SELECT `group_code` FROM `campus_objective_tracking_rel_group`
					WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ';
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $grouplist.= $rij['group_code'] . ', ';
        }
        $selectclasses = substr($grouplist, 0, -2) . ' ';
        // get teacher...
        $query = 'SELECT `lastname`,`firstname` FROM  `user_user`
					WHERE `official_code`="' . $teacher_code . '"';
        $result = mysql_query($query);
        list($lastname, $firstname) = mysql_fetch_row($result);
        $teacher = $lastname . ' ' . substr($firstname, 0, 1) . '.';


        // Pagina instellingen
        include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
        $pdf = & new \Cezpdf('a4', 'portrait');
        $phoogte = 842;
        $pbreedte = 575;

        $marge_boven_cm = 5.5;
        $marge_links_cm = 1.5;
        $marge_onder_cm = 1.0;
        $marge_rechts_cm = 1.5;
        $marge_links = $marge_links_cm / 2.54 * 72;
        $marge_boven = $marge_boven_cm / 2.54 * 72;

        // Pagina instellingen
        $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
        //$pdf ->ezSetCmMargins( 3.2,1.5,2,2);
        $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
        //
        $pdf->ezStartPageNumbers(550, 785, 15, 'left', '<b>SPECTRUMCOLLEGE vzw</b>', 1);
        $pdf->ezStartPageNumbers(550, 765, 14, 'left', $departmentStruc[$department_id]['name'], 1);
        $pdf->ezStartPageNumbers(550, 745, 10, 'left', "Schooljaar " . $academicYear, 1);
        $pdf->ezStartPageNumbers(550, 725, 10, 'left', DatetimeUtilities::format_locale_date('%A %d %B %Y', time()), 1);
        $all = $pdf->openObject();
        $pdf->saveState();
        $pdf->setStrokeColor(0.8, 0.8, 0.8);
        $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
        if ($ext == '.jpg')
        {
            $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 732, 130);
        }
        elseif ($ext == '.png')
        {
            $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 732, 130);
        }

        // get evaluation structure.....

        $pdf->line(30, 50, 550, 50);
        $pdf->ezStartPageNumbers(550, 35, 11, 'left', $departmentStruc[$department_id]['name'], 1);
        $pdf->ezStartPageNumbers(30, 35, 11, 'right', 'Spectrumcollege vzw', 1);
        $pdf->ezStartPageNumbers(550, 20, 11, 'left', 'http://www.spectrumcollege.be', 1);
        $pdf->ezStartPageNumbers(30, 20, 11, 'right', $departmentStruc[$department_id]['address'] . ' Tel.(' . $departmentStruc[$department_id]['phone'] . ')', 1);

        $pdf->restoreState();
        $pdf->closeObject();
        // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
        // 	or 'even'.
        $pdf->addObject($all, 'all');

        $pdf->ezText('Beste ouders', 12, array('aleft' => 75));
        $pdf->ezSetDy(-30);

        $pdf->ezText('Onze school organiseert volgende activiteit:', 12, array('aleft' => 75));
        $pdf->ezSetDy(-3);
        $pdf->ezText('<i>' . $name . '</i>', 13, array('aleft' => 105));
        $pdf->ezSetDy(-10);
        $pdf->ezText('Deze activiteit wordt georganiseerd voor de leerlingen van de klas(sen):', 12, array('aleft' => 75));
        $pdf->ezSetDy(-10);
        $pdf->ezText('<i>' . $selectclasses . '</i>', 10, array('aleft' => 85));
        $pdf->ezSetDy(-20);
        $pdf->ezText('<b>Omschrijving van de activiteit:</b>', 12, array('aleft' => 75));
        $pdf->ezSetDy(-10);
        $pdf->ezText('<i>' . str_replace("<br>", "\n", $comment) . '</i>', 10, array('aleft' => 85));

        $pdf->ezSetDy(-20);
        $pdf->ezText('<b>Praktische informatie:</b>', 12, array('aleft' => 75));
        $pdf->ezSetY($pdf->ezPosY() - 2);
        $pdf->ezText('Datum:', 12, array('aleft' => 85));
        $pdf->ezSetY($pdf->ezPosY() + 14);
        $pdf->ezText('<i>' . DatetimeUtilities::format_locale_date('%A %d %B %Y',$date) . '</i>', 12, array('aleft' => 185));
        $pdf->ezSetY($pdf->ezPosY() - 1);
        $pdf->ezText('Bestemming:', 12, array('aleft' => 85));
        $pdf->ezSetY($pdf->ezPosY() + 14);
        $pdf->ezText('<i>' . $info['locatie']. '</i>', 12, array('aleft' => 185));
        if ($info['type'] == 'extramuros')
        {
            $pdf->ezText('Uur van vertrek:', 12, array('aleft' => 85));
            $pdf->ezSetY($pdf->ezPosY() + 14);
            $pdf->ezText('<i>' . $info['begin'] . '</i>', 12, array('aleft' => 185));
            $pdf->ezText('Uur van terugkeer:', 12, array('aleft' => 85));
            $pdf->ezSetY($pdf->ezPosY() + 14);
            $pdf->ezText('<i>' . $info['einde'] . '</i>', 12, array('aleft' => 185));
            $pdf->ezText('vervoer:', 12, array('aleft' => 85));
            $pdf->ezSetY($pdf->ezPosY() + 14);
            $pdf->ezText('<i>' . $info['vervoer'] . '</i>', 12, array('aleft' => 185));
        }
        else
        {
            $pdf->ezText('Uur van begin:', 12, array('aleft' => 85));
            $pdf->ezSetY($pdf->ezPosY() + 14);
            $pdf->ezText('<i>' . $info['begin'] . '</i>', 12, array('aleft' => 185));
            $pdf->ezText('Uur van einde:', 12, array('aleft' => 85));
            $pdf->ezSetY($pdf->ezPosY() + 14);
            $pdf->ezText('<i>' . $info['einde'] . '</i>', 12, array('aleft' => 185));
        }

        $pdf->ezSetDy(-20);
        if ($info['meebrengen'] != '')
        {
            $pdf->ezText('<b>Meebrengen:</b>', 12, array('aleft' => 85));
            $pdf->ezSetDy(-5);
            $pdf->ezText('<i>' . str_replace("<br>", "\n", $info['meebrengen']) . '</i>', 10, array('aleft' => 95));
            $pdf->ezSetDy(-20);
        }
        $pdf->ezText('<b>Onkosten van de activiteit:</b>', 12, array('aleft' => 75));
        $pdf->ezSetDy(-5);
        $pdf->ezText('Omschrijving van de onkosten:', 12, array('aleft' => 85));
        $pdf->ezText('<i>' . str_replace("<br>", "\n", $info['kostenomschrijving']) . '</i>', 10, array('aleft' => 95));
        $pdf->ezSetDy(-20);
        $pdf->ezText('Totaal:', 12, array('aleft' => 85));
        $pdf->ezSetY($pdf->ezPosY() + 14);
        $pdf->ezText('<i>' . $info['kost'] . '</i>', 12, array('aleft' => 155));
        $pdf->ezSetDy(-5);
        if ($info['betalingswijze'] == 'Het geld van de onkosten meebrengen ')
        {
            $pdf->ezText('<i>' . $info['betalingswijze'] . ' ' . $info['geldmeebrengen'] . '</i>', 12, array('aleft' => 85));
        }
        else
        {
            $pdf->ezText($info['betalingswijze'], 12, array('aleft' => 85));
        }
        $pdf->ezSetDy(-20);

        $pdf->ezText('Met vriendelijke groeten', 12, array('aleft' => 75));
        $pdf->ezSetDy(-5);
        $pdf->ezText('Namens de directie en de verantwoordelijke leerkracht, ' . $teacher, 12, array('aleft' => 75));

        $fileoption = array('Content-Disposition' => $filename . '.pdf');
        $pdf->ezStream($fileoption);
    }
    else
    {
        Echo "NOT ALLOWED!!!";
    }
}
?>
