<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $submitmessage = campus::get_POST_GET('submitmessage');
    if (empty($objective_tracking_id))
    {
        $objective_tracking_id = intval(campus::get_POST_GET('objective_tracking_id'));
    }
    $classes2 = campus::get_studentclasses($department_id);
    $teachers = campus::get_teachers($department_id);
    $info = campus::get_POST_GET('info');
    $classes = array();
    foreach ($classes2 as $class_id => $classinfo)
    {
        $classes[$classinfo['code']]['aantal'] = $classinfo['aantal'];
    }
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    // read data
    $query = "SELECT `id`, `teacher_code`, `name`, `comment`,`date`  FROM `campus_objective_tracking`
 						WHERE `id`=" . $objective_tracking_id . " "; //***
    $result = mysql_query($query) or die(mysql_error());
    list($objective_tracking_id, $teacher_code, $name, $comment, $date) = mysql_fetch_row($result); //***
    //$date=  DatetimeUtilities::format_locale_date('%Y-%m-%d',$date);
    // read in info's.....
    if ($objective_tracking_id=="")
    {
         Display::error_message(get_lang("msgObjectiveTrackingNotExist"), false);
    }
    else
    {

        $query = "SELECT `varname`, `content`  FROM `campus_objective_tracking_info`
 					WHERE `objective_tracking_id`=" . $objective_tracking_id . " "; //***
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if (empty($info[$rij['varname']]))
            {
                $info[$rij['varname']] = $rij['content'];
            }
        }
        $grouplist = '';
        $query = "SELECT `group_code` FROM `campus_objective_tracking_rel_group`
					WHERE `objective_tracking_id`=" . $objective_tracking_id . " ";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $grouplist.= $rij['group_code'] . '(' . $classes[$rij['group_code']]['aantal'] . '), ';
            $totaal+=$classes[$rij['group_code']]['aantal'];
        }
        $selectgroups = substr($grouplist, 0, -2) . ' in het totaal:' . $totaal . ' leerlingen.';
        $array = array();
        $query = "SELECT * FROM `campus_objective_tracking_rel_teacher` WHERE `objective_tracking_id`=" . $objective_tracking_id . " ";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $array[] = '<span title="' . $teachers[$rij['teacher_id']]['fullame'] . '">' . $teachers[$rij['teacher_id']]['official_code'] . '</span>';
        }
        $selectteachers = implode(', ', $array);
        $array = array();

        $selectobjectives = campus::get_POST_GET('selectobjectives');
        // questions for evaluation....
        $arrayquestions = array(
            'organisatie' => '1. Was de activiteit goed georganiseerd?',
            'voorbereiding' => '2. Waren de leerlingen goed voorbereid?',
            'documentatie' => '3. Kregen de leerlingen voldoende documentatie?',
            'populair' => '4. Is de activiteit bij de leerlingen in de smaak gevallen?',
            'afgestemd' => '5. Was de activiteit voldoende afgestemd op de doelgroep (onze leerlingen)?',
            'nabespreking' => '6. Werd de activiteit voldoende verwerkt/nabesproken in de klas?',
            'evaluatielln' => '7. Heb je bij deze evaluatie rekening gehouden met de evaluatie van de activiteit door de leerlingen?',
            'vakgebondendoelstellingen' => '8. Beantwoordde de activiteit aan de gestelde vakgebonden doelstellingen - eindtermen?',
            'VOET' => '9.  Beantwoordde de activiteit voldoende aan de gestelde vakoverschrijdende eindtermen?'
        );
        $select = array('nee', 'ja', 'nvt');
        if ($submitmessage == '')
        { //
            switch ($action)
            {
                case 'evaluateobjectivetracking' :
                    {
                        //$info=campus::get_POST_GET('info');
                    }
            }
        }
        else
        {
            switch ($action)
            {
                case 'evaluateobjectivetracking' :
                    {
                        //$info=campus::get_POST_GET('info');
                        // update tracking objective info...
                        $result = mysql_query('DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="evaluationdate"');
                        foreach ($arrayquestions as $varname => $question)
                        {
                            if ($info[$varname] != '')
                            {
                                // Remove previous evaluations....
                                $query = 'DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="' . $varname . '"';
                                $result = mysql_query($query);
                                // write new evaluation...
                                $result = mysql_query('INSERT `campus_objective_tracking_info` SET `objective_tracking_id`=' . $objective_tracking_id . ', `varname`="' . $varname . '", `content`="' . $info[$varname] . '"');
                            }
                            else
                            {
                                $errormessage = get_lang('msgNotAllQuestionsAnswered');
                                break;
                            }
                        }
                        if ($errormessage != '')
                        {
                            break;
                        }
                        // Update evaluation objective tracking comment....
                        $query = 'DELETE FROM `campus_objective_tracking_info` WHERE
					`objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="evaluatieopmerking"';
                        $result = mysql_query($query);
                        $query = 'INSERT `campus_objective_tracking_info` SET
					`objective_tracking_id`=' . $objective_tracking_id . ',
					`varname`="evaluatieopmerking",
					`content`="' . $info['evaluatieopmerking'] . '"';
                        $result = mysql_query($query);
                        // update objectives related to objective tracking...
                        $objective2studenttracking = $objective_tracking_id;
                        if (!empty($selectobjectives))
                        {
                            // delete existing rel objectives........
                            $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_objective` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                            // add objectives to objective tracking
                            foreach ($selectobjectives as $objective_id)
                            {
                                $objective2studenttracking.=';' . $objective_id;
                                $result = mysql_query('INSERT `campus_objective_tracking_rel_objective` SET `objective_tracking_id`=' . $objective_tracking_id . ', `objective_id`=' . $objective_id);
                            }
                        }
                        else
                        {
                            // write objectives to student tracking system......
                            $query = 'SELECT `objective_id` FROM `campus_objective_tracking_rel_objective`
							WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ';
                            $result = mysql_query($query);
                            while (list($objective_id) = mysql_fetch_row($result))
                            {
                                $objective2studenttracking.=';' . $objective_id;
                            }
                        }
                        $info['evaluationdate'] = DatetimeUtilities::format_locale_date('%Y-%m-%d');
                        // write evaluation date and mark objective tracking as evaluated...
                        $query = 'INSERT `campus_objective_tracking_info` SET
					`objective_tracking_id`="' . $objective_tracking_id . '",
					`varname`="evaluationdate",
					`content`="' . $info['evaluationdate'] . '"';
                        $result = mysql_query($query);


                        if ($objective2studenttracking != '')
                        {
                            // 	write objectives to student tracking system......
                            $query = 'SELECT `user_id` FROM `campus_objective_tracking_rel_group`
                            INNER JOIN `group_group` ON `group_code`=`group_group`.`code`
                            INNER JOIN  `group_group_rel_user` ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
							WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ';
                            $result = mysql_query($query);
                            while (list($student_id) = mysql_fetch_row($result))
                            {
                                // remove existing objective tracking
                                $result2 = mysql_query('DELETE FROM `campus_student_tracking` WHERE
							`student_id`=' . $student_id . ' AND
							`tracking_title`="objectivetracking" AND
							`content` like "' . $objective_tracking_id . ';%"');
                                // write objective tracking in student tracking system....
                                $query3 = "INSERT `campus_student_tracking` SET
							`student_id`=" . $student_id . ",
							`tracking_category`='',
							`tracking_title`='objectivetracking',
							`date`=" . $date . ",
							`teacher_code`='" . $teacher_code . "',
							`grouplist`='',
							`department_code`='',
							`public`='off',
							`attachment`='',
							`content`='" . $objective2studenttracking . "'
											";
                                $result3 = mysql_query($query3);
                            }
                        }

                        $action = 'objectivetrackinglist';
                    }
                    break;
                case 'setapproval' :
                    {
                        // Reset approval....
                        $query = 'DELETE FROM `campus_objective_tracking_info` WHERE
					`objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="approval"';
                        $result = mysql_query($query) or die(mysql_error());
                        $query = 'INSERT `campus_objective_tracking_info` SET
					`objective_tracking_id`=' . $objective_tracking_id . ',
					`varname`="approval",
					`content`="approved"';
                        $result = mysql_query($query);
                        if ($result)
                        {
                            $info['approval'] = 'approved';
                            $message = get_lang('msgObjectiveTrackingApproved');

                            // 	send approved message....
                            $result = mysql_query("SELECT `id` FROM  `user_user` WHERE `official_code`='" . $teacher_code . "'");
                            list($user_id) = mysql_fetch_row($result);
                            $query = 'INSERT`campus_messageboard` SET
						`title`= "Aanvraag organisatie activiteit:",
						`date`=' . time() . ',
						`user_id`=' . $_uid . ',
						`content`="' . addslashes(get_lang('msgObjectiveTrackingApproved') . '<br><br>' . get_lang('txtToLink') . ' <a href="' . $this->get_url() . '">' . get_lang('txtobjectiveTrackingList') . '</a><br>' . stripslashes($name) . ' :<br>' . stripslashes($comment)) . '"
						';
                            $result = mysql_query($query);
                            if ($result)
                            {
                                $message_id = mysql_insert_id();
                                $user2warn = array();
                                $user2warn = array_merge($user2warn, array("u" . $user_id));
                                campus::set_message_to($user2warn, $message_id);
                            }
                        }
                    }
                    break;
                case 'resetapproval' :
                    {
                        // Reset approval....
                        $query = 'DELETE FROM `campus_objective_tracking_info` WHERE
					`objective_tracking_id`="' . $objective_tracking_id . '" AND `varname`="approval"';
                        $result = mysql_query($query);
                        if ($result)
                        {
                            $info['approval'] = '';
                            $message = get_lang('msgObjectiveTrackingNotApproved');
                            // send approved message....
                            $result = mysql_query("SELECT `id` FROM  `user_user` WHERE `official_code`='" . $teacher_code . "'");
                            list($user_id) = mysql_fetch_row($result);
                            $query = 'INSERT
						`campus_messageboard` SET
						`title`= "Aanvraag organisatie activiteit:",
						`date`=' . time() . ',
						`user_id`=' . $_uid . ',
						`content`="' . addslashes(get_lang('msgObjectiveTrackingNotApproved') . '<br><br>' . get_lang('txtToLink') . ' <a href="' . $this->get_url() . '">' . get_lang('txtObjectiveTrackingList') . '</a><br>' . stripslashes($name) . ' :<br>' . stripslashes($comment)) . '"
						';
                            $result = mysql_query($query);
                            if ($result)
                            {
                                $message_id = mysql_insert_id();
                                $user2warn = array();
                                $user2warn = array_merge($user2warn, array("u" . $user_id));
                                campus::set_message_to($user2warn, $message_id);
                            }
                        }
                    }
                    break;
                case 'getapproval' :
                    {
                        // write message to ....

                        $query = 'INSERT
					`campus_messageboard` SET
					`title`= "Aanvraag organisatie activiteit",
					`date`=' . time() . ',
					`user_id`=' . $_uid . ',
					`content`="' . addslashes(get_lang('txtToLink') . ' <a href="' . $this->get_url() . '&page=viewobjectivetracking&objective_tracking_id=' . $objective_tracking_id . '">' . get_lang('txtObjectiveTracking') . ': ' . $name . '</a><br>' . $comment) . '"
					';
                        $result = mysql_query($query) or die(mysql_error());
                        if ($result)
                        {
                            $message_id = mysql_insert_id();
                            $query = 'SELECT `user_id` FROM `campus_rights` WHERE `department_id`=' . $department_id . ' AND `item`=12';
                            $result = mysql_query($query);
                            $user2warn = array();
                            while (list($user_id) = mysql_fetch_row($result))
                            {
                                $user2warn = array_merge($user2warn, array("u" . $user_id));
                            }
                            campus::set_message_to($user2warn, $message_id);
                            $message = get_lang('msgApprovalRequestSend');
                        }
                        $action = "list";
                    }
                    break;
            }
        }
        /*
          ==============================================================================
          display ...
          ==============================================================================
         */

        // ===============================================================
        // Form to add/edit objective tracking
        // ===============================================================
        if (!empty($errormessage))
        {
            Display::error_message($errormessage, false);
        }
        elseif (!empty($message))
        {
            Display::normal_message($message, false);
        }
        echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="viewobjectivetracking" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="objective_tracking_id" value="' . $objective_tracking_id . '" >
								<a name="letter"></a>';

        switch ($action)
        {
            case 'editobjectiveletter' :
                {

                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.myform.page.value=\'\';">
					 <input type="submit" name="letter" value="Maak brief Doc" onMouseDown="javascript:document.myform.page.value=\'objectiveletter2doc\';">
					 <input type="submit" name="letter" value="Maak brief Pdf" onMouseDown="javascript:document.myform.page.value=\'objectiveletter2pdf\';">';
                }
                break;
            case 'evaluateobjectivetracking' :
                {
                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'\';">
					 <input type="submit" name="submitmessage" value="Bewaar evaluatie">';
                }
                break;
            default :
                {
                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.myform.page.value=\'\';document.myform.action.value=\'\';">
                         <input type="submit" name="pdf" value="Brief naar de ouders" onMouseDown="javascript:myform.action=\'' . $this->get_url() . '#letter\';document.myform.action.value=\'editobjectiveletter\';">';
                    if (((($teacher['official_code'] == $teacher_code) || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0'])) && ($info['evaluationdate'] == '')) || $is_platformadmin)
                    {
                        echo '   <input type="submit" name="submitmessage" value="Aanvraag voor goedkeuring" onMouseDown="javascript:document.myform.action.value=\'getapproval\';">';
                    }
                    if (((($teacher['official_code'] == $teacher_code) || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1'])) && ($info['evaluationdate'] == '')) || $is_platformadmin)
                    {

                        echo '   <input type="submit" name="evaluate" value="Evalueer" onMouseDown="javascript:document.myform.action.value=\'evaluateobjectivetracking\';">';
                    }
                    if ((((isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']))) || $is_platformadmin)
                    {
                        if (($info['approval'] == 'approved') && ($info['evaluationdate'] == ''))
                        {
                            echo '   <input type="submit" name="submitmessage" value="Verwijder goedkeuring" onMouseDown="javascript:document.myform.action.value=\'resetapproval\';">';
                        }
                        elseif ($info['approval'] != 'approved')
                        {
                            echo '   <input type="submit" name="submitmessage" value="Goedkeuring" onMouseDown="javascript:document.myform.action.value=\'setapproval\';">';
                        }
                    }
                    echo '   <input type="submit" name="" value="' . get_lang('buttonlabelCopy') . '" title="' . get_lang('tooltipCopyObjectivetracking') . '" onMouseDown="javascript:document.myform.page.value=\'editobjectivetracking\';document.myform.action.value=\'copy2new\';">';
                }
        }
        echo '			<table border=1 cellpadding=3 cellspacing=0 style="width:780px">
				<tr valign="top">
					<td align="right" style="background-color:#eee;font-weight:bold;">
						Aanvrager :
					</td>
					<td>
						' . $teacher_code . '
					</td>
				</tr>
				<tr valign="top">
					<td align="right" style="background-color:#eee;font-weight:bold;">
						Naam van de activiteit:<sup>(1)</sup>
					</td>
					<td>
							' . $name . '
					</td>
		   		</tr>';
        echo ' 		<tr valign="top">
			   		<td  align="right" style="background-color:#eee;font-weight:bold;">
				    	Omschrijving van de activiteit:<sup>(1)</sup>
				   	</td>
				   	<td>
						<textarea cols="80" style=" border:none;" readonly>' . stripslashes($comment) . '</textarea>
				   	</td>
				</tr>';
        echo ' <tr valign="top" id="" >
				   <td  align="right" style="background-color:#eee;font-weight:bold;">
					    Datum van de activiteit:<sup>(1)</sup>
				   </td>
				   <td>
						' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $date) . '
				   </td>
				</tr>';
        if ($info['opmerking'] != '')
        {
            echo ' 		<tr valign="top">
				   		<td  align="right" style="background-color:#eee;font-weight:bold;">
					    	Bijkomende informatie (vakgroep, ...):
					   	</td>
					   	<td>
							<textarea name="info[opmerking]" cols="80" style=" border:none;" readonly>' . stripslashes($info['opmerking']) . '</textarea>
					   	</td>
					 </tr>';
        }
        echo ' 		<tr valign="top">
					<td  align="right" style="background-color:#eee;font-weight:bold;">
				    	Type activiteit:
				   	</td>
				   	<td>
						' . $info['type'] . '
					</td>
				</tr>';
        // ===========
        if ($info['type'] != 'vak')
        {
            echo ' <tr valign="top">
				   	<td  align="right" style="background-color:#eee;font-weight:bold;">
					    Plaats:<sup>(1)</sup>
				   	</td>
				    <td>
						' . $info['locatie'] . '
					</td>
				</tr>';
            if ($info['type'] == 'extra-muros')
            {

                echo ' <tr valign="top">
			   		<td  align="right" style="background-color:#eee;font-weight:bold;">
				    	Vertrek uur:<sup>(1)</sup>
				   	</td>
				   	<td>
						' . $info['begin'] . '
				   	</td>
			 	</tr>';
                echo ' <tr valign="top">
					   <td  align="right" style="background-color:#eee;font-weight:bold;">
					     	Uur van terug keer:<sup>(1)</sup>
					   </td>
					   <td>
							' . $info['einde'] . '
					   </td>
				 </tr>';
                echo ' <tr valign="top">
			   		<td  align="right" style="background-color:#eee;font-weight:bold;">
				    	Vervoer:<sup>(1)</sup>
				   	</td>
				   	<td>
						' . $info['vervoer'] . '
					</td>
				 </tr>';
            }
            else
            {
                echo ' <tr valign="top">
			   		<td  align="right" style="background-color:#eee;font-weight:bold;">
				    	Begin uur:<sup>(1)</sup>
				   	</td>
				   	<td>
						' . $info['begin'] . '
				   	</td>
				 	</tr>';
                echo ' <tr valign="top">
					   <td  align="right" style="background-color:#eee;font-weight:bold;">
					     	Eind uur:<sup>(1)</sup>
					   </td>
					   <td>
							' . $info['einde'] . '
					   </td>
					 </tr>';
            }
            if ($info['opmerking'] != '')
            {
                echo ' <tr valign="top" id="">
				   <td  align="right" style="background-color:#eee;font-weight:bold;">
					    Materiaal benodigdheden:
					   </td>
					   <td>
							<textarea type="text" style ="height:36px; border: none;" cols="80" READONLY>' . stripslashes($info['materiaal']) . '</textarea>
							</td>
					 </tr>';
            }
            if ($action != 'editobjectiveletter')
            {
                echo '	<tr valign="top">
						<td align="right" style="background-color:#eee;font-weight:bold;">
						Meebrengen:<sup>(1)</sup>
						</td>
						<td>
							<textarea type="text" style ="height:36px; border: none;" cols="80" READONLY>' . stripslashes($info['meebrengen']) . '</textarea>
						</td>
				   		</tr>';
                echo '	<tr valign="top">
						<td align="right" style="background-color:#eee;font-weight:bold;">
						Onkosten van de activiteit:<sup>(1)</sup>
						</td>
						<td>
							' . $info['kost'] . '
						</td>
				   		</tr>';
                echo ' 		<tr valign="top">
				   		<td  align="right" style="background-color:#eee;font-weight:bold;">
					    	Beschrijving van deze onkosten:<sup>(1)</sup>
					   	</td>
					   	<td>
							<textarea type="text" style ="height:36px; border: none;" cols="60" READONLY>' . stripslashes($info['kostenomschrijving']) . '</textarea>
					   	</td>
					 </tr>';
                echo ' <tr valign="top">
				   		<td  align="right" style="background-color:#eee;font-weight:bold;">
					    	Betaling:<sup>(1)</sup>
					   	</td>
					   	<td>
							' . $info['betalingswijze'] . '
       					</td>
					 </tr>';
                if ($info['betalingswijze'] == 'Het geld van de onkosten meebrengen ')
                {
                    echo '<tr valign="top">
				   		<td  align="right" style="background-color:#eee;font-weight:bold;">
					    	Geld meebrengen:<sup>(1)</sup>
					   	</td>
					   	<td>
							' . $info['geldmeebrengen'] . '
					   	</td>
					 </tr>';
                }
            }
            echo ' <tr valign="top">
			  		 <td  align="right" style="background-color:#eee;font-weight:bold;">
					    Begeleidende leerkrachten:
				   		</td>
					   <td>';
            echo $selectteachers;
            echo '	</td>
					</tr>';
        }
        // 	===========
        echo '<tr valign="top">
			<td  align="right" style="background-color:#eee;font-weight:bold;">
				Klassen:<sup>(1)</sup>
			</td>
			<td>';
        echo $selectgroups;
        echo ' 	</td>
			</tr>';
        if ($info['vakgebondeneindtermen'] != '')
        {
            echo ' <tr valign="top" id="">
				   <td  align="right" style="background-color:#eee;font-weight:bold;">
					    Vakgebonden eindtermen behaald:
					   </td>
					   <td>
							<textarea type="text"  style ="height:36px;border: none;" cols="80" READONLY>' . stripslashes($info['vakgebondeneindtermen']) . '</textarea>
							</td>
					 </tr>';
        }
        echo'</table>';
        if ($action != 'evaluateobjectivetracking')
        {
            echo '<sup>(1)</sup>: wordt weergeven op de brief voor de ouders....<br><br>';
        }
        if ($action == 'evaluateobjectivetracking')
        {
            // evaluation of objective tracking....
            echo '<table>';
            echo '	<tr valign="top">
						<td align="left" colspan=20>
							<b><u style="font-size:15px;">Evaluatie van de activiteit:</u></b>
						</td>
				   		</tr>';
            echo '	<tr valign="top">
						<td align="left" colspan=5>
							&nbsp;
						</td>';
            foreach ($select as $option)
            {
                echo '<td align="center" style="width: 60px;"><b>' . $option . '</b></td>';
            }
            echo '		</tr>';
            foreach ($arrayquestions as $var => $question)
            {
                echo '	<tr valign="top">
						<td align="left" colspan=5>
						' . $question . '
						</td>';
                foreach ($select as $option)
                {
                    echo '<td align="center" ><input type="radio" name="info[' . $var . ']" value="' . $option . '" ' . (($info[$var] == $option) ? 'checked' : '') . ' Onclick="javascript:submit();" >&nbsp;</td>';
                }
                echo '
				   		</tr>';
            }
            echo'</table>';
            echo '<table>';
            echo ' 		<tr valign="top">
				   		<td  align="right" colspan=2>
					    	Opmerking:
					   	</td>
					   	<td>
							<textarea name="info[evaluatieopmerking]" style ="height:68px;" cols="80" >' . stripslashes($info['evaluatieopmerking']) . '</textarea>
					   	</td>
					 </tr>';
            echo'</table>';
        }
        if (($action == 'objectivetrackinglist') || (($action == 'evaluateobjectivetracking') && (($info['VOET'] == 'nee'))))
        {
            echo '<table>';
            echo ' <tr valign="top">
	   			<td  align="right" style="border-right: solid 5px #eee;font-weight:bold;font-size:16px;">
					Eindtermen
				</td>
				<td>';

            $query = 'SELECT `campus_objective_curriculum`.`name` as objective_curriculum, `campus_objective_curriculum`.`comment`, `objective_group`, `objective`,`campus_objective`.`display_order`, `campus_objective`.`code`  FROM `campus_objective_tracking_rel_objective`
					INNER JOIN `campus_objective` ON `campus_objective`.`id`=`campus_objective_tracking_rel_objective`.`objective_id`
					INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`=`campus_objective`.`objective_curriculum_id`
				WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ORDER BY `campus_objective_curriculum`.`display_order`, `campus_objective`.`display_order`';
            $result = mysql_query($query) or die(mysql_error());
            $prevtype = '';
            $prevsubtype = '';
            $prevgroup = '';
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                if ($rij['objective_curriculum'] != $prevtype)
                {
                    $prevtype = $rij['objective_curriculum'];
                    echo '<b><u style="font-size:14px;">' . $rij['objective_curriculum'] . '</u></b><br>';
                }
                if ($rij['objective_group'] != $prevgroup)
                {
                    $prevgroup = $rij['objective_group'];
                    echo '<span style="font-size:12px;margin-left:15px;">' . $rij['objective_group'] . '</span><br>';
                }
                echo '<p style="font-size:12px;margin-left:15px;">';
                if ($action == 'evaluateobjectivetracking')
                {
                    echo '<input type="checkbox" name="selectobjectives[]" value="' . $rij['objective_id'] . '" ' . ((in_array($rij['objective_id'], $selectobjectives) || empty($selectobjectives)) ? 'checked' : '') . ' >';
                }
                echo '<i>' . $rij['code'] . ':&nbsp;&nbsp;<pre style="display:inline;">' . $rij['objective'] . '</pre></i></p>';
            }
            echo '	  </td>
						 </tr>';
            echo '</table>';
        }
        if (($action != 'evaluateobjectivetracking') && ($info['evaluationdate'] != '') && ($action != 'editobjectiveletter'))
        {
            // evaluation of objective tracking....
            echo '<table>';
            echo '	<tr valign="top">
						<td align="left" colspan=20>
							<b><u style="font-size:15px;">Evaluatie van de activiteit:</u></b>
						</td>
				   		</tr>';
            echo '	<tr valign="top">
						<td align="left" colspan=5>
							&nbsp;
						</td>';
            foreach ($select as $option)
            {
                echo '<td align="center" style="width: 60px;"><b>' . $option . '</b></td>';
            }
            echo '		</tr>';
            foreach ($arrayquestions as $var => $question)
            {
                echo '	<tr valign="top">
						<td align="left" colspan=5>
						' . $question . '
						</td>';
                foreach ($select as $option)
                {
                    echo '<td align="center" ><input type="radio" name="dummy[' . $var . ']" value="' . $option . '" ' . (($info[$var] == $option) ? 'checked' : '') . ' disabled>&nbsp;</td>';
                }
                echo '
				   		</tr>';
            }
            echo'</table>';
            echo '<table>';
            echo ' 		<tr valign="top">
				   		<td  align="right" colspan=2>
					    	Opmerking:
					   	</td>
					   	<td>
							<textarea cols="80" style="height:36px; border:none;" readonly>' . stripslashes($info['evaluatieopmerking']) . '</textarea>
					   	</td>
					 </tr>';
            echo'</table>';
        }

        if ($action == 'editobjectiveletter')
        {
            echo '<table>';
            echo '	<tr valign="top">
						<td align="right">
						Meebrengen:<sup>(1)</sup>
						</td>
						<td>
							<textarea type="text" name="info[meebrengen]" style ="height:52px;" cols="80" >' . stripslashes($info['meebrengen']) . '</textarea>
						</td>
				   		</tr>';
            echo '	<tr valign="top">
						<td align="right">
						Onkosten van de activiteit:<sup>(1)</sup>
						</td>
						<td>
							<input type="text" name="info[kost]" size="32"  value="' . $info['kost'] . '"/>
						</td>
				   		</tr>';
            echo ' 		<tr valign="top">
				   		<td  align="right">
					    	Beschrijving van deze onkosten:<sup>(1)</sup>
					   	</td>
					   	<td>
							<textarea name="info[kostenomschrijving]" style ="height:52px;"" cols="60" >' . stripslashes($info['kostenomschrijving']) . '</textarea>
					   	</td>
					 </tr>';
            echo ' <tr valign="top">
				   		<td  align="right">
					    	Betaling:<sup>(1)</sup>
					   	</td>
					   	<td>
							<select name="info[betalingswijze]" OnChange="javascript:submit();">
										<option value="" selected>maak een keuze</option>';
            $select = array('De onkosten worden afgerekend via de schoolrekening.', 'Het geld van de onkosten meebrengen op de dag zelf.', 'Het geld van de onkosten meebrengen ',);
            foreach ($select as $option)
            {
                echo '<option value="' . $option . '" ' . (($info['betalingswijze'] == $option) ? 'selected' : '') . '>' . $option . '</option>';
            }
            echo'	</select>
						</td>
					 </tr>';
            if ($info['betalingswijze'] == 'Het geld van de onkosten meebrengen ')
            {
                echo '<tr valign="top">
				   		<td  align="right">
					    	Geld meebrengen:<sup>(1)</sup>
					   	</td>
					   	<td>
							<input type="tekst" name="info[geldmeebrengen]"  size="32"  value="' . $info['geldmeebrengen'] . '"/>
					   	</td>
					 </tr>';
            }
            echo '	</table>';
        }

        switch ($action)
        {
            case 'editobjectiveletter' :
                {

                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.myform.page.value=\'\';">
					 <input type="submit" name="letter" value="Maak brief Doc" onMouseDown="javascript:document.myform.page.value=\'objectiveletter2doc\';">
					 <input type="submit" name="letter" value="Maak brief Pdf" onMouseDown="javascript:document.myform.page.value=\'objectiveletter2pdf\';">';
                }
                break;
            case 'evaluateobjectivetracking' :
                {
                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'\';">
					 <input type="submit" name="submitmessage" value="Bewaar evaluatie">';
                }
                break;
            default :
                {
                    echo '   <input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.myform.page.value=\'\';document.myform.action.value=\'\';">
                         <input type="submit" name="pdf" value="Brief naar de ouders" onMouseDown="javascript:myform.action=\'' . $this->get_url() . '#letter\';document.myform.action.value=\'editobjectiveletter\';">';
                    if (((($teacher['official_code'] == $teacher_code) || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0'])) && ($info['evaluationdate'] == '')) || $is_platformadmin)
                    {
                        echo '   <input type="submit" name="submitmessage" value="Aanvraag voor goedkeuring" onMouseDown="javascript:document.myform.action.value=\'getapproval\';">';
                    }
                    if (((($teacher['official_code'] == $teacher_code) || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1'])) && ($info['evaluationdate'] == '')) || $is_platformadmin)
                    {

                        echo '   <input type="submit" name="evaluate" value="Evalueer" onMouseDown="javascript:document.myform.action.value=\'evaluateobjectivetracking\';">';
                    }
                    if ((((isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']))) || $is_platformadmin)
                    {
                        if (($info['approval'] == 'approved') && ($info['evaluationdate'] == ''))
                        {
                            echo '   <input type="submit" name="submitmessage" value="Verwijder goedkeuring" onMouseDown="javascript:document.myform.action.value=\'resetapproval\';">';
                        }
                        elseif ($info['approval'] != 'approved')
                        {
                            echo '   <input type="submit" name="submitmessage" value="Goedkeuring" onMouseDown="javascript:document.myform.action.value=\'setapproval\';">';
                        }
                    }
                    echo '   <input type="submit" name="" value="' . get_lang('buttonlabelCopy') . '" title="' . get_lang('tooltipCopyObjectivetracking') . '" onMouseDown="javascript:document.myform.page.value=\'editobjectivetracking\';document.myform.action.value=\'copy2new\';">';
                }
        }


        echo '	</form> ';
    }
}
?>