<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  This is a studentlist to excell Export utility.
  ==============================================================================
 */
/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $select = campus::get_POST_GET("select");
    // Query van het gegevensbestand....
    $query = "SELECT `display_order`, `lastname`, `firstname`, `official_code`, `email`, `group_group`.`code`
            FROM `user_user`
                INNER JOIN `group_group_rel_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                INNER JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
    $filter = "`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select);
    $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    $result = mysql_query($sql);

    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */

    $vorige = '';
    $selectie='';
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        if ($vorige != $rij['code'])
        {
            $vorige = $rij['code'];
            $selectie.=$rij['code'] . "_";
            $data.="<TR>
						<TD CLASS='BORDER' COLSPAN='23'> 
							KLAS: <b>" . $rij['code'] . "</b>
						</TD>
					</TR>";
        }
        $data.="<TR>
					<TD class='CEL' HEIGHT=25 ALIGN=center> 
						" . $rij['display_order'] . "
					</TD>
					<TD class='CEL'>
						" . $rij['lastname'] . "
					</TD>
					<TD class='CEL'>
						" . $rij['firstname'] . "
					</TD>";
        for ($i = 1; $i <= 20; $i++)
        {
            $data.="<TD class='CEL'>&nbsp;</TD>";
        }
        $data.="</TR>";
    }
    $data.="</TABLE>
		</BODY>
	</HTML>";
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: html/text; charset=UTF-8');
    header("Content-Disposition: attachment; filename=lijst(" . substr($selectie, 0, -1) . ").xls");
    //  header
    header("Pragma: no-cache");
    header("Expires: 0");
    //   header("")
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
    echo '		<style type="text/css">
			body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
			TD.CEL       {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: NORMAL; border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; }
			TD.KOLOMKOP  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000;}
			TD.KOLOMKOP1  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: none;border-bottom: 1px solid #000000; padding-left: 3px;}
			TD.KOLOMKOP2  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: none ;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; padding-left: 3px;}
			TABLE        {border-left: 2px solid #000000;border-top: 2px solid #000000;border-right: 2px solid #000000;border-bottom: 2px solid #000000;}
		</style>';
    echo '<table  width=100% ALIGN="center" CELLSPACING=0 BORDER=1 CELLPADDING=0>
		   <TR> 
		    <TD class="KOLOMKOP1" COLSPAN=3 Height=25> 
			    Klas(sen): ' . $selectie . '

		    </TD>
		    <TD class="KOLOMKOP2" COLSPAN=20 ALIGN=RIGHT> 
			    Schooljaar: ' . $academicYear . '
		    </TD>
		  </TR> 
		 <TR> 
		   <TD Class="KOLOMKOP" WIDTH="25" VALIGN=BOTTOM Height=150> 
			    Nr 
		   </TD>
   		   <TD Class="KOLOMKOP" WIDTH="200" VALIGN=BOTTOM> 
			    Naam
		   </TD>
		   <TD Class="KOLOMKOP" WIDTH="100" VALIGN=BOTTOM> 
			    Voornaam
		   </TD>';

    for ($i = 1; $i <= 20; $i++)
    {
        echo "<TD class='KOLOMKOP'>&nbsp;</TD>";
    }

    echo ' </TR>';
    // de rijen opsturen.
    print $data;
    echo '</table>';
}
?>