<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  This is a studentlist to excell Export utility.
  ==============================================================================
 */
/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $classes = campus::get_studentclasses(8);
    // Query van het gegevensbestand....
    $query = "SELECT `display_order`, `lastname`, `firstname`, `official_code`, `birth`, `group_group`.`code`
            FROM `user_user`
              INNER JOIN `campus_user`
                   ON `user_user`.`id` = `campus_user`.`user_id`
                INNER JOIN `group_group_rel_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                INNER JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
    $filter = "";
    foreach ($classes as $key => $value)
    {

        $filter.="`group_group_rel_user`.`group_id`=" . $key . " OR ";
    }
    $sql = $query . substr($filter, 0, -3) . " ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    $result = mysql_query($sql);

    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */

    $data = "";
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $data.="<tr>
					<td class=\"text\">" . $rij['lastname'] . "</td><td class=\"text\">" . $rij['firstname'] . "</td><td class=\"datum\">" . DatetimeUtilities::format_locale_date('%d/%m/%Y', strtotime($rij['birth'])) . "</td><td class=\"text\">" . $rij['official_code'] . "</td><td class=\"text\">" . $rij['code'] . "</td><td class=\"text\">" . $rij['display_order'] . "</td>
			</tr>";
    }
    mysql_close($dbdokeos);
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: html/text; charset=UTF-8');
    header("Content-Disposition: attachment; filename=klas.xls");
    header("Pragma: no-cache");
    header("Expires: 0");
    //   header("")
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
   echo '<style>.text  { mso-number-format:\@; }.datum  { mso-number-format:"dd\\\.mm\\\.yyyy"; }</style>
		<table cellspacing="0" rules="all" border="1" id="export" style="border-collapse:collapse;">
		   <tr> 
	 		<td>Naam</td><td>Voornaam</td><td>Geboortedatum</td><td>Stamnummer</td><td>Klas</td><td>Klasnummer</td>
		  </tr> ';

    // de rijen opsturen.
    print $data;
    echo '  </table>';
}
?>
