<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;

/*
  ==============================================================================
  This is an disciplindeagena to PDF export utility
  ==============================================================================
 */
/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */
//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $select = intval(campus::get_POST_GET("select"));
    if ($select > 0)
    {
        // Query van het gegevensbestand....
        $sql = "SELECT DISTINCT `lastname`, `firstname`, `official_code`, `email`, `address`, `phone`, `code`
            FROM `campus_department_rel_group`
                INNER JOIN `group_group`
                   ON `campus_department_rel_group`.`group_id` = `group_group`.`id`
                INNER JOIN `group_group_rel_user`
                   ON `campus_department_rel_group`.`group_id` = `group_group_rel_user`.`group_id` AND `type`=1
                INNER JOIN `user_user`
                   ON `user_user`.`id`=`group_group_rel_user`.`user_id`
                LEFT JOIN `campus_user`
 	           ON `user_user`.`id` = `campus_user`.`user_id`
               WHERE `group_group_rel_user`.`group_id`=" . $select . " ORDER BY `lastname`,`firstname`";
        $result = mysql_query($sql) or die(mysql_error());
        $data = "Name;email;adres;telefoon\n";
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $group=$rij['code'];
            $data.=$rij['firstname'] . ' ' . $rij['lastname'] . ';' . $rij['email'] . ';' . $rij['address'] . ';' . $rij['phone'] . "\n";
        }
        mysql_close($dbdokeos);
        /*
          -----------------------------------------------------------
          Header
          -----------------------------------------------------------
         */
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=" . "Adreslijst_".$group.".csv");
        header('Content-transfer-encoding: binary');
        header("Pragma: no-cache");
        header("Expires: 0");
        // de rijen opsturen.
        print $data;
    }
}
?>
