<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\DatetimeUtilities;

/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxObjectiveInfo extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);
        campus::connect_db();
        $test = explode(';', $this->get_parameter('sendid'));

        $subfilter = str_replace(',', ') OR (`campus_objective_tracking`.`id`=', $test[1]);
        $newContent = '<b>' . $test[0] . '</b><br>';

        $query = 'SELECT DISTINCT `campus_objective_tracking`.`id`, `name`, `comment`, `date` FROM `campus_objective_tracking`
        INNER JOIN `campus_objective_tracking_rel_objective`
        ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
        WHERE ((`campus_objective_tracking`.`id`=' . $subfilter . '))
        ORDER BY `date`';
        $result = mysql_query($query);

        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $classlist = '';
            $query2 = 'SELECT `group_code` FROM `campus_objective_tracking_rel_group`
                    WHERE `objective_tracking_id`=' . $rij['id'] . ' ORDER BY `group_code`';
            $result2 = mysql_query($query2);
            while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
            {
                $classlist.= $rij2['group_code'] . ', ';
            }
            if ($classlist == ', ')
            {
                $selectclasses = ' - ';
            }
            else
            {
                $selectclasses = '(' . substr($classlist, 0, -2) . ')';
            }

            $title = DatetimeUtilities::format_locale_date('%A %d %B %Y', $rij['date']) . ' ' . htmlentities($rij['name']);
            //$newContent .= '<a href="'.'page=viewobjectivetracking&objective_tracking_id=' . $rij['id'] . '" title="' . $title . ' ' . $selectclasses . '">';
            $newContent .='<i>';
            if (strlen($title) > 80)
            {
                $newContent .= substr($title, 0, 50);
                $rest = '...)';
            }
            else
            {
                $newContent .=$title;
                $len = ( 80 - strlen($title));
                if (strlen($selectclasses) > $len)
                {
                    $rest = substr($selectclasses, 0, $len) . '...)';
                }
                else
                {
                    $rest = $selectclasses;
                }
            }
            $newContent .= '</i>';
            $newContent .= ' ' . $rest . '<br />';
        }

        $ajax_result->set_property("ajaxid", $newContent);



        $ajax_result->display();
    }

}

?>