<?php

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Application;
use common\libraries\ActionBarRenderer;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\ConditionProperty;
use common\libraries\Utilities;

/**
 * @package application.campus.campus.component
 */

/**
 * Campus component which allows the user to browse the campus application
 * @author Sven Vanpoucke
 * @author Theunis Ludwig
 */
class BrowserComponent extends Manager
{

    function run()
    {
        $this->display_header($trail);

        echo '<div class="clear"></div>';
        echo $this->display_menu();

        echo '<div id="tool_browser_right">';
        //  echo $this->display_campus_tabs();
        echo campus :: Display_departments();
        echo '</div>';


        $this->display_footer();
    }

}

?>