<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
	Display::display_error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$category_id=intval(campus::get_POST_GET("category_id"));

/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/ 
	if ($submitmessage=="")
	{ //
		switch ($action) 
		{
			case "new" :
			{ 
				$category_id="";
				$category="";
				$display="form";
			}
			break;
			case "update" :
			{
				// 
				$query="select * FROM `campus_it_defect_category` WHERE `id`=".$category_id." LIMIT 1";
				$result = mysql_query($query) ;
				while (list($category_id, $category)= mysql_fetch_row($result))
				{
					break;
				}
				$display="form";
			}
			break;
			case "delete" :
			{
				// 
				$result=mysql_query("DELETE FROM `campus_it_defect_category` WHERE `id`=".$category_id." ");
				$message = get_lang("msgItemDeleted");
				$display="list";
			}
			break;
			default :
			{
				$display="list";
			}
			break;
		}
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				$query="INSERT 
						`campus_it_defect_category` SET
						`category`='".campus::get_POST_GET("category")."' ";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
				}
				else
				{
					$category_id=mysql_insert_id();
					$message = get_lang("msgItemAddSucces");
				}
				$display="list";
			}
			break;
			case "update" :
			{ 
				$query="UPDATE 
						`campus_it_defect_category` SET
						`category`='".campus::get_POST_GET("category")."'
					WHERE `id`='".$category_id."'
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
				}
				$display="list";
			}
			break;
		}
	}
/*
============================================================================== 
		display ...
============================================================================== 
*/
	if (!empty($message))
	{		
		Display::normal_message($message);
	}
	switch ($display)
	{
		case "form" :
		{ 
// ===============================================================
// diplay Resource form.........
// ===============================================================
			echo "<b>".get_lang('titleeditITdefectcategorys')."</b><br>";
	
			echo '<form method="post" action="'.$this->get_url().'" name="myform">
				<input type="hidden" name="page" value="ITdefectcategorys" >
		    		<input type="hidden" name="category_id" value="'.$category_id.'" >
		    		<input type="hidden" name="action" value="'.$action.'" >
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
							'.get_lang('labelDefectCategory').'
						</td>
						<td>
							<input type="text" name="category" size="32" maxlength="50" value="'.$category.'" />
							<br />
						</td>
					</tr>
					<tr valign="top">
						<td>
						</td>
						<td>
							<input type="submit" name="submitmessage" value="'.get_lang("buttonlabelOK").'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'list\';">
						</td>
					</tr>
				</table>
				</form>';
		}
		break;
		case "list" :
		{ 
		// ===============================================================
		// lokaallijst weergeven........
		// ===============================================================
			$query="SELECT `id`,`category` FROM `campus_it_defect_category` ORDER BY `category` ";
			$result = mysql_query($query) ;
			echo '<div >';
			echo '<a href="'.$this->get_url().'&page=ITdefectcategorys&action=new">'.get_lang("txtAddDefectCategory").'</a>';
			echo '</div>';
			campus::display_complex_table_header($properties, array(get_lang("colheadDefectCategory"),""));
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$data=array();
				$data[]=$rij['category'];
				$data[]='&nbsp;<a href="'.$this->get_url().'&page=ITdefectcategorys&category_id='.$rij['id'].'&action=update" title="'.get_lang("tooltipEditDefectCategory").'"><img src="'.  Theme::get_image_path('application\campus').'edit.gif" border=0 align="absmiddle" /></a>'.
					  		'&nbsp;<a href="'.$this->get_url().'&page=ITdefectcategorys&category_id='.$rij['id'].'&action=delete" onclick="javascript:if(!confirm(\''.get_lang("msgboxConfirmDeleteDefectCategory").'\')) return false;" title="'.get_lang("tooltipDeleteDefectCategory").'"><img src="'.Theme::get_image_path('application\campus').'delete.gif" border=0 align="absmiddle"/></a>';
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
		}
	}
}
?>