<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\ResourceManager;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['IT']) && ! $is_platformadmin))
{
    Display::normal_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
    $departmentStruc = campus::get_department($_uid);
    // get rights of user in campus plugin .....
    $admin = campus::get_rights($_uid, $department_id);
    $action = campus::get_POST_GET('action');
    $submitmessage = campus::get_POST_GET('submitmessage');




    //check if file is included...
    echo '<div class="maincontent" id="content">';

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // initiatisatie van de variabelen die via POST of GET worden mee gezonden
    $action = campus::get_POST_GET('action', 'list');
    $device_id = campus::get_POST_GET('device_id');
    $filter = intval(campus::get_SESSION('filter', 0));
    $filterresourceid = intval(campus::get_SESSION('filterresourceid'));



    /*
   -----------------------------------------------------------
   Specials
   -----------------------------------------------------------
  */
    //echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.ui.min.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_itadmin_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/dialog.css');
    //echo ResourceManager :: get_instance()->get_resource_html('http://code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css');

    if ($action == 'delete')
    {
        // delete device..
        $result = mysql_query("DELETE FROM `campus_it_device` WHERE `id`=" . $device_id . " ");
        // delete device relations to media and software...
        $result = mysql_query("DELETE FROM `campus_it_device_rel_info` WHERE `device_id`=" . $device_id . " ");
        if ($result)
        {
            $message = get_lang('msgItemDeleted');
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (! empty($message))
    {
        Display::normal_message($message, false);
    }

    // ---------------------------------- lijst (TONEN) --------------------------------
    echo '<form ACTION="' . $this->get_url() . '" METHOD="POST" NAME="myform" STYLE="display: inline;float: right;">
		<input type="hidden" name="action" value="' . $action . '">
		<input type="hidden" name="page" value="ITdevicelist">
 	    	<b>' . get_lang('txtFilter') . ':</b>&nbsp;&nbsp;
      		<select name="filter" STYLE="width:250px;" OnChange="javascript:myform.submit();">';
    $subquery = "SELECT `id`,`info` FROM `campus_it_device_info` WHERE `category_id`=0 ORDER BY `display_order`";
    $subresult = mysql_query($subquery);
    while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
    {
        echo "<option value='" . $rij['id'] . "' " . (($rij['id'] == $filter) ? 'SELECTED' : '') . ">" . $rij['info'] .
            "</option>";
    }
    echo '	    <option value="0" ' . (($filter == 0) ? 'SELECTED' : '') . '>' . get_lang('txtComplete') . '</option>
		</select>
 		<select name="filterresourceid" style="width:180px;display: inline;" OnChange="myform.submit();" >
			<option value="0">' . get_lang('txtSelectResource') . '</option>';
    $query = "SELECT DISTINCT `campus_resource`.`id`,`campus_resource`.`code` FROM `campus_resource` ";
    $query .= "INNER JOIN `campus_it_device` ON `campus_it_device`.`resource_id`=`campus_resource`.`id` ";
    $query .= "WHERE `campus_resource`.`department_id`=" . $department_id . " ORDER BY `campus_resource`.`code`";
    $result = mysql_query($query);
    while (list($id, $resourcecode) = mysql_fetch_row($result))
    {
        echo "<option value='" . $id . "' " . (($filterresourceid == $id) ? "selected" : "") . ">" . $resourcecode .
            "</option>";
    }
    echo '</select></form>';
    echo '<div >';
    echo '<a href="' . $this->get_url() . '&page=editITdevices&action=new">' . get_lang("txtAddITDevice") . '</a>';
    echo '&nbsp;|&nbsp;<a href="' . $this->get_url() . '&page=importIT">' . get_lang("txtImportITDevice") . '</a>';
    echo '&nbsp;|&nbsp;<a href="' . $this->get_url() . '&page=computers2csv">' . get_lang('txtExport2Csv') . '</a>';
    echo '</div>';
    echo '<div id="campus_dialog"></div>';

    $query =
        "SELECT DISTINCT t1.`id` as device_id, t1.`code`, t5.`info` as device_type, t3.`info` as name, t1.`comment`, `state`,  `campus_resource`.`code` as room, t1.`resource_id` ";
    $query .= "FROM `campus_it_device` as t1 ";
    $query .= 'LEFT JOIN `campus_resource` ON t1.`resource_id` = `campus_resource`.`id` ';
    //get device name
    $query .= 'LEFT JOIN (`campus_it_device_rel_info` as t2
                    INNER JOIN `campus_it_device_info` as t3 ON t3.`id`= t2.`info_id`) ON t2.`device_id`=t1.`id` AND t3.`category_id`=t1.`type`  ';
    // get device type text
    $query .= 'LEFT JOIN `campus_it_device_info` as t5 ON t5.`id`=t1.`type` AND t5.`category_id`=0';
    if ($filter > 0)
    {
        $query .= " WHERE `type`=" . $filter . " AND ";
    }
    else
    {
        $query .= " WHERE ";
    }
    $query .= ($filterresourceid != 0) ? (" t1.`resource_id` = " . $filterresourceid . " AND ") : "";
    $query .= " t1.`department_id`=" . $department_id . " ORDER BY `room` ASC, `code`, `device_id`";
    $result = mysql_query($query) or die(mysql_error());
    $previous = "";
    campus::display_complex_table_header(
        $properties, array(
            get_lang("colheadInventory"), get_lang("colheadID"), get_lang("colheadITDeviceType"), get_lang("colheadIT"),
            get_lang("colheadComment"), get_lang("colheadStatus"), ""
        )
    );
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $data = array();
        $data[] = $rij['device_id'];
        $data[] = '<div class="campus_show_dialog"  device_id="' . $rij['device_id'] . '" dialog_title="'
            . $rij['code'] . '">' . $rij['code'] . '</div>';
        $data[] = $rij['device_type'];
        $data[] = $rij['name'];
        $data[] = $rij['comment'];
        $data[] = get_lang('devicestate_' . $rij['state']);
//		$data[]=$rij['identification'];

        if ($previous <> $rij['room'])
        {
            $room = "<a href='" . $this->get_url() . "&resource_id=" . $rij['resource_id'] . "' title='" .
                get_lang("tooltipShow") . " " . $rij['room'] . "'>" . $rij['room'] . "</a>";
            campus::display_table_row("bgcolor='gray'", array("", $room, "-", "-", "-", "-", "-"), true);
        }
        $previous = $rij['room'];
        $data[] = '<a href="' . $this->get_url() . '&page=editITdevices&device_id=' . $rij['device_id'] .
            '&action=edit" title="' . get_lang('tooltipEditDevice') . '"><img src="' .
            Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" ></a>'
            . '&nbsp;<a href="' . $this->get_url() . '&page=ITdevicelist&device_id=' . $rij['device_id'] .
            '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteDevice') .
            '\')) return false;" title="' . get_lang('tooltipDeleteDevice') . '"><img src="' .
            Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a>';
          campus::display_table_row("", $data, true);
    }
    campus::display_table_footer();

    echo '</div>';
}
?>