<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

$_uid=campus::get_userid_from_session ();
$is_platformadmin = $_SESSION["is_platformAdmin"];
$department_id=intval($_SESSION['_campus']['department_id']);
$admin=campus::get_rights($_uid,$department_id);
$allowed=((isset($admin['IT']) && $admin['IT'])||$is_platformadmin);


// array van de verschillende tabellen...
$query ='SELECT t1.`id`, t1.`code` as computer_id, t1.`comment` as opmerking, t2.`info`as type, `campus_resource`.`code` as lokaal, t3.`info` as toestel, t5.`info` as moederbord, t6.`info` as processor, t7.`info` as geheugen, t8.`info` as grafisch, t10.`info` as `os`, t11.`info` as `netwerk`,  t12.`info` as `antivirus`, t13.`info` as `illusion`, t14.`info` as `gebruik`, t15.`info` as `soort`, t17.`info` as `licentie`, FROM_UNIXTIME(`purchase_date`, \'%Y-%m-%d\') as datum,`purchase_info` as factuur ';
$query.='FROM `campus_it_device` t1 ';
$query.='LEFT JOIN `campus_resource` ON t1.`resource_id` = `campus_resource`.`id` ';
$query.='LEFT JOIN `campus_it_device_info` t2 ON t2.`id` = t1.`type` AND t2.`category_id`=0 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t3b INNER JOIN `campus_it_device_info` as t3 ON t3.`id`= t3b.`info_id`) ON t3b.`device_id`=t1.`id` AND t3.`category_id`=t1.`type`  ';
  
//$query.="LEFT JOIN (SELECT t3b.`option` as `status`, t3a.`device_id` FROM `".$campusDb."`.`campus_IT_device_rel_option` t3a INNER JOIN `".$campusDb."`.`campus_IT_field_options` t3b ON t3a.`option_id` = t3b.`option_id` AND t3b.`type_id`=2) as t3 USING (`device_id`) ";

//$query.="LEFT JOIN (SELECT t4b.`option` as `toestel`, t4a.`device_id` FROM `".$campusDb."`.`campus_IT_device_rel_option` t4a INNER JOIN `".$campusDb."`.`campus_IT_field_options` t4b ON t4a.`option_id` = t4b.`option_id` AND (t4b.`type_id`=3 OR t4b.`type_id`=4 OR t4b.`type_id`=5 OR t4b.`type_id`=6 OR t4b.`type_id`=7 OR t4b.`type_id`=8 OR t4b.`type_id`=9)) as t4 USING (`device_id`) ";
$query.='LEFT JOIN (`campus_it_device_rel_info` as t5b INNER JOIN `campus_it_device_info` as t5 ON t5.`id` = t5b.`info_id`) ON t5b.`device_id`=t1.`id` AND t5.`category_id`=11 ';
//$query.="LEFT JOIN (SELECT t5b.`option` as `moederbord`, t5a.`device_id` FROM `".$campusDb."`.`campus_IT_device_rel_option` t5a INNER JOIN `".$campusDb."`.`campus_IT_field_options` t5b ON t5a.`option_id` = t5b.`option_id` AND t5b.`type_id`=11) as t5 USING (`device_id`) ";
$query.='LEFT JOIN (`campus_it_device_rel_info` as t6b INNER JOIN `campus_it_device_info` as t6 ON t6.`id` = t6b.`info_id`) ON t6b.`device_id`=t1.`id` AND t6.`category_id`=12 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t7b INNER JOIN `campus_it_device_info` as t7 ON t7.`id` = t7b.`info_id`) ON t7b.`device_id`=t1.`id` AND t7.`category_id`=13 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t8b INNER JOIN `campus_it_device_info` as t8 ON t8.`id` = t8b.`info_id`) ON t8b.`device_id`=t1.`id` AND t8.`category_id`=14 ';
//$query.="LEFT JOIN (SELECT t9b.`option` as `netwerkkaart`, t9a.`device_id` FROM `".$campusDb."`.`campus_IT_device_rel_option` t9a INNER JOIN `".$campusDb."`.`campus_IT_field_options` t9b ON t9a.`option_id` = t9b.`option_id` AND t9b.`type_id`=15) as t9 USING (`device_id`) ";
$query.='LEFT JOIN (`campus_it_device_rel_info` as t10b INNER JOIN `campus_it_device_info` as t10 ON t10.`id` = t10b.`info_id`) ON t10b.`device_id`=t1.`id` AND t10.`category_id`=17 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t11b INNER JOIN `campus_it_device_info` as t11 ON t11.`id` = t11b.`info_id`) ON t11b.`device_id`=t1.`id` AND t11.`category_id`=10 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t12b INNER JOIN `campus_it_device_info` as t12 ON t12.`id` = t12b.`info_id`) ON t12b.`device_id`=t1.`id` AND t12.`category_id`=27 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t13b INNER JOIN `campus_it_device_info` as t13 ON t13.`id` = t13b.`info_id`) ON t13b.`device_id`=t1.`id` AND t13.`category_id`=26 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t14b INNER JOIN `campus_it_device_info` as t14 ON t14.`id` = t14b.`info_id`) ON t14b.`device_id`=t1.`id` AND t14.`category_id`=20 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t15b INNER JOIN `campus_it_device_info` as t15 ON t15.`id` = t15b.`info_id`) ON t15b.`device_id`=t1.`id` AND t15.`category_id`=21 ';
$query.='LEFT JOIN (`campus_it_device_rel_info` as t17b INNER JOIN `campus_it_device_info` as t17 ON t17.`id` = t17b.`info_id`) ON t17b.`device_id`=t1.`id` AND t17.`category_id`=19 ';

 $query.=' WHERE t1.`department_id`='.$department_id.' ORDER BY `lokaal`';
 
// kolomhoofdingen, weer te geven velden...
$tabelarray=array("device_id"=>"ID", "computer_id"=>"ID", "opmerking"=>"Opmerking", "type"=>"Type","lokaal"=>"Lokaal", "licentie"=>"Licentie", "status"=>"Status","toestel"=>"Toestel", "moederbord"=>"Moederbord", "processor"=>"Processor", "geheugen"=>"Geheugen", "grafisch"=>"Beeldschermkaart", "os"=>"Operatingsystem", "datum"=>"Datum", "netwerk"=>"Netwerk", "antivirus"=>"Antivirus", "illusion"=>"Illusion");
 $sorteer=" ";
 $result2=mysql_query($query);
 $velden=mysql_fetch_array($result2,MYSQL_ASSOC) or die (mysql_error());
 $result=mysql_query($query);
 $aantal=mysql_num_rows($result); 
 $n=0;
	header('Content-Type: application/vnd.ms-excel'); 
	header("Content-Disposition: attachment; filename=Computers.xls"); 
	header("Pragma: no-cache"); 
	header("Expires: 0"); 
echo '
  <style type="text/css">
   body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
   PRE            {text-decoration: none; color : #000000;font-family: arial, Helvetica, sans-serif;font-size: 15px; width:690px; }
   TD.BORDER      {border: 1px #000000 solid; }
  </style>
 <TABLE WIDTH="" ALIGN="CENTER" CELLSPACING="0" BORDER="0" CELLPADDING="0">
  <TR>'; 
foreach ($velden as $key=>$value) 
{
	//velden die niet in de selectielijst staan worden niet weergegeven...
	echo '<TD CLASS="BORDER" >'.(!empty($tabelarray[$key])?$tabelarray[$key]:$key).'</TD>';
} 
echo '</TR>';
while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
{
	echo '<TR>';
	foreach ($velden as $key=>$value) 
	{
		//velden die niet in de selectielijst staan worden niet weergegeven...
            
    		echo '<TD CLASS="BORDER">'.$rij[$key].'</TD>';
	}
}
echo '</TR>';
echo '</TABLE>';
echo '</BODY>';
echo '</HTML>';
mysql_close($dbvti);
 ?>
