<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $category_id = intval(campus::get_POST_GET("category_id"));

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //
        switch ($action)
        {
            case "new" :
                {
                    $category_id = "";
                    $category = "";
                    $readonly = 1;
                    $multiple = 0;
                    $type = 0;
                    $display = "form";
                }
                break;
            case "update" :
                {
                    //
                    $query = "select `id`, `category`, `readonly`, `system`, `multiple`, `type`, `display_order` FROM `campus_it_device_info_category` WHERE `id`=" . $category_id . " LIMIT 1";
                    $result = mysql_query($query);
                    while (list($category_id, $category, $readonly, $system, $multiple, $type) = mysql_fetch_row($result))
                    {
                        break;
                    }
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    //
                    $result = mysql_query("DELETE FROM `campus_it_device_info_category` WHERE `id`=" . $category_id . " ");
                    $result = mysql_query("DELETE FROM `campus_it_device_rel_info`,`campus_device_info` WHERE `campus_it_device_rel_info`.`info_id`=`campus_it_device_info`.`info_id` AND `campus_it_device_info`.`category_id`=" . $category_id . " ");
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_it_device_info_category`  ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $category_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info_category` SET
								`display_order`=' . $line . ' WHERE `display_order`=' . ($line - 1) . ' AND `system`=0 '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_it_device_info_category` SET
								`display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info_category` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $display = "list";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_it_device_info_category` ORDER BY `display_order`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $category_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info_category` SET `display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_it_device_info_category` SET `display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = 'SELECT `display_order` FROM `campus_it_device_info_category`
		 					WHERE `system`=0 ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_it_device_info_category` SET
						`category`="' . campus::get_POST_GET("category") . '",
						`readonly`=' . ((campus::get_POST_GET("readonly")) ? 1 : 0) . ',
                                                `system`=0,
                                                `multiple`=' . ((campus::get_POST_GET("multiple")) ? 1 : 0) . ',
                                                `type`=' . intval(campus::get_POST_GET("type")) . ',
                                                `display_order`=' . ($display_order + 1) . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                    }
                    else
                    {
                        $category_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                    }
                    $display = "list";
                }
                break;
            case "update" :
                {
                    $query = 'UPDATE
                            `campus_it_device_info_category` SET
                            `category`="' . campus::get_POST_GET("category") . '",
                            `readonly`=' . ((campus::get_POST_GET("readonly")) ? 1 : 0) . ',
                            `multiple`=' . ((campus::get_POST_GET("multiple")) ? 1 : 0) . ',
                            `type`=' . intval(campus::get_POST_GET("type")) . '
                        WHERE `id`=' . $category_id;
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                    }
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message);
    }
    switch ($display)
    {
        case "form" :
            {
// ===============================================================
// diplay Resource form.........
// ===============================================================

                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="device_info_category" >
		    		<input type="hidden" name="category_id" value="' . $category_id . '" >
		    		<input type="hidden" name="action" value="' . $action . '" >
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
							' . get_lang('labelDeviceInfoCategory') . '
						</td>
						<td>
							<input type="text" name="category" size="32" maxlength="50" value="' . $category . '" />
							<br />
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
							' . get_lang('labelReadonly') . '
						</td>
						<td>
							<input type="checkbox" name="readonly" ' . (($readonly) ? 'checked' : '') . '>
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
							' . get_lang('labelMultiple') . '
						</td>
						<td>
							<input type="checkbox" name="multiple" ' . (($multiple) ? 'checked' : '') . '>
						</td>
					</tr>';
                echo '			<tr valign="top">
						<td  align="right">
							' . get_lang('labelType') . '
						</td>
						<td>
                                                    <select name="type">
                                                       <option value="0" ' . (($type == '0') ? 'SELECTED' : '') . '>' . get_lang("forAllDevices") . '</option>';
                $query='SELECT `id`,`info` FROM `campus_it_device_info` WHERE `category_id`=0 ORDER BY `display_order`';
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo '       <option value="'.$rij['id'].'" ' . (($type == $rij['id']) ? 'SELECTED' : '') . '>' . $rij['info'] . '</option>';

                }
                
                echo '				  </select>
						</td>
					</tr>';
               
                echo '<tr valign="top">
						<td>
						</td>
						<td>
							<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
						</td>
					</tr>
				</table>
				</form>';
            }
            break;
        case "list" :
            {
                $query = "SELECT `campus_it_device_info_category`.`id`,`category`,`readonly`, `system`, `multiple`,`info`,`type` FROM `campus_it_device_info_category`
                                LEFT JOIN `campus_it_device_info`
                                    ON `campus_it_device_info_category`.`type`= `campus_it_device_info`.`id` AND `campus_it_device_info`.`category_id`=0
                            ORDER BY `system` DESC, `campus_it_device_info_category`.`display_order`, `category`";
                $result = mysql_query($query);
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                $first = 1;
                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=device_info_category&action=new">' . get_lang("txtAddDeviceInfoCategory") . '</a>';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadInfoCategory"), get_lang("colheadReadonly"), get_lang("colheadMultiple"),get_lang("colheadType"), ""));
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data[] = $rij['category'];
                    $data[] = ($rij['readonly']) ? "on" : "-";
                    $data[] = ($rij['multiple']) ? "on" : "-";
                    $data[] = $rij['info'];
                    if ($first == 1)
                    {
                        $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                        $first = 0;
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=device_info_category&category_id=' . $rij['id'] . '&action=moveup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=device_info_category&category_id=' . $rij['id'] . '&action=movedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }
                    $data[] = '&nbsp;<a href="' . $this->get_url() . '&page=device_info_category&category_id=' . $rij['id'] . '&action=update" title="' . get_lang("tooltipEditITType") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                            (($rij['system']) ? "" : ('&nbsp;<a href="' . $this->get_url() . '&page=device_info_category&category_id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteITType") . '\')) return false;" title="' . get_lang("tooltipDeleteITType") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"/></a>')) . $link;
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
    }
}
?>