<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $delete = campus::get_POST_GET("delete");

    /*
      -----------------------------------------------------------
      Klasselectie per department....
      -----------------------------------------------------------
     */

    // voor elke department de lijst opstellen om de klas te selecteren.
    // de verschillende klassen die tot een bepaalde department behoren ophalen....
    $classes = campus::get_studentclasses($department_id);

    /*
      -----------------------------------------------------------
      Geselecteerde lijst....
      -----------------------------------------------------------
     */
    if ($delete != "true")
    {
        $message = get_lang("msgClearClasses1") . $departmentStruc[$department_id]['code'] . ",<br>";
        $message.= get_lang("msgClearClasses2");
        $message.= "<a href=\"" . $this->get_url() . "&page=clearclasses&delete=true\">" . get_lang("txtYes") . "</a>";
    }
    else
    {
        // while clearing classes display report....
        echo "<p><u><b>" . get_lang("txtClearClassReport") . "</b></u></p>";
        foreach ($classes as $classid => $classarray)
        {
            echo get_lang("labelClass") . " " . $classarray['code'] . "<br>";
            $sql = "SELECT `user_id` FROM `group_group_rel_user`
    				WHERE  `group_id` = " . $classid . " ";
            $result = mysql_query($sql);
            while (list($user_id) = mysql_fetch_row($result))
            {
                $result4 = mysql_query("UPDATE `user_user` SET `active`=0 WHERE `id`=" . $user_id);
            }
            echo "<br>" . get_lang("msgUser2StudentPool") . "<br>" . get_lang("msgUserDeActivated") . "<br>";
            $sql = "DELETE FROM `group_group_rel_user` WHERE  `group_id` = " . $classid . "";
            $result = mysql_query($sql);
            echo get_lang("msgUsrDelFromClass") . "<br>";
            // If you want to delete the classes from the course you have to uncomment the folowing lines.
            // the theachers then have to newly add the classes to them courses!!!
            //$sql = "DELETE FROM `".$_configuration['main_database']."`.`course_rel_class` WHERE  `class_id` = ".$classid."";
            //$result = mysql_query($sql);
            //echo get_lang("msgUsrDelClass")."<br>";
            echo"<br>";
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::warning_message($message, false);
    }
}
?>