<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    $formSent = intval(campus::get_POST_GET("formSent"));
    $message = '';
    $item = campus::get_POST_GET("item", 1);

    if ($_POST['formSent'])
    {
        $User2Sub = campus::get_POST_GET("User2Sub");
        $User2Unsub = campus::get_POST_GET("User2Unsub");
        if (!is_array($User2Sub))
        {
            $User2Sub = array();
        }

        if (!is_array($User2Unsub))
        {
            $User2Unsub = array();
        }
        if ($formSent == 1)
        {
            if (!sizeof($User2Sub))
                $message = get_lang("msgAtLeastOneUser2Subscribe");
            else
            {
                $query1 = "INSERT IGNORE INTO `campus_rights` (user_id,department_id,item) VALUES";

                foreach ($User2Sub as $enreg_user)
                {
                    $query1.="(" . $enreg_user . "," . $department_id . "," . $item . "),";
                }

                $query1 = substr($query1, 0, -1);

                mysql_query($query1);
            }
        }

        // formsent=2: unsubscribe users selected in array $User2Unsub of current department
        if ($formSent == 2)
        {
            if (!sizeof($User2Unsub))
                $message = get_lang("msgAtLeastOneUser2Unsubscribe");
            else
            {
                $query1 = "DELETE FROM `campus_rights` WHERE";

                foreach ($User2Unsub as $enreg_user)
                {
                    $query1.=" (department_id=" . $department_id . " AND user_id=" . $enreg_user . " AND item=" . $item . ") OR";
                }
                $query1 = substr($query1, 0, -3);
                mysql_query($query1);
            }
        }

        if (sizeof($User2Sub))
        {
            $subscribe_users = $User2Sub;
        }

        if (sizeof($User2Unsub))
        {
            $unsubscribe_users = $User2Unsub;
        }
    }

    if (empty($subscribe_users))
    {
        $subscribe_users = array();
    }
    elseif (!is_array($subscribe_users))
    {
        $subscribe_users = explode(',', $subscribe_users);

        foreach ($subscribe_users as $key => $enreg)
        {
            $subscribe_users[$key] = intval($enreg);
        }
    }
    else
    {
        foreach ($subscribe_users as $key => $enreg)
        {
            $subscribe_users[$key] = intval($enreg);
        }
    }
    if (empty($unsubscribe_users))
    {
        $unsubscribe_users = array();
    }
    elseif (!is_array($unsubscribe_users))
    {
        $unsubscribe_users = explode(',', $unsubscribe_users);

        foreach ($unsubscribe_users as $key => $enreg)
        {
            $unsubscribe_users[$key] = intval($enreg);
        }
    }
    else
    {
        foreach ($unsubscribe_users as $key => $enreg)
        {
            $unsubscribe_users[$key] = intval($enreg);
        }
    }

    $result = mysql_query("SELECT `campus_rights`.`user_id` as id, concat(concat(`lastname`,' ') , `firstname`) as 'usern', `official_code` FROM `campus_rights`
												LEFT JOIN `user_user`
												ON `campus_rights`.`user_id` = `user_user`.`id`
												WHERE `campus_rights`.`department_id` = '" . $department_id . "' AND `campus_rights`.`item`='" . $item . "' ORDER by `lastname`,`firstname`");
    //ORDER BY ".(sizeof($subscribe_users)?"(id IN(".implode(',',$subscribe_users).")) DESC,":"")." name LIMIT 0,1000");

    $db_unsubscribe_users = api_store_result($result);

    $selected_users = "0";
    foreach ($db_unsubscribe_users as $enreg)
    {
        $selected_users.="," . $enreg['id'];
    }

    $query = "SELECT DISTINCT `user_user`.`id`, concat(concat(`lastname`,' ') , `firstname`) as 'usern', `official_code` FROM `user_user`
						LEFT JOIN `group_group_rel_user`
							ON `user_user`.`id` =  `group_group_rel_user`.`user_id`
						LEFT JOIN `campus_department_rel_group`
							ON `group_group_rel_user`.`group_id` =  `campus_department_rel_group`.`group_id` AND `type`=1
						WHERE `campus_department_rel_group`.`department_id` = " . $department_id . " AND `user_user`.`id` NOT IN($selected_users) ORDER by `lastname`,`firstname`";
    $result = mysql_query($query);

    $db_subscribe_users = api_store_result($result);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    echo '<form name="formulaire" method="post" action="' . $this->get_campus_admin_url() . '" style="margin:0px;">
		<input type="hidden" name="formSent" value="1">
		<input type="hidden" name="page" value="editcampusrights" >
		<table border="0" cellpadding="5" cellspacing="0" width="100%">
		 <tr>
		  <td colspan="3" >';
    echo '     <select name="item" onchange="javascript:document.formulaire.formSent.value=\'3\'; document.formulaire.submit();">';
    for ($i = 1; $i <= 12; $i++)
    {
        echo '<option value="' . $i . '" ' . (($i == $item) ? 'SELECTED' : '') . '>' . get_lang('enumValue_rights_' . $i) . '</option>';
    }
    echo '     </select>';
    echo '    </td>
	         </tr>
		 <tr>
		  <td width="40%" align="center">
		   <b>' . get_lang('txtAvailableTeachers') . '</b><br><br>
		  </td>
		  <td width="20%">&nbsp;</td>
		  <td width="40%" align="center">
		   <b>' . get_lang('txtSelectedTeachers') . '</b><br><br><br>
		  </td>
		 </tr>
		 <tr>
		  <td width="40%" align="center">
		   <select name="User2Sub[]" multiple="multiple" size="20" style="width:230px;">';
    foreach ($db_subscribe_users as $enreg)
    {
        echo '<option value="' . $enreg['id'] . '" ' . (((!$formSent && in_array($enreg['id'], $subscribe_users)) || ($formSent && in_array($enreg['id'], $User2Sub))) ? '"selected"' : '') . '>' . $enreg['usern'] . ' (' . $enreg['official_code'] . ')</option>';
    }
    unset($db_subscribe_users);
    echo '     </select>
		  </td>
		  <td width="20%" valign="middle" align="center">
		   <input type="submit" onmousedown="javascript:document.formulaire.formSent.value=\'1\';" value="' . get_lang('buttonlabelAdd2Supervisors') . '"><BR><BR>
		   <input type="submit" onmousedown="javascript:document.formulaire.formSent.value=\'2\';" value="' . get_lang('buttonlabelRemoveFromSupervisors') . '">
		  </td>
		  <td width="40%" align="center">
		   <select name="User2Unsub[]" multiple="multiple" size="20" style="width:230px;">';
    foreach ($db_unsubscribe_users as $enreg)
    {
        echo '<option value="' . $enreg['id'] . '" ' . ((($formSent && in_array($enreg['id'], $unsubscribe_users)) || ($formSent && in_array($enreg['id'], $User2Unsub))) ? '"selected"' : '') . '>' . $enreg['usern'] . ' (' . $enreg['official_code'] . ')</option>';
    }
    unset($db_unsubscribe_users);
    echo '     </select>
		  </td>
		 </tr>
		</table>
		<input type="submit" name="cancel" value="' . get_lang('buttonlabelBack') . '" onMouseDown="javascript:document.formulaire.page.value=\'\';">
	       </form>';
}

function api_store_result($result)
{
    $tab = array();
    while ($row = mysql_fetch_array($result))
    {
        $tab[] = $row;
    }
    return $tab;
}

?>