<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($admin['roster']) && !$is_platformadmin)) 
{// not allowed here!
	Display::display_error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$list_id=intval(campus::get_POST_GET("list_id"));
	$constant_id=intval(campus::get_POST_GET("constant_id"));

/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/ 
	if ($submitmessage=="")
	{ //
		// de scholen ophalen waar de gebruiker deel van uitmaakt.
		switch ($action) 
		{
			case "new" :
			{ 
				$list_id="";
				$name="";
				$display="form";
			}
			break;
			case "newconstant" :
			{ 
				$constant_id="";
				$code="";
				$comment="";
				$display="formconstant";
			}
			break;
			case "update" :
			{
				$query="select * FROM `campus_evaluation_constant_list` WHERE `id`=".$list_id." ";
				$result = mysql_query($query) ;
				list($list_id,$name, $default_id, $department_id)= mysql_fetch_row($result);
				$display="form";
			}
			break;
			case "updateconstant" :
			{
				$query="select * FROM `campus_evaluation_constant` WHERE `id`=".$constant_id." ";
				$result = mysql_query($query) ;
				list($constant_id,$list_id, $code, $comment)= mysql_fetch_row($result);
				$display="formconstant";
			}
			break;
			case "delete" :
			{
				$result=mysql_query("DELETE FROM `campus_evaluation_constant_list` WHERE `id`=".$list_id." ");
				$message = get_lang("msgItemDeleted");
				$display="list";
			}
			break;
			case "deleteconstant" :
			{
				$query="select `list_id` FROM `campus_evaluation_constant` WHERE `id`=".$constant_id." ";
				$result = mysql_query($query) ;
				list($list_id)= mysql_fetch_row($result);
				$result=mysql_query("DELETE FROM `campus_evaluation_constant` WHERE `id`=".$constant_id." ");
				$message = get_lang("msgItemDeleted");
				$display="listconstant";
			}
			break;
			case "showconstants" :
			{
				$display="listconstant";
			}
			break;
			default :
			{
				$display="list";
			}
			break;
			case "moveup" :
			{ // move the selected line in the form list one up
				$query = "SELECT * FROM `campus_evaluation_constant` WHERE `list_id`=".$list_id." ORDER BY `display_order`, `id`";
				$result = mysql_query($query);
				$line=0;
				while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
				{
					$line++;
					if ($rij['id']==$constant_id)
					{
						$result2=mysql_query("UPDATE `campus_evaluation_constant` SET
								`display_order`=".$line." WHERE `list_id`=".$list_id." AND `display_order`=".($line-1)." ");//move previous down..
						$result2=mysql_query("UPDATE `campus_evaluation_constant` SET
								`display_order`=".($line-1)." WHERE `list_id`=".$list_id." AND `id`=".$rij['id']." ");
					}
					else
					{
						$result2=mysql_query("UPDATE `campus_evaluation_constant` SET
								`display_order`=".$line." WHERE `list_id`=".$list_id." AND `id`=".$rij['id']." ");
					}							
				}
				$display="listconstant";
			}
			break;
			case "movedown" :
			{ // move the selected line in the form list one down
				$query = "SELECT * FROM `campus_evaluation_constant` WHERE `list_id`=".$list_id." ORDER BY `display_order`, `id`";
				$result = mysql_query($query);
				$line=0;
				$moveup=0;
				while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
				{
					$line++;
					if ($rij['id']==$constant_id)
					{
						$result2=mysql_query("UPDATE `campus_evaluation_constant` SET
								`display_order`=".($line+1)." WHERE `list_id`=".$list_id." AND `id`=".$rij['id']." ");
						$moveup=-1;//next record move 1 up
					}
					else
					{
						$result2=mysql_query("UPDATE `campus_evaluation_constant` SET
								`display_order`=".($line+$moveup)." WHERE `list_id`=".$list_id." AND `id`=".$rij['id']." ");
						$moveup=0;		
					}							
				}
			
				$display="listconstant";
			}
			break;
		}
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				$query="INSERT 
						`campus_evaluation_constant_list` SET
						`name`='".campus::get_POST_GET("name")."',
						`default_id`='".campus::get_POST_GET("default_id")."',
						`department_id`= ".$department_id."
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
					$display="form";
				}
				else
				{
					$list_id=mysql_insert_id();
					$message = get_lang("msgItemAddSucces");
					$display="list";
				}
			}
			break;
			case "update" :
			{ 
				$query="UPDATE 
						`campus_evaluation_constant_list` SET
						`name`='".campus::get_POST_GET("name")."',
						`default_id`=".campus::get_POST_GET("default_id").",
						`department_id`= ".$department_id."
					WHERE `id`='".$list_id."'
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
					$display="form";
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
					$display="list";
				}
			}
			break;
			case "newconstant" :
			{ 
				$query="INSERT 
						`campus_evaluation_constant` SET
						`list_id`=".$list_id.",
						`code`='".campus::get_POST_GET("code")."',
						`comment`='".campus::get_POST_GET("comment")."'
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
					$display="formconstant";
				}
				else
				{
					$cosntant_id=mysql_insert_id();
					$message = get_lang("msgItemAddSucces");
					$display="listconstant";
				}
			}
			break;
			case "updateconstant" :
			{ 
				$query="UPDATE 
						`campus_evaluation_constant` SET
						`code`='".campus::get_POST_GET("code")."',
						`comment`='".campus::get_POST_GET("comment")."'
					WHERE `id`='".$constant_id."'
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
					$display="formconstant";
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
					$display="listconstant";
				}
			}
			break;
		}
	}
/*
============================================================================== 
		display ...
============================================================================== 
*/
	if (!empty($message))
	{		
		Display::normal_message($message);
	}
	switch ($display)
	{
		case "form" :
		{ 
			echo '<form method="post" action="'.$this->get_url().'" name="myform">
		 	 	 <input type="hidden" name="page" value="editconstantlist" >
				 <input type="hidden" name="list_id" value="'.$list_id.'" >
				 <input type="hidden" name="department_id" value="'.$department_id.'" >
				 <input type="hidden" name="action" value="'.$action.'" >
		 		 <table>
				  <tr valign="top">
				   <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelName').':
				  </td>
				  <td>
				   <input type="text" name="name" size="8" maxlength="16" value="'.$name.'" />
					<br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelDefaultValue').':
				</td>
				<td>';
			if ($list_id!=0)
			{
				$query2="SELECT * FROM `campus_evaluation_constant` WHERE `list_id`=".$list_id." "; 
				$result2 = mysql_query($query2);
				echo "<select name='default_id'>";
				while ($rij2=mysql_fetch_array($result2,MYSQL_ASSOC))
				{
					echo '<option value="'.$rij2['id'].'" '.(($rij2['id']==$default_id)?'selected':'').'>'.$rij2['code'].'</option>';
				}
				echo "</select>";
			}
			else
			{
				echo "<b style='color: #999;'>".get_lang("txtFirstAddConstants2SetDefault")."</b>";
			}
			echo '   </td>
			        </tr>
			        <tr valign="top">
				 <td>
				 </td>
				 <td>
				  <input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'constantlist\';">
				</td>
			       </tr>
			      </table>
			     </form>';
		}
		break;
		case "formconstant" :
		{ 
			echo '<form method="post" action="'.$this->get_url().'" name="myform">
  	 			<input type="hidden" name="page" value="editconstantlist" >
			        <input type="hidden" name="list_id" value="'.$list_id.'" >
	 			<input type="hidden" name="constant_id" value="'.$constant_id.'" >
	 			<input type="hidden" name="action" value="'.$action.'" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelCode').':
				  </td>
				  <td>
				   <input type="text" name="code" size="8" maxlength="16" value="'.$code.'" />
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelComment').':
				  </td>
				  <td>
				   <input type="text" name="comment" size="32" maxlength="255" value="'.$comment.'" />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td>
				   <input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'showconstants\';">
				  </td>
				 </tr>
				</table>
			       </form>';
		}
		break;
		case "list" :
		{ 
		// ===============================================================
		// lokaallijst weergeven........
		// ===============================================================
			$query='SELECT `id`,`name`,`default_id`
  					FROM `campus_evaluation_constant_list`
      					WHERE `department_id`='.$department_id.' ORDER BY `name`';
			$result = mysql_query($query);
                	echo '<div >';
			echo '<a href="'.$this->get_url().'&page=editconstantlist&action=new">'.get_lang("txtAddConstantList").'</a>&nbsp;';
			echo '</div>';
			campus::display_complex_table_header($properties, array(get_lang("colheadConstantList"),get_lang("colheadComment"),""));
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$data=array();
				$data[]=$rij['name'];
				$data[]=$rij['default_id'];
				$data[]='&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&list_id='.$rij['id'].'&action=update"  title="'.get_lang("tooltipEditConstantList").'"><img src="'.Theme::get_image_path('application\campus').'edit.gif" border=0 align="absmiddle"></a>'.
			  		'&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&list_id='.$rij['id'].'&action=delete" onclick="javascript:if(!confirm(\''.get_lang("msgboxConfirmDeleteConstantList").'\')) return false;" title="'.get_lang("tooltipDeleteConstantList").'"><img src="'.Theme::get_image_path('application\campus').'delete.gif" border=0 align="absmiddle">'.
					'&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&list_id='.$rij['id'].'&action=showconstants"  title="'.get_lang("tooltipEditConstants").'"><img src="'.Theme::get_image_path('application\campus').'edit.gif" border=0 align="absmiddle">Constants</a>';
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
		}
		break;
		case "listconstant" :
		{ 
		// ===============================================================
		// lokaallijst weergeven........
		// ===============================================================
			$query='SELECT `id`,`code`,`comment` FROM `campus_evaluation_constant` WHERE `list_id`='.$list_id.' ORDER BY `display_order`';
			$result = mysql_query($query) ;
			echo '<div >';
			echo '<a href="'.$this->get_url().'&page=editconstantlist">'.get_lang("txtConstantList").'</a>&nbsp;|';
			echo '&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&action=newconstant&list_id='.$list_id.'">'.get_lang("txtAddConstant").'</a>';
			echo '</div>';
			campus::display_complex_table_header($properties, array(get_lang("colheadConstant"),get_lang("colheadComment"),""));
			$line=0;
			$nbrLines=mysql_num_rows($result);
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$line++;
				$data=array();
				$data[]=$rij['code'];
				$data[]=$rij['comment'];
				$data[]='&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&constant_id='.$rij['id'].'&action=updateconstant"  title="'.get_lang("tooltipEditConstant").'"><img src="'.Theme::get_image_path('application\campus').'edit.gif" border=0 align="absmiddle"></a>'.
			  		'&nbsp;<a href="'.$this->get_url().'&page=editconstantlist&constant_id='.$rij['id'].'&action=deleteconstant" onclick="javascript:if(!confirm(\''.get_lang("msgboxConfirmDeleteConstant").'\')) return false;" title="'.get_lang("tooltipDeleteConstant").'"><img src="'.Theme::get_image_path('application\campus').'delete.gif" border=0 align="absmiddle">'.
					(($line==1)?'<img src="'.Theme::get_image_path('application\campus').'up_na.gif" border=0 align="absmiddle">':'<a href="'.$this->get_url().'&page=editconstantlist&constant_id='.$rij['id'].'&list_id='.$list_id.'&action=moveup"><img src="'.Theme::get_image_path('application\campus').'up.gif" border=0 align="absmiddle"></a>').
					(($line == $nbrLines)?'<img src="'.Theme::get_image_path('application\campus').'down_na.gif" border=0 align="absmiddle">':'<a href="'.$this->get_url().'&page=editconstantlist&constant_id='.$rij['id'].'&list_id='.$list_id.'&action=movedown"><img src="'.Theme::get_image_path('application\campus').'down.gif" border=0 align="absmiddle"></a>');
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
		}
	}
}
?>