<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $objective_curriculum_id = intval(campus::get_POST_GET('objective_curriculum_id'));
    $objective_id = intval(campus::get_POST_GET('objective_id'));
    $action = campus::get_POST_GET('action', 'objectivecurriculumlist');
    $submitmessage = campus::get_POST_GET('submitmessage');
    $groups = campus::get_studentclasses($department_id);
    $selectgroups = campus::get_POST_GET('groups');
    $objective = campus::get_POST_GET('objective');
    $objective_group = campus::get_POST_GET('objective_group');
    $name = campus::get_POST_GET('name');
    $code = campus::get_POST_GET('code');
    $comment = campus::get_POST_GET('comment');

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == '')
    { //
        switch ($action)
        {
            case 'addobjectivecurriculum' :
                {
                    $name = '';
                    $code = '';
                    $comment = '';
                }
                break;
            case 'editobjectivecurriculum' :
                {
                    // read data
                    $query = "SELECT `id`, `name`,`code`, `comment`, `type`  FROM `campus_objective_curriculum`
 						WHERE `id`=" . $objective_curriculum_id . " "; //***
                    $result = mysql_query($query);
                    list($objective_curriculum_id, $name, $code, $comment, $type) = mysql_fetch_row($result); //***
                    $query = "SELECT `campus_objective_curriculum_rel_group`.`group_id` FROM `campus_objective_curriculum_rel_group`
 					INNER JOIN  `campus_department_rel_group` ON `campus_objective_curriculum_rel_group`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`= 2
				WHERE `department_id`=" . $department_id . " AND `objective_curriculum_id`=" . $objective_curriculum_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['group_id'];
                    }
                    $selectgroups = implode(';', $array);
                }
                break;
            case "deleteobjectivecurriculum" :
                {

                    // delete all links from objective_view
                    $result = mysql_query('DELETE `campus_objective_view`, `campus_objective_view_rel_assignment`, `campus_objective_view_rel_class`,`campus_objective_view_rel_objective`
                                                FROM `campus_objective_curriculum`
                                                  INNER JOIN `campus_objective_view`
                                                    ON `campus_objective_curriculum`.`id`= `campus_objective_view`.`objective_curriculum_id`
                                                  INNER JOIN `campus_objective_view_rel_assignment`
                                                    ON `campus_objective_curriculum`.`id`= `campus_objective_view_rel_assignment`.`objective_curriculum_id`
                                                  INNER JOIN `campus_objective_view_rel_class`
                                                    ON `campus_objective_curriculum`.`id`= `campus_objective_view_rel_class`.`objective_curriculum_id`
                                                  INNER JOIN `campus_objective_view_rel_objective`
                                                    ON `campus_objective_curriculum`.`id`= `campus_objective_view_rel_objective`.`objective_curriculum_id`
                                  WHERE `objective_curriculum`.`id`=' . $objective_curriculum_id);

                    // delete all links from objectives to tracking
                    $result = mysql_query("DELETE `campus_objective_tracking_rel_objective` FROM `campus_objective_curriculum`
                                            INNER JOIN `campus_objective`
                                                ON `campus_objective_curriculum`.`id`= `campus_objective`.`objective_curriculum_id`)
                                            INNER JOIN `campus_objective_tracking_rel_class`
                                                ON `campus_objective`.`id`= `campus_objective_tracking_rel_class`.`objective_id`
                      WHERE `objective_curriculum_id`=" . $objective_curriculum_id);

                    // delete all links from objectives to agenda
                    $result = mysql_query("DELETE `campus_agenda_rel_objective` FROM `campus_agenda_rel_objective`
                                                INNER JOIN `campus_objective` ON `campus_agenda_rel_objective`.`objective_id`= `campus_objective`.`id`)
                      WHERE `objective_curriculum_id`=" . $objective_curriculum_id);
                    // delete all links from objectives to agendaarchive
                    $result = mysql_query("DELETE `campus_agenda_archive_rel_objective` FROM `campus_agenda_archive_rel_objective`
                                                INNER JOIN `campus_objective` ON `campus_agenda_archive_rel_objective`.`objective_id`= `campus_objective`.`id`)
                      WHERE `objective_curriculum_id`=" . $objective_curriculum_id);
                    // delete all links from objectives to agenda
                    // delete objectives
                    $result = mysql_query("DELETE FROM `campus_objective` WHERE `objective_curriculum_id`=" . $objective_curriculum_id);
                    // delete form rel objective_curriculum....
                    $result = mysql_query("DELETE FROM `campus_objective_curriculum` WHERE `id`=" . $objective_curriculum_id);


                    $message = get_lang("msgItemDeleted");
                    $action = "objectivecurriculumlist";
                }
                break;
            case "addobjective" :
                {
                    $objective_group = '';
                    $objective = '';
                    $code = '';
                    $comment = '';
                }
                break;
            case 'editobjective' :
                {
                    // read data
                    $query = 'SELECT `id`, `objective_curriculum_id`,`objective_group`,`objective`,`code`,`comment`  FROM `campus_objective`
 						WHERE `id`=' . $objective_id . ' '; //***
                    $result = mysql_query($query);
                    list($objective_id, $objective_curriculum_id, $objective_group, $objective, $code, $comment) = mysql_fetch_row($result); //***
                }
                break;
            case 'deleteobjective' :
                {
                    // delete form line
                    $result = mysql_query('DELETE FROM `campus_objective` WHERE `id`=' . $objective_id);
                    $message = get_lang('msgItemDeleted');
                    $action = 'objectivelist';
                }
                break;
            case 'movecurriculumup' :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_objective_curriculum` ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_curriculum_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_curriculum` SET `display_order`=' . $line . ' WHERE `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_objective_curriculum` SET `display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_curriculum` SET `display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $action = "objectivecurriculumlist";
                }
                break;
            case "movecurriculumdown" :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_objective_curriculum` ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_curriculum_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_curriculum` SET `display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_curriculum` SET
								`display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $action = "objectivecurriculumlist";
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_objective` WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . $line . ' WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' AND `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $action = "objectivelist";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_objective`
		 					WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `display_order`,`objective_group`, `objective`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $action = 'objectivelist';
                }
                break;
            case 'order_code' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_objective`
		 					WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `code`, `objective`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                    }

                    $action = 'objectivelist';
                }
                break;
            case 'order_group' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_objective`
		 					WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `objective_group`, `objective`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        $result2 = mysql_query('UPDATE `campus_objective` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                    }

                    $action = 'objectivelist';
                }
                break;
        }
    }
    elseif ($submitmessage == 1)
    {

        if (campus::get_POST_GET('Group2Sub') != '')
        {
            if (campus::get_POST_GET('Group2Sub') == 'all')
            {
                $selectgroups = implode(';', array_keys($groups));
            }
            else
            {
                $selectgroups.=';' . intval(campus::get_POST_GET('Group2Sub'));
            }
        }
        elseif (campus::get_POST_GET('Group2UnSub') != '')
        {
            if (campus::get_POST_GET('Group2UnSub') == 'all')
            {
                $selectgroups = '';
            }
            else
            {
                $selectgroups = substr(str_replace(';' . intval(campus::get_POST_GET('Group2UnSub')) . ';', ';', ';' . $selectgroups . ';'), 1, -1);
            }
        }
    }
    elseif ($submitmessage == 2)
    {

        switch ($action)
        {
            case 'addobjectivecurriculum' :
                {
                    $query = 'SELECT `display_order` FROM `campus_objective_curriculum`
		 						ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_objective_curriculum` SET
						`name`="' . $name . '",
						`code`="' . $code . '",
						`comment`="' . $comment . '",
						`visible`=1,
						`display_order`= ' . ($display_order + 1) . ' '; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang('msgItemAddError');
                    }
                    else
                    {
                        $objective_curriculum_id = mysql_insert_id();
                        $array = explode(";", $selectclasses);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_curriculum_rel_group` SET `objective_curriculum_id`=' . $objective_curriculum_id . ', `group_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $action = 'objectivecurriculumlist';
                    }
                }
                break;
            case "editobjectivecurriculum" :
                {
                    $query = 'UPDATE `campus_objective_curriculum` SET
						`name`="' . $name . '",
						`code`="' . $code . '",
						`comment`="' . $comment . '"
						WHERE `id`=' . $objective_curriculum_id . ' '; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                    }
                    else
                    {
                        // delete existing form rel classes....
                        $result = mysql_query("DELETE `campus_objective_curriculum_rel_group` FROM `campus_objective_curriculum_rel_group`
											INNER JOIN  `campus_department_rel_group` ON `campus_objective_curriculum_rel_group`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`= 2
												WHERE `department_id`=" . $department_id . " AND `objective_curriculum_id`=" . $objective_curriculum_id) or die(mysql_error());
                        $array = explode(";", $selectgroups);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_curriculum_rel_group` SET `objective_curriculum_id`=' . $objective_curriculum_id . ', `group_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $message = get_lang("msgItemEditSucces");
                        $action = "objectivecurriculumlist";
                    }
                }
                break;
            case "addobjective" :
                {
                    $query = 'SELECT `display_order` FROM `campus_objective`
		 					WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_objective` SET
						`objective`="' . $objective . '",
						`objective_group`="' . $objective_group . '",
						`objective_curriculum_id`=' . $objective_curriculum_id . ',
						`code`="' . $code . '",
						`comment`="' . $comment . '",
						`visible`=1,
						`display_order`= ' . ($display_order + 1) . ' '; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang('msgItemAddError');
                    }
                    else
                    {
                        //$message = get_lang("msgItemAddSucces");
                        $action = 'objectivelist';
                    }
                }
                break;
            case "editobjective" :
                {
                    $query = 'UPDATE `campus_objective` SET
						`objective`="' . $objective . '",
						`objective_group`="' . $objective_group . '",
						`code`="' . $code . '",
						`comment`="' . $comment . '"
						WHERE `id`=' . $objective_id . ' '; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $action = "objectivelist";
                    }
                }
                break;
            case 'import' :
                {
                    $row1 = campus::get_POST_GET("row1", "off");
                    if (!empty($_FILES))
                    {
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $i = 1;
                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                // als textChar leeg is een
                                $values = explode(";", $value);
                                $display_order = intval(trim(addslashes($values[0])));
                                $objective_group = trim(addslashes($values[2]));
                                $objective = trim(addslashes($values[3]));
                                $code = trim(addslashes($values[1]));
                                $comment = trim(addslashes($values[4]));
                                $id = intval(trim(addslashes($values[5])));
                                if ($code != "")
                                {
                                    $result = mysql_query('INSERT INTO `campus_objective` SET
                                                                        ' . (($id > 0) ? '`id`=' . $id . ', ' : '') . '
									`objective_curriculum_id`=' . $objective_curriculum_id . ',
									`objective_group`="' . $objective_group . '",
									`objective`="' . $objective . '",
									`display_order`=' . $display_order . ',
									`code`="' . $code . '",
									`comment`="' . $comment . '"') or die(mysql_error());
                                }
                                else
                                {
                                    $result = false;
                                }
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                                else
                                {
                                    $action = "objectivelist";
                                }
                            }
                            $i++;
                        }
                    }
                    $display = "list";
                }
                break;
        }
    }


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($action)
    {
        case 'addobjectivecurriculum' :
        case 'editobjectivecurriculum' :
            {
                $allgroups = campus::get_studentclasses(0);
                // ===============================================================
                // Form to add/edit objective type
                // ===============================================================
                echo "<b>" . get_lang('page_editobjectives') . ': ' . get_lang('txtobjectiveCurriculum') . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editobjective" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="objective_curriculum_id" value="' . $objective_curriculum_id . '" >
                                <input type="hidden" name="submitmessage" value="1">
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>';
                echo '<tr valign="top">
					<td  align="right">
						' . get_lang('labelFormline_type') . '
					</td>
					<td>
						<select name="linebegin_type" onchange="javascript:document.myform.submit();" />
						';
                for ($value = 0; $value < 4; $value++)
                {
                    echo '<option value="' . $value . '" ' . (($value == $linebegin_type) ? 'SELECTED' : '') . '>' . get_lang("enumValue_objectivecurriculumtype_" . $value) . '</option>';
                }
                echo ' 		</select>
					</td>
				</tr>';
                echo '<tr valign="top">
						<td align="right">
						' . get_lang('labelobjectiveCurriculum') . '
						</td>
						<td>
							<input type="text" name="name" size="32"  value="' . $name . '" />
						</td>
					</tr>';
                echo '<tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelCode') . '
					   </td>
					   <td>
							<input type="text" name="code" size="8"  value="' . $code . '" />
					   </td>
					 </tr>
					 <tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelComment') . '
					   </td>
					   <td>
						<textarea name="comment" rows="2" cols="80" >' . stripslashes($comment) . '</textarea>
					   </td>
					 </tr>';
                echo '<tr>
					<td  align="center">
						<b>' . get_lang('txtClasses') . '</b><br><br>
					</td>
					<td>
						<table>
					  		<tr>
							<td>
								<input type="hidden" name="groups" value="' . $selectgroups . '">
								<select name="Group2UnSub" size="5" style="width:230px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllClasses') . '</OPTION>';
                $array = explode(";", $selectgroups);
                foreach ($array as $id)
                {
                    if (intval($id) > 0)
                    {
                        echo '<option value="' . $id . '" >' . $allgroups[$id]['code'] . '</option>';
                    }
                }
                echo '   </select>
					</td>
					<td valign="middle">
					<h1><</h1>
					</td>
					<td>
					 <select name="Group2Sub" size="5" style="width:230px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllClasses') . '</OPTION>';
                foreach ($groups as $key => $value)
                {
                    if (!in_array($key, $array))
                    {
                        echo '<option value="' . $key . '">' . $groups[$key]['code'] . '</OPTION>';
                    }
                }
                echo '			</select>
					</td>
				</tr>
				</table>
				</td>
				</tr>';


                echo '		 <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" value="' . get_lang('buttonlabelOK') . '" onMouseDown="javascript:document.myform.submitmessage.value=\'2\';"/>&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'objectivecurriculumlist\';">
					  </td>
					 </tr>
					</table>
					</form>';
            }
            break;
        case "addobjective" :
        case "editobjective" :
            {

                // ===============================================================
                // Form to add/edit objective type
                // ===============================================================
                echo '<b>' . get_lang('page_editobjectives') . ': ' . get_lang('txtobjective') . '</b><br>';
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editobjective" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="objective_curriculum_id" value="' . $objective_curriculum_id . '" >
				<input type="hidden" name="objective_id" value="' . $objective_id . '" >
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>';
                echo '<tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelCode') . '
					   </td>
					   <td>
							<input type="text" name="code" size="8"  value="' . $code . '" />
					   </td>
					 </tr>';
                echo '<tr valign="top">
						<td align="right">
						' . get_lang('labelobjectiveGroup') . '
						</td>
						<td>
							<input type="text" name="objective_group" size="32"  value="' . $objective_group . '" />
						</td>
					</tr>';
                echo '<tr valign="top">
						<td align="right">
						' . get_lang('labelobjective') . '
						</td>
						<td>
						<textarea name="objective" rows="2" cols="80" >' . stripslashes($objective) . '</textarea>
						</td>
						</tr>';
                echo '<tr valign="top">
					<td  align="right">
					    ' . get_lang('labelComment') . '
					   </td>
					   <td>
						<textarea name="comment" rows="2" cols="80" >' . stripslashes($comment) . '</textarea>
					  </td>
					 </tr>
				 <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'objectivelist\';">
					  </td>
					 </tr>
					</table>
					</form>';
            }
            break;
        case "objectivecurriculumlist" :
            {
                // ===============================================================
                // show objective curriculum
                // ===============================================================
                $query = "SELECT `id`, `name`, `code`, `comment`,`type`, `display_order` FROM `campus_objective_curriculum`
							ORDER BY `type`, `display_order`, `name`";
                $result = mysql_query($query);
                echo '<div style="float:right;">';
                echo '&nbsp;';
                echo '</div>';
                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=editobjective&action=addobjectivecurriculum">' . get_lang("txtAddobjectiveCurriculum") . '</a>&nbsp;';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadobjectiveType"), get_lang("colheadComment"), "", ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data['name'] = $rij['name'];
                    $data['comment'] = $rij['comment'];
                    if ($line == 1)
                    {
                        $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $rij['id'] . '&action=movetypeup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $rij['id'] . '&action=movetypedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }
                    $data['link1'] = '<pre style="margin:0px;padding:0px;"><a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $rij['id'] . '&action=editobjectivecurriculum" title="' . get_lang('tooltipEditObjectiveCurriculum') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                            '&nbsp;<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $rij['id'] . '&action=deleteobjectivecurriculum" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteObjectiveCurriculum') . '\')) return false;" title="' . get_lang('tooltipDeleteObjectiveCurriculum') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" /></a>' .
                            $link .
                            '&nbsp;<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $rij['id'] . '&action=objectivelist" title="' . get_lang('tooltipObjectiveList') . '"><img src="' . Theme::get_image_path('application\campus') . 'objective.png" border=0 align="absmiddle"></a></pre>';
                    //            '&nbsp;<a href="' . $this->get_url() . '&page=editobjectiveview&objective_curriculum_id=' . $rij['id'] . '" title="' . get_lang('tooltipobjectiveviews') . '"><img src="' . Theme::get_image_path('application\campus') . 'objective.png" border=0 align="absmiddle"></a></pre>';
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
        case "objectivelist" :
            {
                $query = 'SELECT `name`,`code`, `comment` FROM `campus_objective_curriculum` WHERE `id` =' . $objective_curriculum_id . ' ';
                $result = mysql_query($query);
                list($objective_curriculum, $objective_curriculum_code, $comment) = mysql_fetch_row($result);

                // ===============================================================
                // Form to add/edit objective type
                // ===============================================================
                //echo '<a href="' . $this->get_url() . '&page=editobjective&action=objectivecurriculumlist" title="' . get_lang('tooltipObjectiveTypes') . '">' . get_lang('page_objectivetypes') . '</a>&nbsp;=>&nbsp;';
                //echo '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&action=objectivesubtypelist" title="' . $comment . '">' . $objective_type . '</a>&nbsp;:&nbsp;';
                echo '<b title="' . $comment . '">' . $objective_curriculum_code . ':' . $objective_curriculum . '</b>&nbsp;<br><br>';
                // ===============================================================
                // show objectives
                // ===============================================================
                $query = "SELECT * FROM `campus_objective`	 WHERE `objective_curriculum_id`=" . $objective_curriculum_id . " ORDER BY `display_order`";
                $result = mysql_query($query);
                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=editobjective&action=addobjective&objective_curriculum_id=' . $objective_curriculum_id . '">' . get_lang("txtAddObjective") . '</a>&nbsp;';
                echo '|&nbsp;<a href="' . $this->get_url() . '&page=editobjective&action=import&objective_curriculum_id=' . $objective_curriculum_id . '">' . get_lang("txtImportObjectives") . '</a>&nbsp;';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadCode"), get_lang("colheadObjectiveGroup"), get_lang("colheadObjective"), ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    //$teachers_array=campus::get_roster2teachers ($rij['roster_id']);
                    $data['code'] = $rij['code'];
                    $data['objective_group'] = $rij['objective_group'];
                    $data['objective'] = $rij['objective'];
                    if ($line == 1)
                    {
                        $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&objective_id=' . $rij['id'] . '&action=moveup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&objective_id=' . $rij['id'] . '&action=movedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }

                    $data['link'] = '<pre style="margin:0px;padding:0px;"><a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&objective_id=' . $rij['id'] . '&action=editobjective" title="' . get_lang('tooltipEditobjective') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                            '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&objective_id=' . $rij['id'] . '&action=deleteobjective" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteobjective') . '\')) return false;" title="' . get_lang('tooltipDeleteobjective') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" /></a>' .
                            $link . '</pre>';
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
        case "import" :
            {
                $query = 'SELECT `name`,`code`, `comment` FROM `campus_objective_curriculum` WHERE `id` =' . $objective_curriculum_id . ' ';
                $result = mysql_query($query);
                list($objective_curriculum, $objective_curriculum_code, $comment) = mysql_fetch_row($result);

                // ===============================================================
                // Form to add/edit objective type
                // ===============================================================
                echo '<a href="' . $this->get_url() . '&page=editobjective&action=objectivecurriculumlist" title="' . get_lang('tooltipObjectiveTypes') . '">' . get_lang('page_objectivetypes') . '</a>=>';
                echo '<a href="' . $this->get_url() . '&page=editobjective&objective_curriculum_id=' . $objective_curriculum_id . '&action=objectivelist" title="' . $comment . '">' . $objective_curriculum . '</a>';

                // ===============================================================
                // Objective importform
                // ===============================================================
                echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">
				<input type="hidden" name="page" value="editobjective" >
				<input type="hidden" name="action" value="import" >
				<input type="hidden" name="objective_curriculum_id" value="' . $objective_curriculum_id . '" >
				<input type="hidden" name="MAX_FILE_SIZE" value="100000">
				<table>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelDisableRow1') . '
				  </td>
				  <td >
				   <input type="checkbox" name="row1" value="on">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectFile2Import') . '
				  </td>
				  <td >
				   <input type="file" name="uploadfile" >
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td >
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'objectivelist\';">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td colspan=2>
				   ' . get_lang('helpDisciplineImport') . '<br>
				    <div style="color: #777777">
				     <u>' . get_lang('txtCsvImport') . '</u><br>
				     NR;CODE;GROEP;VOET;Opmerking<br>
				     xx;xxx;xxxx;xxxxxxxxxx<br>
				     xx;xxx;xxxx;xxxxxxxxxx<br>
				     <br><u>' . get_lang('txtCsvExample') . '</u><br>
				     1;LL101;Opvattingen over leren;De leerlingen werken ordelijk;<br>
				     2;LL102;Opvattingen over leren;De leerlingen weten dat kennis en vaardigheden via verschillende leerstrategieën kunnen verworven worden;<br>
				     3;LL103;Informatieverwerving;De leerlingen kunnen gegevens memoriseren door gebruikt te maken van hulpmiddelen;<br>
				    </div>
				   </td>
				  </tr>
				 </table>
				</form>';
            }
            break;
    }
}
?>
