<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $objective_curriculum_id = intval(campus::get_POST_GET('objective_curriculum_id'));
    $objective_view_id = intval(campus::get_POST_GET('objective_view_id'));
    $objective_id = intval(campus::get_POST_GET('objective_id'));
    $action = campus::get_POST_GET('action', 'objectiveviewlist');
    $submitmessage = campus::get_POST_GET('submitmessage');
    $classes = campus::get_studentclasses($department_id);

    $selectclasses = campus::get_POST_GET('classes');
    $selectobjectives = campus::get_POST_GET('objectives');
    $name = campus::get_POST_GET('name');
    $code = campus::get_POST_GET('code');
    $comment = campus::get_POST_GET('comment');

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == '')
    { //
        switch ($action)
        {
            case 'addobjectiveview' :
                {
                    $name = '';
                    $code = '';
                    $comment = '';
                    $selectclasses = '';
                    $objective_curriculum_id = '';
                }
                break;
            case 'editobjectiveview' :
                {
                    // read data
                    $query = "SELECT `id`,`objective_curriculum_id`, `name`, `code`,`comment`  FROM `campus_objective_view`
 						WHERE `id`=" . $objective_view_id . " "; //***
                    $result = mysql_query($query);
                    list($objective_view_id, $objective_curriculum_id, $name, $code, $comment) = mysql_fetch_row($result); //***
                    $query = "SELECT `group_id` FROM `campus_objective_view_rel_group`
 					INNER JOIN  `campus_department_rel_group` ON `campus_objective_view_rel_group`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`= 2
				WHERE `department_id`=" . $department_id . " AND `objective_view_id`=" . $objective_view_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['group_id'];
                    }
                    $selectclasses = implode(';', $array);
                    $query = "SELECT `objective_id` FROM `campus_objective_view_rel_objective` WHERE `objective_view_id`=" . $objective_view_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['objective_id'];
                    }
                    $selectobjectives = implode(';', $array);
                }
                break;
            case 'deleteobjectiveview' :
                {
                    // delete form line
                    $result = mysql_query('DELETE FROM `campus_objective_view` WHERE `id`=' . $objective_view_id);
                    $result = mysql_query('DELETE FROM `campus_objective_view` WHERE `id`=' . $objective_view_id);
                    $message = get_lang('msgItemDeleted');
                    $action = 'objectiveviewlist';
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_objective_view` ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_view_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_view` SET
								`display_order`=' . $line . ' WHERE `id`=' . $objective_view_id . ' AND `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_objective_view` SET
								`display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_view` SET
								`display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $action = "objectiveviewlist";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_objective_view` ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $objective_view_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_view` SET
								`display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_objective_view` SET
								`display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }

                    $action = 'objectiveviewlist';
                }
                break;
        }
    }
    elseif ($submitmessage == 1)
    {

        if (campus::get_POST_GET('Objective2Sub') != '')
        {
            if (campus::get_POST_GET('Objective2Sub') == 'all')
            {
                $selectobjectives = 'all';
            }
            else
            {
                $selectobjectives.=';' . intval(campus::get_POST_GET('Objective2Sub'));
            }
        }
        elseif (campus::get_POST_GET('Objective2UnSub') != '')
        {
            if (campus::get_POST_GET('Objective2UnSub') == 'all')
            {
                $selectobjectives = '';
            }
            else
            {
                $selectobjectives = substr(str_replace(';' . intval(campus::get_POST_GET('Objective2UnSub')) . ';', ';', ';' . $selectobjectives . ';'), 1, -1);
            }
        }
        elseif (campus::get_POST_GET('Group2Sub') != '')
        {
            if (campus::get_POST_GET('Group2Sub') == 'all')
            {
                $selectclasses = implode(';', array_keys($classes));
            }
            else
            {
                $selectclasses.=';' . intval(campus::get_POST_GET('Group2Sub'));
            }
        }
        elseif (campus::get_POST_GET('Group2UnSub') != '')
        {
            if (campus::get_POST_GET('Group2UnSub') == 'all')
            {
                $selectclasses = '';
            }
            else
            {
                $selectclasses = substr(str_replace(';' . intval(campus::get_POST_GET('Group2UnSub')) . ';', ';', ';' . $selectclasses . ';'), 1, -1);
            }
        }
        elseif (campus::get_POST_GET('objective_curriculum_id') != '')
        {
            $selectobjectives = '';
            $objective_curriculum_id = campus::get_POST_GET('objective_curriculum_id');
        }
    }
    elseif ($submitmessage == 2)
    {
        switch ($action)
        {
            case 'addobjectiveview' :
                {
                    $query = 'SELECT `display_order` FROM `campus_objective_view` ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT `campus_objective_view` SET
						`objective_curriculum_id`=' . $objective_curriculum_id . ',
						`name`="' . $name . '",
						`code`="' . $code . '",
						`comment`="' . $comment . '",
						`visible`=1,
                                                `department_id`=0,
						`display_order`= ' . ($display_order + 1) . ' '; //***
                    $result = mysql_query($query) or die(mysql_error());
                    if (!$result)
                    {
                        $message = get_lang('msgItemAddError');
                    }
                    else
                    {
                        $objective_view_id = mysql_insert_id();
                        $array = explode(";", $selectclasses);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_view_rel_group` SET `objective_view_id`=' . $objective_view_id . ', `group_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $array = explode(";", $selectobjectives);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_view_rel_objective` SET `objective_view_id`=' . $objective_view_id . ', `objective_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $action = 'objectiveviewlist';
                    }
                }
                break;
            case "editobjectiveview" :
                {
                    $query = 'UPDATE `campus_objective_view` SET
						`name`="' . $name . '",
						`code`="' . $code . '",
						`comment`="' . $comment . '"
						WHERE `id`=' . $objective_view_id . ' '; //***
                    $result = mysql_query($query) or die(mysql_error());
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                    }
                    else
                    {
                        // delete existing form rel classes....
                        $result = mysql_query("DELETE `campus_objective_view_rel_group` FROM `campus_objective_view_rel_group`
											INNER JOIN  `campus_department_rel_group` ON `campus_objective_view_rel_group.`group_id`=`campus_department_rel_group`.`group_id` AND `type`= 2
												WHERE `department_id`=" . $department_id . " AND `objective_view_id`=" . $objective_view_id);
                        $result = mysql_query("DELETE  FROM `campus_objective_view_rel_objective` WHERE `objective_view_id`=" . $objective_view_id);
                        $array = explode(";", $selectclasses);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_view_rel_group` SET `objective_view_id`=' . $objective_view_id . ', `group_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $array = explode(";", $selectobjectives);
                        foreach ($array as $id)
                        {
                            if (intval($id) > 0)
                            {
                                $result = mysql_query('INSERT `campus_objective_view_rel_objective` SET `objective_view_id`=' . $objective_view_id . ', `objective_id`=' . $id);
                            }
                            //$message = get_lang('msgItemAddSucces');
                        }
                        $message = get_lang("msgItemEditSucces");
                        $action = "objectiveviewlist";
                    }
                }
                break;
        }
    }



    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($action)
    {
        case 'addobjectiveview' :
        case 'editobjectiveview' :
            {
                $allclasses = campus::get_studentclasses(0);
                // ===============================================================
                // Form to add/edit qualification type
                // ===============================================================
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editobjectiveview" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="objective_view_id" value="' . $objective_view_id . '" >
                                <input type="hidden" name="objective_curriculum_id" value="' . $objective_curriculum_id . '" >
				<input type="hidden" name="submitmessage" value="1">
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>';
                echo '<tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelCurriculum') . '
					   </td>
					   <td>';
                if ($action == 'addobjectiveview')
                {
                    echo '<select name="objective_curriculum_id" size="5" style="width:400px;" OnChange="javascript:myform.submit();">';
                    echo '<opion></option>';
                    $query = 'SELECT `id`,`name`, `code`,`comment`  FROM `campus_objective_curriculum` '; //***
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo '<option value="' . $rij['id'] . '">' . $rij['name'] . '</option>';
                    }
                    echo '</select>';
                }
                else
                {
                    $query = 'SELECT `id`,`name`, `code`,`comment`  FROM `campus_objective_curriculum` where `id`=' . $objective_curriculum_id; //***
                    $result = mysql_query($query);
                    list($objective_curriculum_id, $curriculum) = mysql_fetch_row($result);
                    echo $name;
                    echo '<input type="hidden" name="objective_curriculum_id" value="' . $objective_curriculum_id . '" >';
                }
                echo '				   </td>
					 </tr>';
                echo '<tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelCode') . '
					   </td>
					   <td>
							<input type="text" name="code" size="8"  value="' . $code . '" />
					   </td>
					 </tr>';
                echo '<tr valign="top">
						<td align="right">
						' . get_lang('labelName') . '
						</td>
						<td>
							<input type="text" name="name" size="32"  value="' . $name . '" />
						</td>
					</tr>';
                echo '<tr valign="top">
				   <td  align="right">
					    ' . get_lang('labelComment') . '
					   </td>
					   <td>
						<textarea name="comment" rows="2" cols="80" >' . stripslashes($comment) . '</textarea>
					   </td>
					 </tr>';

                $array = explode(";", $selectobjectives);
                $query = 'SELECT * FROM `campus_objective` WHERE `objective_curriculum_id`=' . $objective_curriculum_id . ' ORDER BY `display_order`';
                $result = mysql_query($query);
                $group1 = '';
                $group2 = '';
                $objectives2Sub = '';
                $objectives2UnSub = '';
                $selectobjectives = '';
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    if ((!in_array($rij['id'], $array)) && (!in_array('all', $array)))
                    {
                        if ($rij['objective_group'] != $group1)
                        {
                            $group1 = $rij['objective_group'];
                            $objectives2Sub.='<optgroup label="' . $rij['objective_group'] . '">';
                        }
                        $objectives2Sub.='<option value="' . $rij['id'] . '" title="' . $rij['code'] . ': ' . $rij['objective'] . ($rij['comment'] == '' ? '' : ' (' . $rij['comment'] . ')') . '">' . $rij['code'] . ': ...' . substr($rij['objective'], 13) . '</option>';
                    }
                    else
                    {
                        if ($rij['objective_group'] != $group2)
                        {
                            $group2 = $rij['objective_group'];
                            $objectives2UnSub.='<optgroup label="' . $rij['objective_group'] . '">';
                        }
                        $objectives2UnSub.='<option value="' . $rij['id'] . '" title="' . $rij['code'] . ': ' . $rij['objective'] . ($rij['comment'] == '' ? '' : ' (' . $rij['comment'] . ')') . '">' . $rij['code'] . ': ...' . substr($rij['objective'], 13) . '</option>';
                        $selectobjectives.=';' . $rij['id'];
                    }
                }
                echo '<tr>
								<td  align="center">
						<b>' . get_lang('txtObjectives') . '</b><br><br>
								</td>
								<td>
									<table>
					  					<tr>
											<td>
												<input type="hidden" name="objectives" value="' . $selectobjectives . '">
												<select name="Objective2UnSub" size="5" style="width:400px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllObjectives') . '</option>';
                echo $objectives2UnSub;
                echo '   				</select>
											</td>
											<td valign="middle">
												<h1><</h1>
											</td>
											<td>
					 							<select name="Objective2Sub" size="5" style="width:400px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllObjectives') . '</option>';
                echo $objectives2Sub;
                echo '			</select>
											</td>
										</tr>
									</table>
								</td>
							</tr>';
                echo '<tr>
					<td  align="center">
						<b>' . get_lang('txtClasses') . '</b><br><br>
					</td>
					<td>
						<table>
					  		<tr>
							<td>
								<input type="hidden" name="classes" value="' . $selectclasses . '">
								<select name="Group2UnSub" size="5" style="width:230px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllClasses') . '</OPTION>';
                $array = explode(";", $selectclasses);
                foreach ($array as $id)
                {
                    if (intval($id) > 0)
                    {
                        echo '<option value="' . $id . '" >' . $allclasses[$id]['code'] . '</option>';
                    }
                }
                echo '   </select>
					</td>
					<td valign="middle">
					<h1><</h1>
					</td>
					<td>
					 <select name="Group2Sub" size="5" style="width:230px;" OnChange="javascript:myform.submit();">';
                echo '<option value="all">' . get_lang('txtAllClasses') . '</OPTION>';
                foreach ($classes as $key => $value)
                {
                    if (!in_array($key, $array))
                    {
                        echo '<option value="' . $key . '">' . $classes[$key]['code'] . '</OPTION>';
                    }
                }
                echo '			</select>
					</td>
				</tr>
				</table>
				</td>
				</tr>';
                echo ' <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" value="' . get_lang('buttonlabelOK') . '" onMouseDown="javascript:document.myform.submitmessage.value=\'2\';" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'objectiveviewlist\';">
					  </td>
					 </tr>
					</table>
					</form>';
            }
            break;
        case "objectiveviewlist" :
            {
              /*  $query = 'SELECT `name`,`code`, `comment` FROM `campus_objective_curriculum` WHERE `id` =' . $objective_curriculum_id . ' ';
                $result = mysql_query($query);
                list($objective_curriculum, $objective_curriculum_code, $comment) = mysql_fetch_row($result);
                echo '<b title="' . $comment . '">' . $objective_curriculum . '</b>&nbsp;<br><br>';*/

                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=editobjectiveview&action=addobjectiveview">' . get_lang('txtAddObjectiveView') . '</a>&nbsp;';
                echo '</div>';
                $query = 'SELECT `campus_objective_view`.`id`, `campus_objective_view`.`code`, `campus_objective_view`.`name` ,`campus_objective_curriculum`.`name` as "curriculum" FROM `campus_objective_view`
                                INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`= `objective_curriculum_id`
                                WHERE `department_id`='.$department_id.' OR `department_id`=0 ORDER BY `campus_objective_view`.`display_order`';
                $result = mysql_query($query);
                campus::display_complex_table_header($properties, array(get_lang("colheadCode"), get_lang("colheadName"), get_lang("colheadObjectiveCurriculum"), ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data['code'] = $rij['code'];
                    $data['name'] = $rij['name'];
                    $data['curriculum'] = $rij['curriculum'];
                    if ($line == 1)
                    {
                        $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editobjectiveview&objective_view_id=' . $rij['id'] . '&action=moveup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=editobjectiveview&objective_view_id=' . $rij['id'] . '&action=movedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }


                    $data['link'] = '<pre style="margin:0px;padding:0px;"><a href="' . $this->get_url() . '&page=editobjectiveview&objective_curriculum_id=' . $objective_curriculum_id . '&objective_view_id=' . $rij['id'] . '&action=editobjectiveview" title="' . get_lang('tooltipEditobjectiveview') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                            '<a href="' . $this->get_url() . '&page=editobjectiveview&objective_curriculum_id=' . $objective_curriculum_id . '&objective_view_id=' . $rij['id'] . '&action=deleteobjectiveview" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteobjectiveview') . '\')) return false;" title="' . get_lang('tooltipDeleteobjectiveview') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" /></a>' .
                            $link . '</pre>';

                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
    }
}
?>