<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($admin['roster']) && !$is_platformadmin)) 
{// not allowed here!
	Display::display_error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$report_id=intval(campus::get_SESSION("report_id"));
	$evaluation_id=intval(campus::get_POST_GET("evaluation_id"));
	$parent_id=intval(campus::get_POST_GET("parent_id"));
	$title=campus::get_POST_GET("title");
	$comment=campus::get_POST_GET("comment");
	$max_score=campus::get_POST_GET("max_score");
	$reportstart=strtotime(campus::get_POST_GET("reportstart"));
	$reportend=strtotime(campus::get_POST_GET("reportend"));
	$visible=intval(campus::get_POST_GET("visible"));
	$allow_child=intval(campus::get_POST_GET("allow_child"));
	$view=campus::get_POST_GET("view");
/*
============================================================================== 
		Actualiseer de gegevens van het formulier en de database......
============================================================================== 
*/ 
	if ($submitmessage=="")
	{ //
		// de scholen ophalen waar de gebruiker deel van uitmaakt.
		switch ($action) 
		{
			case "new" :
			{ 
				$report_id="";
				$title="";
				$comment="";
				$max_score=10;
				$reportstart=$today;
				$reportend=$today;
				$display="form";
			}
			break;
			case "update" :
			{
			// De gegevens van het bericht inlezen.
				$query="select `id`,`evaluation_id`,`parent_id`,`title`,`comment`,`max_score`,`reportstart`,`reportend`,`visible`,`allow_child`,`view` FROM `campus_report` WHERE `id`=".$report_id." ";
				$result = mysql_query($query) ;
				list($report_id,$evaluation_id,$parent_id,$title,$comment,$max_score,$reportstart,$reportend,$visible,$allow_child,$view)= mysql_fetch_row($result);
				$display="form";
			}
			break;
			case "delete" :
			{
				// het vak verwijderen.....
				delete_reporttree ($report_id);
				$message = get_lang("msgItemDeleted");
				$display="list";
			}
			break;
			case "moveup" :
			{ // move the selected evaluation 
				$query = "SELECT * FROM `campus_report` WHERE `parent_id`=".$parent_id." AND `department_id`=".$department_id." ORDER BY `display_order`, `id`";
				$result = mysql_query($query);
				$line=0;
				while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
				{
					$line++;
					if ($rij['id']==$report_id)
					{
						$result2=mysql_query("UPDATE `campus_report` SET
								`display_order`=".$line." WHERE `parent_id`=".$parent_id." AND `display_order`=".($line-1)." ");//move previous down..
						$result2=mysql_query("UPDATE `campus_report` SET
								`display_order`=".($line-1)." WHERE `parent_id`=".$parent_id." AND `id`=".$rij['id']." ");
					}
					else
					{
						$result2=mysql_query("UPDATE `campus_report` SET
								`display_order`=".$line." WHERE `parent_id`=".$parent_id." AND `id`=".$rij['id']." ");
					}							
				}
				$display="list";
			}
			break;
			case "movedown" :
			{ // move the selected line in the form list one down
				$query = "SELECT * FROM `campus_report` WHERE `parent_id`=".$parent_id." AND `department_id`=".$department_id."  ORDER BY `display_order`, `id`";
				$result = mysql_query($query);
				$line=0;
				$moveup=0;
				while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
				{
					$line++;
					if ($rij['id']==$report_id)
					{
						$result2=mysql_query("UPDATE `campus_report` SET
								`display_order`=".($line+1)." WHERE `parent_id`=".$parent_id." AND `id`=".$rij['id']." ");
						$moveup=-1;//next record move 1 up
					}
					else
					{
						$result2=mysql_query("UPDATE `campus_report` SET
								`display_order`=".($line+$moveup)." WHERE `parent_id`=".$parent_id." AND `id`=".$rij['id']." ");
						$moveup=0;		
					}							
				}
			
				$display="list";
			}
			break;
				default :
			{
				$display="list";
			}
			break;
		}
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				$query="INSERT 
						`campus_report` SET
						`parent_id`= ".$parent_id.",
						`evaluation_id`= ".$evaluation_id.",
						`title`='".$title."',
						`comment`='".$comment."',
						`max_score`='".$max_score."',
						`reportstart`=".$reportstart.",
						`reportend`=".$reportend.",
						`visible`=".$visible.",
						`allow_child`=".$allow_child.",
						`view`='".$view."',
						`department_id`=".$department_id."
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
					$display="form";
				}
				else
				{
					$report_id=mysql_insert_id();
					$message = get_lang("msgItemAddSucces");
					$display="list";
				}
			}
			break;
			case "update" :
			{ 
				$query="UPDATE 
						`campus_report` SET
						`parent_id`= ".$parent_id.",
						`evaluation_id`= ".$evaluation_id.",
						`parent_id`= ".$parent_id.",
						`title`='".$title."',
						`comment`='".$comment."',
						`max_score`='".$max_score."',
						`reportstart`=".$reportstart.",
						`reportend`=".$reportend.",
						`visible`=".$visible.",
						`allow_child`=".$allow_child.",
						`view`='".$view."',
						`department_id`=".$department_id."
					WHERE `id`='".$report_id."'
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
					$display="form";
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
					$display="list";
				}
			}
			break;
		}
	}
/*
============================================================================== 
		display ...
============================================================================== 
*/
	if (!empty($message))
	{		
		Display::normal_message($message);
	}
	switch ($display)
	{
		case "form" :
		{ 
// ===============================================================
// diplay Resource form.........
// ===============================================================
			echo '<form method="post" action="'.$this->get_url().'" name="myform">
			  	<input type="hidden" name="page" value="editreporttree" >
	 			<input type="hidden" name="report_id" value="'.$report_id.'" >
	 			<input type="hidden" name="parent_id" value="'.$parent_id.'" >
	 			<input type="hidden" name="action" value="'.$action.'" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelTitle').':
				  </td>
				  <td>
				   <input type="text" name="title" size="32" maxlength="255" value="'.$title.'" />
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelComment').':
				  </td>
				  <td>
				   <input type="text" name="comment" size="32" maxlength="255" value="'.$comment.'" />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelMaxScore').':
				  </td>
				  <td>
				   <input type="text" name="max_score" size="32" maxlength="255" value="'.$max_score.'" />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelStartDate').':
				  </td>
				  <td>
				   <input type="text" name="reportstart" size="32" maxlength="255" value="'.  DatetimeUtilities::format_locale_date('%Y-%m-%d',$reportstart).'" />(yyyy-mm-dd)
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelEndDate').':
				  </td>
				  <td>
				   <input type="text" name="reportend" size="32" maxlength="255" value="'.DatetimeUtilities::format_locale_date('%Y-%m-%d',$reportend).'" />(yyyy-mm-dd)
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelVisible').':
				  </td>
				  <td>
				   <input type="checkbox" name="visible" value="1" '.(($visible=='1')?'checked':'').'>
				  </td>
				 </tr>
				 <tr valign="top">
				  <td  align="right">
				   '.get_lang('labelAllowChild').':
				  </td>
				  <td>
				   <input type="checkbox" name="allow_child" value="1" '.(($allow_child=='1')?'checked':'').'>
				  </td>
				 </tr>';
			if ($parent_id==0)
			{
				echo '<tr valign="top">
				       <td  align="right">
					'.get_lang('labelSelectView').':
				       </td>
				       <td>';
				echo '<select name="view" />';
				// extract enum values
				echo '<option value="'.  CampusManagerStudentreportComponent::REPORT_COLUMN_VIEW.'" '.((CampusManagerStudentreportComponent::REPORT_COLUMN_VIEW==$view)? 'SELECTED' : '').'>'.get_lang("enumValue_reportview_". CampusManagerStudentreportComponent::REPORT_COLUMN_VIEW).'</option>';
				echo '<option value="'.CampusManagerStudentreportComponent::REPORT_TREE_VIEW.'" '.((CampusManagerStudentreportComponent::REPORT_TREE_VIEW==$view)? 'SELECTED' : '').'>'.get_lang("enumValue_reportview_".CampusManagerStudentreportComponent::REPORT_TREE_VIEW).'</option>';
				echo '<option value="'.CampusManagerStudentreportComponent::REPORT_SELECT_VIEW.'" '.((CampusManagerStudentreportComponent::REPORT_SELECT_VIEW==$view)? 'SELECTED' : '').'>'.get_lang("enumValue_reportview_".CampusManagerStudentreportComponent::REPORT_SELECT_VIEW).'</option>';
				echo '</select></td></tr>';
			}
			echo '	<tr valign="top">
				 <td  align="right">
				  '.get_lang('labelSelectEvaluation').':
				 </td>
				 <td>
				  <select name="evaluation_id" />';
			$query="SELECT `id`,`title` FROM `campus_evaluation`
		      		 WHERE `department_id`=".$department_id." AND `parent_id`=0 ORDER BY `display_order`";
			$result = mysql_query($query) ;
			echo "<option value=\"0\" 'SELECTED' >&nbsp;</option>";
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				echo "<option value=\"".$rij['id']."\" ".(($rij['id']==$evaluation_id)? 'SELECTED' : '').">".$rij['title']."</option>";
			}
			echo '	  </select>
				 </td>
				</tr>
				<tr valign="top">
				 <td>
				 </td>
				 <td>
				  <input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</td>
			       </tr>
			      </table>
			     </form>';
		}
		break;
		case "list" :
		{ 
		// ===============================================================
		// lokaallijst weergeven........
		// ===============================================================
			$query="SELECT * FROM `campus_report` WHERE `parent_id`=".$parent_id." AND `department_id`=".$department_id." ORDER BY `display_order`";
			$result = mysql_query($query) ;
			echo "<div >";
			if ($parent_id!=0)
			{
				$query2="SELECT `parent_id` FROM `campus_report` WHERE `id`=".$parent_id."";
				$result2 = mysql_query($query2);
				list($up_id)= mysql_fetch_row($result2);
				echo '<a href="'.$this->get_url().'&page=editreporttree&parent_id='.$up_id.'">'.get_lang("txtUp1Level").'</a>&nbsp;|';
			}
			echo '&nbsp;<a href="'.$this->get_url().'&page=editreporttree&action=new&parent_id='.$parent_id.'">'.get_lang("txtAddReport").'</a>';
			echo '</div>';
			campus::display_complex_table_header($properties, array(get_lang("colheadReport"),get_lang("colheadComment"),""));
			$line=0;
			$nbrLines=mysql_num_rows($result);
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$line++;
				$data=array();
				$data[]=$rij['title'];
				$data[]=$rij['comment'];
				$data[]='&nbsp;<a href="'.$this->get_url().'&page=editreporttree&report_id='.$rij['id'].'&action=update"  title="'.get_lang("tooltipEditReport").'"><img src="'.Theme::get_image_path('application\campus') .'edit.gif" border=0 align="absmiddle"></a>'.
			  		'&nbsp;<a href="'.$this->get_url().'&page=editreporttree&report_id='.$rij['id'].'&action=delete" onclick="javascript:if(!confirm(\''.get_lang("msgboxConfirmDeleteReport").'\')) return false;" title="'.get_lang("tooltipDeleteReport").'"><img src="'.Theme::get_image_path('application\campus') .'delete.gif" border=0 align="absmiddle"></a>'.
					(($rij['evaluation_id']==0)?'&nbsp;<a href="'.$this->get_url().'&page=editreporttree&report_id='.$rij['id'].'&parent_id='.$rij['id'].'"  title="'.get_lang("tooltipEditReportChildren").'"><img src="'.Theme::get_image_path('application\campus') .'addreport.gif" border=0 align="absmiddle"></a>':'&nbsp;<img src="'.Theme::get_image_path('application\campus') .'addreport_na.gif" border=0 align="absmiddle">').
					(($line==1)?'<img src="'.Theme::get_image_path('application\campus') .'up_na.gif" border=0 align="absmiddle">':'<a href="'.$this->get_url().'&page=editreporttree&report_id='.$rij['id'].'&parent_id='.$parent_id.'&action=moveup"><img src="'.Theme::get_image_path('application\campus') .'up.gif" border=0 align="absmiddle"></a>').
					(($line == $nbrLines)?'<img src="'.Theme::get_image_path('application\campus') .'down_na.gif" border=0 align="absmiddle">':'<a href="'.$this->get_url().'&page=editreporttree&report_id='.$rij['id'].'&parent_id='.$parent_id.'&action=movedown"><img src="'.Theme::get_image_path('application\campus') .'down.gif" border=0 align="absmiddle"></a>');
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
		}
	}
}
function delete_reporttree ($report_id)
{
		$campusDb=campusdb_name();
		// delete evaluation tree...
		$query="SELECT * FROM `campus_report` WHERE `parent_id`=".$report_id." ";	
		$result = mysql_query($query);
		while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
		{
			delete_evaluationtree ($rij['id']);
		}
		$result=mysql_query("DELETE FROM `campus_report` WHERE `report_id`=".$report_id." ");
}

?>