<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $write = campus::get_POST_GET("write");

    $userinfo = campus::get_user_info($_uid);

    if ($write != "true")
    {
        $message = get_lang("msgStudentInfo2Tracking") . "<br>";
        $message.= '<a href="' . $this->get_url() . '&page=studentdetail2tracking&write=true">' . get_lang("txtYes") . '</a>';
        Display::warning_message($message, false);
    }
    else
    {
        // while clearing classes display report....
        $query = 'SELECT `user_id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
				FROM `user_user`
                                INNER JOIN `campus_user` ON `user_id`=`id`
				WHERE `status`=5	
				 ORDER BY  `lastname`,`firstname`';
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            echo get_lang("labelStudent") . " " . $rij['lastname'] . " " . $rij['firstname'];
            $query2 = "SELECT * FROM `campus_student_tracking` WHERE `student_id`=" . $rij['user_id'] . " AND `department_code`=''";
            $result2 = mysql_query($query2);
            if (mysql_num_rows($result2) == 0)
            {
                $content = $rij['lastname'] . ";" . $rij['firstname'] . ";" . $rij['username'] . ";" . $rij['birth'] . ";" . $rij['adress'] . ";" . $rij['phone'] . ";" . $rij['email'];
                $query3 = 'INSERT `campus_student_tracking` SET
					`student_id`="' . $rij['user_id'] . '",
					`tracking_category`="",
					`tracking_title`="",
					`date`="' . time() . '",
					`teacher_code`="' . $userinfo['official_code'] . '",
					`grouplist`="",
					`department_code`="",
					`public`=0,
					`attachment`="",
					`content`="' . $content . '"';
                echo '=> <b style="color:green">' . get_lang("txtRecordWritten") . '</b>';
                $result3 = mysql_query($query3);
            }
            else
            {
                echo '=> ' . get_lang("txtRecordExists");
            }
            echo "<br>";
        }
    }
}
?>