<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  Export Classes to excell ...
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['student']) && ! $is_platformadmin))
{ // not allowed here!
    Echo "NOT ALLOWED!!!"; //get_lang("msgNoRights4ThisDepartment");
}
else
{ //only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */

// Query van het gegevensbestand....
    $sql = "SELECT DISTINCT `db_id`,  `username`, `initialpassword`, `lastname`, `firstname`
                FROM `user_user`
                    INNER JOIN `campus_user`
                        ON `user_user`.`id` = `campus_user`.`user_id`
                    INNER JOIN `group_group_rel_user`
                        ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                    INNER JOIN `group_group`
                        ON `group_group`.`id` = `group_group_rel_user`.`group_id`
                    INNER JOIN `campus_department_rel_group`
                        ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
                    WHERE `department_id`=" . $department_id . "
		ORDER BY  `group_group`.`code`,`display_order`, `lastname`, `firstname`";

    $data = '"linkID";"Username";"Password";"Lastname";"Firstname"' . "\n";
    $result = mysql_query($sql);
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $data .= '"' . $rij['db_id'] . '";';
        $data .= '"' . $rij['username'] . '";';
        $data .= '"' . $rij['initialpassword'] . '";';
        $data .= '"' . $rij['lastname'] . '";';
        $data .= '"' . $rij['firstname'] . '"';
        $data .= "\n";
    }
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header("Content-type: application/octet-stream");
    header("Content-Disposition: attachment; filename=studentLoginExport.csv");
    header('Content-transfer-encoding: binary');
    header("Pragma: no-cache");
    header("Expires: 0");
    // de rijen opsturen.
    print $data;
}
?>
