<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  Export Classes to excell ...
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['student']) && !$is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!"; //get_lang("msgNoRights4ThisDepartment");
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $display_order = campus::get_POST_GET("display_order");
    $lastname = campus::get_POST_GET("lastname");
    $firstname = campus::get_POST_GET("firstname");
    $username = campus::get_POST_GET("username");
    $password = campus::get_POST_GET("password");
    $changed = campus::get_POST_GET("changed");
    $email = campus::get_POST_GET("email");
    $group_code = campus::get_POST_GET("group_code");
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);


    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */
    $data='';
    foreach ($display_order as $user_id => $order)
    {
        $data.="<TR>
					<TD class='CEL' HEIGHT=25 ALIGN=center> 
						" . $display_order[$user_id] . "
					</TD>
					<TD class='CEL'>
						" . $lastname[$user_id] . " " . $firstname[$user_id] . "
					</TD>
					<TD class='CEL'>
						" . $username[$user_id] . "&nbsp;
					</TD>
					<TD class='CEL'>
						" . $email[$user_id] . "&nbsp;
					</TD>
					<TD class='CEL'>
						" . $password[$user_id] . "&nbsp;
					</TD>
                    <TD class='CEL'>
						" . $changed[$user_id] . "&nbsp;
					</TD>
                    <TD class='CEL'>
						" . $group_code[$user_id] . "&nbsp;
					</TD>
				</TR>
			";
            $group= $group_code[$user_id];
    }
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: html/text; charset=UTF-8');
    header('Content-Disposition: attachment; filename=' . get_lang('txtPasswordList').$group.'_' .$academicYear.'.xls');
    header("Pragma: no-cache");
    header("Expires: 0");
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
    echo '
	<html>
		<head>
			<style type="text/css">
				body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
				TD.CEL       {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: NORMAL; border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; text-align:left;}
				TD.KOLOMKOP  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000;}
				TD.KOLOMKOP1  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: none;border-bottom: 1px solid #000000; padding-left: 3px;}
				TD.KOLOMKOP2  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: none ;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; padding-left: 3px;}
				TABLE        {border: 1px solid #000000;}
			</style>
		</head
		<body>
			<table  width=100% align="center" CELLSPACING=0 BORDER=1 CELLPADDING=0>
						<TR>
					<TD Class="KOLOMKOP" WIDTH="25px" >
						Nr 
					</TD>
					<TD Class="KOLOMKOP" WIDTH="250px" ALIGN="left">
						Naam & Voornaam
					</TD>
					<TD Class="KOLOMKOP" ALIGN="left">
						Gebruikersnaam
					</TD>
					<TD Class="KOLOMKOP" ALIGN="left">
						e-mailadres
					</TD>
					<TD Class="KOLOMKOP" >
						Initiëel Wachtwoord
					</TD>
					<TD Class="KOLOMKOP" >
					</TD>
					<TD Class="KOLOMKOP" style="text-align:left;">
						Klas
					</TD>
				</TR>
				' . $data . '
			</table>
		</body>
	</html>';
}
?>
