<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\Display;
use common\libraries\Theme;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if (!isset($_uid) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST en GET vars inlezen...
      ==============================================================================
     */


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $search = campus::get_POST_GET("search");
    $teacherid = intval(campus::get_POST_GET("teacherid"));

    if (($action == "reset_passwd") && ($teacherid > 0))
    {
        $newpasswd = Text::generate_password(8);
        $sql2 = "UPDATE `user_user` SET `password` = '" . Hashing :: hash($newpasswd) . "' WHERE `id` = " . $teacherid;
        $result2 = mysql_query($sql2);
        $userinfo = campus::get_user_info($teacherid);
        $message = get_lang("txtNewPassword") . $userinfo['lastname'] . ' ' . $userinfo['firstname'] . ': ' . $newpasswd;
    }

    if (!empty($message))
    {
        Display::warning_message($message, false);
    }
    // create a list of teacherclasses off the department
    $classes = campus::get_teacherclasses($department_id);

    /*
      -----------------------------------------------------------
      Geselecteerde lijst....
      -----------------------------------------------------------
     */
    echo "<FORM ACTION=\"" . $this->get_campus_admin_url() . "\" METHOD=\"POST\" NAME=\"SearchTeacher\">";
    echo "<input type=\"hidden\" name=\"page\" value=\"teacherpassword\">";
    echo "<div style='float:right'>";
    echo get_lang('Search') . ': <input type="tekst" name="search" OnChange="javascript:SearchTeacher.submit();" value="' . $search . '">';
    echo "&nbsp;&nbsp;</div>";
    echo "</FORM> ";
    echo "<div style=\"clear:both\"></div>";
    if ($search == "")
    {
        // Query van het gegevensbestand....
        $query = "SELECT `user_user`.`id`, `lastname`, `firstname`, `email`,`username`, `password`
				FROM `group_group_rel_user`
                                    LEFT JOIN `user_user`
                                        ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                                    LEFT JOIN `group_group`
                                        ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
        $filter = "";
        foreach ($classes as $key => $value)
        {
            $filter.="`group_group_rel_user`.`group_id` = " . $key . " OR ";
        }
        $filter = substr($filter, 0, -3) . " ";
        $sql = $query . $filter . " ORDER BY `lastname`, `firstname`";
    }
    else
    {
        // Query van het gegevensbestand....
        $sql = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`, `email`,`username`, `password`
                        FROM `campus_department_rel_group`
                            LEFT JOIN `group_group_rel_user`
                                ON `campus_department_rel_group`.`group_id` = `group_group_rel_user`.`group_id` AND `type`=1
                            LEFT JOIN `user_user`
                                ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                            WHERE (`lastname` like '%" . $search . "%' OR
					`firstname` like '%" . $search . "%' OR
					concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
					concat(`firstname`,' ',`lastname`) like '%" . $search . "%')
				ORDER BY `lastname`,`firstname`";
    }
    $result = mysql_query($sql);
    campus::display_complex_table_header($properties, array(get_lang("colheadId"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadEmail"), get_lang("colheadUsername"), get_lang("colheadPasswd"), get_lang("colheadClass"),'&nbsp;'));
    while ($rij = mysql_fetch_array($result, MYSQL_NUM))
    {
        $rij[3] = "<a href=\"mailto:" . $rij[3] . "\">" . $rij[3] . "</a>";
        $departmentarray = campus::get_department($rij['0']);
        $rij[6] = "";
        foreach ($departmentarray as $departmentid => $departmentinfo)
        {
            $rij[6].=$departmentinfo['code'];
        }
        $rij[5] = '<big title="' . get_lang('tooltipResetPassword') . '">&bull;&bull;&bull;&bull;&bull;&bull;</big>';
         $rij[] = '<a href="' . $this->get_campus_admin_url() . '&page=teacherpassword&action=reset_passwd&teacherid=' . $rij[0] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmResetPasswd") . '\')) return false;" title="' . get_lang("tooltipResetPasswd") . '"><img src="' . Theme::get_image_path('application\campus') . '/passwd.gif" border=0 align="absmiddle"></a>';
         campus::display_table_row($bgcolor, $rij, true);
    }
    campus::display_table_footer();
}
?>