<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;

/*
==============================================================================
	This is a content file included in the index.php file in this directory. 
==============================================================================
*/
/*
============================================================================== 
		MAIN CODE
============================================================================== 
*/ 

//check if user is allowed here...
if ((intval($_uid)==0) || !$is_platformadmin) 
{// not allowed here!
	Display::display_error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/


/*
============================================================================== 
		display ...
============================================================================== 
*/

     if (!empty($message))
	{		
		Display::normal_message($message,false);
	}
	$colheader=array();
	$properties=array();
	$colheader[]="";
	foreach ($departmentStruc as $departmentid => $departmentinfo)
	{
		$colheader[]=$departmentinfo['code'];
	}
	Campus::display_complex_table_header($properties, $colheader);
	// extract enum values
	$values=campus::get_enumvalues('campus_rights','item');
	foreach ($values as $item)
	{
		$rowspan=0;
		$rows[$item][1]['rowheader']=get_lang("enumValue_".$item);
		foreach ($departmentStruc as $departmentid => $departmentinfo)
		{
			$result=mysql_query("SELECT `firstname`, `lastname`, `username` FROM `campus_rights`
									INNER JOIN `user_user`
										ON `user_user`.`id` =  `campus_rights`.`user_id`
									WHERE `campus_rights`.`department_id` = '".$departmentid."' AND `campus_rights`.`item`='".$item."' ORDER by `lastname`,`firstname`");
			$row=0;
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$row++;
				$rows[$item][$row][$departmentinfo['code']]=$rij['firstname']." ".$rij['lastname']." (".$rij['username'].")";
			}
			if ($row>$rowspan)
				$rowspan=$row;
		}			
		$rows[$item][0]['rowheader']=$rowspan;
	}
	foreach ($rows as $member)
	{
		for ($row=1; $row<=$member[0]['rowheader']; $row++)
		{
			echo "<tr>";
			echo ($row==1)?"<td valign='top' rowspan=".$member[0]['rowheader'].">".$member[$row]['rowheader']."</td>":"";
			foreach ($departmentStruc as $departmentid => $departmentinfo)
			{
				echo "<td>".$member[$row][$departmentinfo['code']]."&nbsp;</td>";
			}	
			echo "</tr>";
		}
	}
	$member=array();
        echo '<tr ><td valign="top" colspan="20">Mijn administratie nog invoegen</td></tr>';
		      /*
	$result=mysql_query("SELECT `firstname`, `lastname`, `username` FROM `".$_configuration['main_database']."`.`course`
											INNER JOIN `".$_configuration['main_database']."`.`course_rel_user`
												ON `course_code`=`course`.`code`
											INNER JOIN `".$_configuration['main_database']."`.`user`
												USING (`user_id`)
												WHERE `course`.`code` = 'SG' AND `course_rel_user`.`status`=1 ORDER by `lastname`,`firstname`")or die (mysql_error());
	$rowspan="<td valign='top' rowspan=".mysql_num_rows($result).">ADMIN SG</td>";
	while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
	{
		echo "<tr>";
		echo $rowspan;
		$rowspan="";
		echo "<td colspan=7>".$rij['firstname']." ".$rij['lastname']." (".$rij['username'].")</td>";
		echo "</tr>";
	}

	
	$member=array();
	foreach ($departmentStruc as $departmentid => $departmentinfo)
	{
			$result=mysql_query("SELECT `firstname`, `lastname`, `username` FROM `".$_configuration['main_database']."`.`course`
											INNER JOIN `".$_configuration['main_database']."`.`course_rel_user`
												ON `course_code`=`course`.`code`
											INNER JOIN `user_user`
												USING (`user_id`)
												WHERE `course`.`code` = '".$departmentinfo['code']."' AND `course_rel_user`.`status`=1 ORDER by `lastname`,`firstname`")or die (mysql_error());
			$row=0;
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$row++;
				$member[$row][$departmentinfo['code']]=$rij['firstname']." ".$rij['lastname']." (".$rij['username'].")";
			}
			if ($row>$rowspan)
				$rowspan=$row;
	}	
	for ($row=1; $row<=$rowspan; $row++)
	{
		echo "<tr>";
		echo ($row==1)?"<td valign='top' rowspan=".$rowspan.">ADMIN</td>":"";
		foreach ($departmentStruc as $departmentid => $departmentinfo)
		{
			echo "<td>".$member[$row][$departmentinfo['code']]."&nbsp;</td>";
		}	
		echo "</tr>";
	}
	$member=array();
	$rowspan=0;
	foreach ($departmentStruc as $departmentid => $departmentinfo)
	{
			$result=mysql_query("SELECT `firstname`, `lastname`, `username` FROM `".$_configuration['main_database']."`.`course`
											INNER JOIN `".$_configuration['main_database']."`.`course_rel_user`
												ON `course_code`=`course`.`code`
											INNER JOIN `".$_configuration['main_database']."`.`user`
												USING (`user_id`)
												WHERE `course`.`code` = '".$departmentinfo['code']."WEBSITE' AND `course_rel_user`.`status`=1 ORDER by `lastname`,`firstname`");
			$row=0;
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$row++;
				$member[$row][$departmentinfo['code']]=$rij['firstname']." ".$rij['lastname']." (".$rij['username'].")";
			}
			if ($row>$rowspan)
				$rowspan=$row;
	}	
	for ($row=1; $row<=$rowspan; $row++)
	{
		echo "<tr>";
		echo ($row==1)?"<td valign='top' rowspan=".$rowspan.">SCHOOLWEBSITE</td>":"";
		foreach ($departmentStruc as $departmentid => $departmentinfo)
		{
			echo "<td>".$member[$row][$departmentinfo['code']]."&nbsp;</td>";
		}	
		echo "</tr>";
	}
	*/
	campus::display_table_footer();

}
?>
