<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $dateselect = intval(campus::get_POST_GET("dateselect", time()));
    $user_id = intval(campus::get_POST_GET("uid", 0));
    $selectclass = intval(campus::get_POST_GET("group_id", 0));
    $complete = intval(campus::get_POST_GET("complete", 0));
    if (($selectclass == 0))
    {
        $classes = campus::get_classes($user_id);
    }
    else
    {
        $classes = campus::get_class_info($selectclass);
    }

    $monday = strtotime('Next Monday', strtotime('-1 Week', $dateselect));

    if (!empty($classes))
    {
        $departmentStruc = campus::get_department($_uid);
        if (!empty($departmentStruc))
        { // enkel als de gebruiker is toegewezen aan een klas/department wordt de pagina weergegeven.
            if ($user_id != 0)
            {
                $result = mysql_query("SELECT `lastname`,`firstname` FROM `user_user` WHERE `id`=" . $user_id . "");
                $user = mysql_fetch_array($result, MYSQL_ASSOC);
            }
            $data = array();
            $query = "SELECT `date`, '' as `period_code`,`content`,'' as `tasks`,' ' as `lastname`,' ' as `firstname`, ' ' as `code`
					FROM `campus_calender` WHERE";
            if ($complete == 0)
            {
                $query.=" date>=" . $monday . " AND date<'" . ($monday + 604800) . " ";
            }
            else
            {
                $query .= " date>" . mktime(0, 0, 0, 8, 31, substr($academicYear, 0, 4)) . "	AND date<" . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)) . " ";
            }
            $query.=" AND `vacation`=1 AND `public`=1 AND `department_id`=" . key($departmentStruc) . " ";
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $time = $rij['date'];
                /*        while ($data[$time] != null)
                  {
                  $time++;
                  } */
                $data[$time] = $rij;
            }
            $agendacontent = "";
            $query = 'SELECT `campus_agenda`.`id`,`date`, `campus_period`.`code` as period_code, `content`, `tasks`, `lastname`,`firstname`, `campus_discipline`.`code` as discipline, `start_time`
                	FROM `campus_agenda`
                            INNER JOIN `campus_period`
                                ON `campus_period`.`id`=`campus_agenda`.`period_id`
                            INNER JOIN `campus_agenda_rel_group`
                                ON  `campus_agenda`.`id` = `campus_agenda_rel_group`.`agenda_id`
                            LEFT JOIN `campus_assignment`
                                ON `campus_assignment`.`id`=`campus_agenda`.`assignment_id`
                            LEFT JOIN `campus_discipline`
                                ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
       	                    LEFT JOIN `user_user`
                         	ON `user_user`.`id`=`campus_agenda`.`user_id`
                        WHERE `campus_period`.`department_id`=' . $department_id . ' AND (';
            $classcodes = "";
            foreach ($classes as $group_id => $value)
            {
                $classcodes.=$classes[$group_id]['code'] . ' ';
                $query.='`campus_agenda_rel_group`.`group_id`=' . $group_id . ' OR ';
            }
            $query = substr($query, 0, -3) . ") AND";
            if ($complete == 0)
            {
                $query.=' date>=' . $monday . ' AND date<' . ($monday + 604800);
            }
            else
            {
                $query.= " date>" . mktime(0, 0, 0, 8, 31, substr($academicYear, 0, 4)) . "	AND date<" . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4));
            }
            $query.=" order by `date`, `campus_period`.`display_order`";
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $time = $rij['date'] + $rij['start_time'];
                /*   while ($data[$time] != null)
                  {
                  $time++;
                  } */
                //$checkstudent = campus::get_agenda2students($rij['id']);
                if (empty($checkstudent) || (array_key_exists($user_id, $checkstudent)))
                {
                    $data[$time] = $rij;
                }
            }
            ksort($data);
            // Pagina instellingen
            include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
            $pdf = & new \Cezpdf('a4', 'portrait');
            $pdf->ezSetCmMargins(3.5, 1, 2, 2);
            $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
            //koptekst en voettekst
            $pdf->ezStartPageNumbers(520, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
            $pdf->ezStartPageNumbers(40, 15, 10, 'right', $departmentStruc[key($departmentStruc)]['name'], 1);
            $all = $pdf->openObject();
            $pdf->saveState();
            $pdf->setStrokeColor(0.6, 0.6, 0.6);
            $pdf->setLineStyle(2);
            $pdf->line(20, 750, 570, 750);
            $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
            if ($ext == '.jpg')
            {
                $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 20, 760, 130);
            }
            elseif ($ext == '.png')
            {
                $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 20, 760, 130);
            }
            //$pdf->addJpegFromFile(Theme::get_images_system_path('application/campus') . $departmentStruc[key($departmentStruc)]['logo'], 420, 775, 130);
            $pdf->ezStartPageNumbers(570, 810, 18, 'left', "AGENDA  " . $academicYear, 1);
            $pdf->ezStartPageNumbers(550, 785, 16, 'left', utf8_decode($user['firstname'] . " " . $user['lastname']), 1);
            $pdf->ezStartPageNumbers(570, 755, 20, 'left', trim(utf8_decode($classcodes)), 1);
            $filename = trim(utf8_decode($classcodes));
            $pdf->setColor(0, 0, 0);
            $pdf->restoreState();
            $pdf->closeObject();
            // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
            // or 'even'.
            $pdf->addObject($all, 'all');
            campus::document2pdf_footer($pdf, 595, 1.5);
            $date_old = '';
            foreach ($data as $key => $rij)
            {
                $datum = DatetimeUtilities::format_locale_date("%A %d %B %Y", $rij['date']);
                $pdf->transaction('start');
                $pos1 = $pdf->ezPosY();
                $lus = true;
                while ($lus)
                {
                    $pos1 = $pdf->ezPosY();
                    if ($datum <> $date_old)
                    {
                        $pdf->setColor(0.3, 0.3, 0.55);
                        $pdf->eZText($datum . ".", 12, array('aleft' => 35));
                        $pdf->ezSetDy(-5);
                    }
                    $pos = $pdf->ezPosY();
                    $pdf->setColor(0.96, 0.96, 0.96);
                    $pdf->filledRectangle(30, $pos, 20, -50);
                    if ($rij['period_code'] == '')
                    {
                        $pdf->setColor(0, 0, 0);
                        $pdf->addText(43, $pos - 44, 12, "VRIJAF", -90);
                        $pdf->ezText(" ", 10);
                        $pdf->setColor(0, 0, 0);
                        $pdf->ezText("<i>" . wordwrap(utf8_decode($rij['content']), 50) . "</i>", 14);
                    }
                    else
                    {
                        $pdf->filledRectangle(350, $pos, 220, -50);
                        $pdf->setColor(0.6, 0.6, 0.6);
                        $pdf->addText(43, $pos - $pdf->getTextWidth(12, $rij['period_code']), 12, $rij['period_code'], -90);
                        $pdf->ezText("Lesinhoud: " . utf8_decode($rij['discipline']) . " door " . utf8_decode($rij['lastname'] . " " . substr($rij['firstname'], 0, 1)) . ".", 10);
                        $pdf->setColor(0, 0, 0);
                        $pdf->ezText("<i>" . wordwrap(utf8_decode($rij['content']), 50) . "</i>", 11);
                        $pdf->ezSetY($pos);
                        $pdf->setColor(0.6, 0.6, 0.6);
                        $pdf->ezText("Taken en lessen: ", 10, array('aleft' => 350));
                        $pdf->setColor(0, 0, 0);
                        $pdf->ezText("<i>" . wordwrap(utf8_decode($rij['tasks']), 25) . "</i>", 11, array('aleft' => 350));
                    }
                    $pdf->ezSetY($pos - 59);
                    $pos2 = $pdf->ezPosY();
                    if (($pos2 > $pos1))
                    {
                        $pdf->transaction('rewind');
                        $pdf->ezNewPage();
                        campus::document2pdf_footer($pdf, 595, 1.5);
                    }
                    else
                    {
                        $lus = false;
                    }
                }
                $pdf->transaction('commit');
                $date_old = $datum;
            }
            $pdf->ezText("\n");
            $fileoption = array('Content-Disposition' => $filename . '.pdf');
            $pdf->ezStream($fileoption);
        }
    }
}
?>