<?php
/*
==============================================================================
  plugin: campus for Chamilo 1.8.X
	  by Ludwig Theunis (email: ludwig@openelo.be)
==============================================================================
*/
/*
==============================================================================
	Chamilo - E-earning & Collaboration Software

	Copyright (c) various contributors

	For a full list of contributors detaining copyrights over parts of
	the Chamilo software, see "documentation/credits.html".
	The full license can be read in "documentation/license.html".

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	See the GNU General Public License for more details.

	Mail: info@chamilo.org
==============================================================================
*/
/*
==============================================================================
	This is a page to link to from the department websites. 
==============================================================================
*/

/*
-----------------------------------------------------------
	Libraries
-----------------------------------------------------------
*/ 
//campus.conf.php is automatically included too.
 include("../../../main/inc/conf/configuration.php"); 
 include ("../inc/campus.lib.php");
/*
============================================================================== 
		DBASE
============================================================================== 
*/
 $dbdokeos=mysql_connect($_configuration['db_host'],$_configuration['db_user'],$_configuration['db_password']);
 mysql_select_db($_configuration['main_database'], $dbdokeos) or die ("FOUT: openen database mislukt");

/*
============================================================================== 
		POST en GET vars inlezen...
============================================================================== 
*/
$info=campus::get_POST_GET("info","thisweek");
$style=campus::get_POST_GET("stijl", "style.css");
$department_id=intval(campus::get_POST_GET("department_id"));
/*
============================================================================== 
		MAIN CODE
============================================================================== 
*/ 
echo "<html>
		<head>
		<style type=\"text/css\">";
		
if (empty($_GET["bkgd"]))
{
	echo "<!--
			@import url('".$style."');
			-->";
}
else
{
	$color=$_GET["bkgd"];	
	echo "#div_info {font-family:arial; font-size: 12px; width: 100%;  padding: 0 0 6px 0; background-color: ".$color."; border: 1px solid #1C2F69;}";
	echo "#span_infocaption {font-size: 11px; font-weight: bold;  padding-left: 12px;}";
	echo "#div_infosection {width: auto; margin: 24px 6px 0 6px; padding-left: 10px; border: 1px solid #1C2F69;}";
	echo "#span_infosectioncaption {position: relative; top: -9px; background-color: ".$color."; font-size: 11px; padding: 0 8px 0 4px;}";
	echo "#ul_infolist {list-style-position: outside; margin: 0 6px 16px 15px; padding: 0;list-style-type: circle;}";
	echo "#li_info_item {}";
	echo "#div_info_item {}";
}
echo "</style>
		</head>";

	//dag van de week berekenen. is enkel nodig voor IIS op Windows omdat deze %u niet kent. De online website draait onder unix en heeft deze aanpassing niet nodig.
	if (strftime('%u')=="") 
	{	
		$dagnr=array_search(strftime('%a'), $weekshort);
	}else {
		$dagnr=strftime('%u')-1;
	}
	// De info's beginnende van de maandag van deze week. op zaterdag en zondag laten we de info's van volgende week al zien.
	$maandag=mktime(0, 0, 0, strftime('%m'), strftime('%d'), strftime('%Y'))-($dagnr*86400);

	$departmentStruc=campus::get_department_info ($department_id);
	echo ("<div ID=\"div_info\">");
	//=============================================================================
	// info's....
	//=============================================================================
	switch ($info)
	{
		case "archive":
		{
			$query="select * FROM `".$campusDb."`.`campus_info` WHERE `department_id`=".$department_id." AND `date`<'".$today."' ORDER BY date";
			$result=mysql_query($query);
		}
		break;
		case "thisweek":
		{
			
			$enddate=strftime("%Y-%m-%d",mktime(0, 0, 0, strftime('%m',$maandag), (strftime('%d',$maandag)+7), strftime('%Y',$maandag)));
			$query="select * FROM `".$campusDb."`.`campus_info` WHERE `department_id`=".$department_id." AND `date`>='".$today."' AND `date`<'".$enddate."' ORDER BY date";
			$result=mysql_query($query);
			if ((mysql_num_rows($result))==0) {$info="nextweek"; }
		}
		break;
	}
	switch ($info)
	{	
		case "nextweek":
		{
			$startdate=strftime("%Y-%m-%d",mktime(0, 0, 0, strftime('%m',$maandag), (strftime('%d',$maandag)+7), strftime('%Y',$maandag)));
			$enddate=strftime("%Y-%m-%d",mktime(0, 0, 0, strftime('%m',$maandag), (strftime('%d',$maandag)+14), strftime('%Y',$maandag)));
			$query="select * FROM `".$campusDb."`.`campus_info` WHERE `department_id`=".$department_id." AND `date`>='".$startdate."' AND `date`<'".$enddate."' ORDER BY date";
			$result=mysql_query($query);
		}
		break;
		case "future":
		{
			$startdate=strftime("%Y-%m-%d",mktime(0, 0, 0, strftime('%m',$maandag), (strftime('%d',$maandag)+14), strftime('%Y',$maandag)));
			$query="select * FROM `".$campusDb."`.`campus_info` WHERE `department_id`=".$department_id." AND `date`>='".$startdate."' ORDER BY date";
			$result=mysql_query($query);
		}
		break;
	}
	$vorige_datum="";
	$infodata="";
	while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
	{
		if ($rij['studentinfo']!="") 
		{ 
			if ($vorige_datum!=$rij['date']) 
			{ //nieuwe info?, nieuwe cel en datum schrijven...
				$infodata.="<u id=\"u_info_date\"style='margin-left:-20px;font-weight:bold;'>".strftime('%A %d %B %Y',strtotime($rij['date']))."</u><br><br>";
				$vorige_datum=$rij['date'];
			}
			$infodata.="<li id=\"li_info_item\"><div id=\"div_info_item\">";
			//$infodata.="<a href=\"info_vcs.php?info_id=".$rij['info_id']."\" TARGET='_blank' ><img src=\"".$_configuration['root_web']."main/img/outlook.gif\" border=0 align=\"right\" alt=\"Deze info exporteren naar Outlook\"></a>";
			$infodata.=ereg_replace(13,'<BR>',ereg_replace("  ",'&nbsp;&nbsp;',$rij['studentinfo']))."<BR>";
			$infodata.="</div><br clear=\"all\"></li>";
		}
 	}  	
	// de info's van deze week weergeven ....					
 	echo ("<div id='div_infosection'><span id='span_infosectioncaption'>Deze week");
	if ($info!='thisweek')
	{
		echo ("&nbsp;<a href=\"".$_SERVER['PHP_SELF']."?info=thisweek&department_id=".$department_id."&bkgd=".$color."&stijl=".$style."\" title=\"De info's van deze week weergeven\"><img src=\"".$_configuration['root_web']."main/img/invisible.gif\" border=0 align=\"middle\"/></a></span><ul class='div_infolist'>");
	}
	else
	{
		echo ("</span><ul id=\"ul_infolist\">");
		echo $infodata;
	}
 	echo ("</ul></div>");
 
	// de info's van de volgende week weergeven ....					
 	echo ("<div id=\"div_infosection\"><span id=\"span_infosectioncaption\">Volgende week");
	if ($info!='nextweek')
	{
		echo ("&nbsp;<a href=\"".$_SERVER['PHP_SELF']."?info=nextweek&department_id=".$department_id."&bkgd=".$color."&stijl=".$style."\" title=\"De info's van volgende week weergeven\"><img src=\"".$_configuration['root_web']."main/img/invisible.gif\" border=0 align=\"middle\"/></a></span><ul id=\"ul_infolist\">");
	}
	else
	{
		echo ("</span><ul id=\"ul_infolist\">");
		echo $infodata;
	}
 	echo ("</ul></div>");
 
	// de vooruitzichten weergeven ....					
 	echo ("<div id=\"div_infosection\"><span id=\"span_infosectioncaption\">Vooruitzichten");
	if ($info!='future')
	{
		echo ("&nbsp;<a href=\"".$_SERVER['PHP_SELF']."?info=future&department_id=".$department_id."& bkgd=".$color."&stijl=".$style."\" title=\"De vooruitzichten weergeven\"><img src=\"".$_configuration['root_web']."main/img/invisible.gif\" border=0 align=\"middle\"/></a></span><ul id=\"ul_infolist\">");
	}
	else
	{
		echo ("</span><ul id=\"ul_infolist\">");
		echo $infodata;
	}
 	echo ("</ul></div>");
?>
