<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Path;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) && !($is_teacher))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $message_id = intval(campus::get_POST_GET("message_id"));
    // De gegevens van het bericht inlezen.
    $query = "select * FROM `campus_messageboard` WHERE `id`='" . $message_id . "' LIMIT 1";
    $result = mysql_query($query);
    list($message_id, $title, $date, $from, $content, $department_id) = mysql_fetch_row($result);
    // de bestemmeling voor dit bericht uit de tabel halen...
    $teacher_info = campus::get_user_info($from);
    $leerkracht = $teacher_info['lastname'] . " " . substr($teacher_info['firstname'], 0, 1) . ". (" . $teacher_info['official_code'] . ")";
    if ($from == $_uid)
    {
        $to = campus::get_message_to($message_id);
    }
    else
    {
        $to = array();
        $to['user'][$_uid] = campus::get_user_info($_uid);
    }
    if ($message_id > 0)
    {
        $marge_boven_cm = 2.7;
        $marge_links_cm = 2.0;
        $marge_onder_cm = 1.0;
        $marge_rechts_cm = 2.0;
        // Pagina instellingen
        include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
        $pdf = & new \Cezpdf('a4', 'portrait');
        $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
        $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
        $pdf->ezStartPageNumbers(560, 780, 14, 'left', "van: " . $leerkracht, 1);
        $pdf->ezStartPageNumbers(30, 30, 10, 'right', "Bericht van " . $leerkracht . " op het prikbord van de Spil", 1);
        $all = $pdf->openObject();
        $pdf->saveState();
        $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
        if ($ext == '.jpg')
        {
            $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 550, 75);
        }
        elseif ($ext == '.png')
        {
            $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 550, 75);
        }
        $pdf->restoreState();
        $pdf->closeObject();
        $pdf->addObject($all, 'all');
        $pdf->setStrokeColor(0, 0, 0);
        $pdf->setLineStyle(1);
        $pdf->line(30, 765, 560, 765);
        $pdf->line(30, 745, 560, 745);
        $pdf->setStrokeColor(0.6, 0.6, 0.6);
        $pdf->setLineStyle(1);
        $pdf->line(30, 700, 550, 700);
        $pdf->ezText("<i>Onderwerp </i>: " . strip_tags($title) . "\n", 14);
        $pdf->ezText("<i>Dit bericht is geplaatst op </i>: " . DatetimeUtilities::format_locale_date('%Y-%m-%d', $date), 12);
        $pdf->ezText("<i>En is zichtbaar tot </i>: " . DatetimeUtilities::format_locale_date('%Y-%m-%d', ($date + (2 * 7 * 24 * 3600))) . "\n", 12);
        $list_to = "";
        foreach ($to['class'] as $key => $value)
        {
            $list_to.=" " . $value . ", ";
        }
        if ($list_to != "")
        {
            $pdf->ezText("<i>Voor de klas(sen) </i>: ", 12);
            $pdf->ezText("" . substr($list_to, 0, -2) . "", 12, array('aleft' => 75, 'aright' => 500), 0);
        }
        $list_to = "";
        foreach ($to['user'] as $key => $value)
        {
            $user = campus::get_user_info($key);
            $usernames = $user['lastname'] . " " . substr($user['firstname'], 0, 1) . ".";
            $list_to.=$usernames . "\n";
        }
        if ($list_to != "")
        {
            $pdf->ezText("<i>Voor </i>: ", 12);
            $pdf->ezText("" . $list_to, 12, array('aleft' => 75, 'aright' => 500), 0);
        }
        $pos = $pdf->ezPosY();
        $pdf->line(30, $pos - 16, 550, $pos - 16);
        $pdf->ezText("<i>Inhoud </i>:\n", 12);
        $pdf->ezText(trim(strip_tags($content)), 12);
        //$pdf ->ezText($title."\n\n\n",16);

        $pdf->ezStream();
    }
}
?>