<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $objective_tracking_id = intval(campus::get_POST_GET('objective_tracking_id'));
    $info = campus::get_POST_GET('info');

    // get objective tracking name and comment.....
    $query = 'SELECT `teacher_code`, `name`, `comment`,`date` FROM `campus_objective_tracking`
							WHERE `id`=' . $objective_tracking_id . ' ';
    $result = mysql_query($query);
    list($teacher_code, $name, $comment, $date) = mysql_fetch_row($result);
    if ($teacher['official_code'] == $teacher_code || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']) || $is_platformadmin)
    {
        // update objective tracking info...
        foreach ($info as $varname => $content)
        {
            if ($varname != '')
            {
                // delete previous info...
                $result = mysql_query('DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=' . $objective_tracking_id . ' AND `varname`="' . $varname . '"');
                // write new info....
                $result = mysql_query('INSERT `campus_objective_tracking_info` SET `objective_tracking_id`=' . $objective_tracking_id . ', `varname`="' . $varname . '", `content`="' . $content . '"');
            }
        }
        // get all the info of the objective tracking....
        $query = "SELECT `varname`, `content`  FROM `campus_objective_tracking_info`
 					WHERE `objective_tracking_id`=" . $objective_tracking_id . " "; //***
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if (empty($info[$rij['varname']]))
            {
                $info[$rij['varname']] = $rij['content'];
            }
        }
        // get the classess
        $grouplist = '';
        $query = 'SELECT `group_code` FROM `campus_objective_tracking_rel_group`
					WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ';
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $grouplist.= $rij['group_code'] . ', ';
        }
        $selectclasses = substr($grouplist, 0, -2) . ' ';
        // get teacher...
        $query = 'SELECT `lastname`,`firstname` FROM `user_user`
					WHERE `official_code`="' . $teacher_code . '"';
        $result = mysql_query($query);
        list($lastname, $firstname) = mysql_fetch_row($result);
        $teacher = $lastname . ' ' . substr($firstname, 0, 1) . '.';


        // Pagina instellingen
        header('Content-Type: application/vnd.ms-word');
        header('Content-Disposition: attachment; filename=' . utf8_decode($name) . '.doc');
        header('Pragma: no-cache');
        header('Expires: 0');
        echo '<style type="text/css">
			<!--
				@page { margin-left: 2.5cm; margin-right: 2.5cm; margin-top: 1cm; margin-bottom: 2.5cm }
				P { margin-bottom: 0.21cm; direction: ltr; color: #000000; widows: 2; orphans: 2 ; font-family: Arial; font-size:14px;}
			-->
	
			</style>';
        echo '<body LANG="nl-BE" TEXT="#000000" DIR="LTR">';

        // Pagina instellingen
        //

        echo '<table width="100%" style="margin-left: -1cm;">';
        echo '<tr>';
        echo '<td>';
        echo '<img style="position:absolute; top: 1cm;left: 1cm;" src="' . Theme::get_image_path('application\campus') . $departmentStruc[$department_id]['logo'] . '" width="250" >';
        echo '</td>';
        echo '<td style="text-align:right;">';
        echo '<p style="font-size: 20px"><b>Spectrumcollege vzw</b></p>';
        echo '<p style="font-size: 16px">' . $departmentStruc[$department_id]['name'] . '</p>';
        echo '<p style="font-size: 16px">Schooljaar ' . $academicYear . '</p>';
        echo '<p style="font-size: 16px">' . DatetimeUtilities::format_locale_date('%A %d %B %Y', time()) . '</p>';
        echo '</td>';
        echo '</tr>';
        echo '</table>';
        echo '<br><br>';
        echo '<p>Beste ouders</p><br>';
        echo 'Onze school organiseert volgende activiteit:</p>';
        echo '<p style="margin-left:0.5cm;"><i>' . $name . '</i></p>';
        echo '<p>Deze activiteit wordt georganiseerd voor de leerlingen van de klas(sen):</p>';
        echo '<p style="margin-left:0.5cm;"><i>' . $selectclasses . '</i></p>';
        echo '<p><b>Omschrijving van de activiteit:</b></p>';
        echo '<p style="margin-left:0.5cm;"><i>' . str_replace("<br>", "\n", $comment) . '</i></p>';
        echo '<p><br><br></p>';
        echo '<p><b>Praktische informatie:</b></p>';
        echo '<p style="margin-left:0.5cm;">Datum:&#09;&#09;&#09;<i>' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $date) . '</i></p>';
        echo '<p style="margin-left:0.5cm;">Bestemming:&#09;&#09;<i>' . $info['locatie'] . '</i></p>';
        if ($info['type'] == 'extramuros')
        {
            echo '<p style="margin-left:0.5cm;">Uur van vertrek:&#09;<i>' . $info['begin'] . '</i></p>';
            echo '<p style="margin-left:0.5cm;">Uur van terugkeer:&#09;<i>' . $info['einde'] . '</i></p>';
            echo '<p style="margin-left:0.5cm;">vervoer:&#09;&#09;<i>' . $info['vervoer'] . '</i></p>';
        }
        else
        {
            echo '<p style="margin-left:0.5cm;">Uur van begin:&#09;<i>' . $info['begin'] . '</i></p>';
            echo '<p style="margin-left:0.5cm;">Uur van einde:&#09;<i>' . $info['einde'] . '</i></p>';
        }
        if ($info['meebrengen'] != '')
        {
            echo '<p><b>Meebrengen:</b></p>';
            echo '<p style="margin-left:0.5cm;"><i>' . str_replace("<br>", "\n", $info['meebrengen']) . '</i></p>';
        }
        echo '<p><b>Onkosten van de activiteit:</b></p>';
        echo '<p style="margin-left:0.5cm;">Omschrijving van de onkosten:</p>';
        echo '<p><i>' . str_replace("<br>", "\n", $info['kostenomschrijving']) . '</i></p>';
        echo '<p style="margin-left:0.5cm;">Totaal:</p>';
        echo '<p style="margin-left:0.5cm;"><i>' . $info['kost'] . '</i></p>';
        if ($info['betalingswijze'] == 'Het geld van de onkosten meebrengen ')
        {
            echo '<p style="margin-left:0.5cm;"><i>' . $info['betalingswijze'] . ' ' . $info['geldmeebrengen'] . '</i></p>';
        }
        else
        {
            echo '<p>' . $info['betalingswijze'] . '</p>';
        }
        echo '<br><br>';
        echo '<p>Met vriendelijke groeten</p>';
        echo '<p>Namens de directie en de verantwoordelijke leerkracht, ' . $teacher . '</p>';
        echo '<br><br>';
        echo '<hr>';
        echo '<table width="100%" >';
        echo '<tr>';
        echo '<td><p style="font-size:12px;">';
        echo $departmentStruc[$department_id]['name'] . '<br>';
        echo $departmentStruc[$department_id]['address'] . ' Tel.(' . $departmentStruc[$department_id]['phone'] . ')</p>';
        echo '</td>';
        echo '<td style="text-align:right;">';
        echo '<p style="font-size:12px;">Spectrumcollege vzw<br>';
        echo 'http://www.spectrumcollege.be</p>';
        echo '</td>';
        echo '</tr>';
        echo '</table>';
        echo '</body>';
    }
    else
    {
        Echo "NOT ALLOWED!!!";
    }
}
?>
