<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  This is a studentlist to Pdf Export utility.
  ==============================================================================
 */

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$department_id = intval(campus::get_SESSION("department_id"));
$tracking_id = intval(campus::get_POST_GET("tracking_id"));
$trackingform_id = intval(campus::get_POST_GET("trackingform_id"));
$departmentStruc = campus::get_department_info($department_id);

//check if user is allowed here...
if ((intval($_uid) == 0) || ($department_id == 0))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    $student_id = intval($_uid);
    $student = campus::get_user_info($_uid);

    // Get form subject => title
    $query = "SELECT `subject` FROM `campus_trackingform` WHERE `id`=" . $trackingform_id . "";
    $result = mysql_query($query);
    list($subject) = mysql_fetch_row($result);
    // Get content from tracking...
    $query = "SELECT `content`,`date` FROM `campus_student_tracking`
		               		WHERE `id`=" . $tracking_id . " AND `student_id`=" . $_uid;
    $result = mysql_query($query);
    list($content, $date) = mysql_fetch_row($result);
    if (($content != '') && ($subject != ''))
    {
        $marge_boven_cm = 3.7;
        $marge_links_cm = 2.0;
        $marge_onder_cm = 1.0;
        $marge_rechts_cm = 2.0;
        // Pagina instellingen
        include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
        $pdf = & new \Cezpdf('a4', 'portrait');
        $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
        $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
        $pdf->ezStartPageNumbers(60, 785, 15, 'right', $departmentStruc[$department_id]['name'], 1);
        $pdf->ezStartPageNumbers(60, 750, 13, 'right', $student['firstname'] . " " . $student['lastname'], 1);
        $i = $pdf->ezStartPageNumbers(553, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
        $all = $pdf->openObject();
        $pdf->saveState();
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 415, 752, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 415, 752, 130);
    }
         $pdf->restoreState();
        $pdf->closeObject();
        $pdf->addObject($all, 'all');
        $pdf->setStrokeColor(0, 0, 0);
        $pdf->setLineStyle(1);
        $pdf->line(30, 735, 560, 735);
        $pdf->line(30, 715, 560, 715);
        $pdf->setStrokeColor(0.6, 0.6, 0.6);
        $pdf->setLineStyle(1);
        $pdf->line(30, 685, 550, 685);
        $pdf->ezText("<i>" . strip_tags($subject) . "</i>\n", 14);
        $pdf->ezText("<i>Datum </i>: " . DatetimeUtilities::format_locale_date('%A %d %B %Y', $date) . "\n", 12);
        $content2 = campus::remove_emptylines($content);
        $pdf->ezText(str_replace("<br>", "\n", $content2) . "\n", 10, array('aleft' => 80));
        $pdf->ezStream();
    }
 }
?>