<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\DatetimeUtilities;

if (($trackingform_id != 0) && ($student_id != 0))
{

    // ===============================================================
    // get forminfo
    // ===============================================================
    $query = "SELECT `subject`,`tracking_title`, `tracking_category`, `form_type` FROM `campus_trackingform`
				INNER JOIN `campus_tracking_title`
					ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
				INNER JOIN `campus_tracking_category`
					ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
				WHERE `campus_trackingform`.`id`=" . $trackingform_id . "";
    $result = mysql_query($query);
    list($subject, $tracking_title, $tracking_category, $form_type) = mysql_fetch_row($result);
    // ===============================================================
    // get trackingform
    // ===============================================================
    $query = "SELECT * FROM `campus_trackingform_line` WHERE `trackingform_id`=" . $trackingform_id . " ORDER BY `display_order`, `id`";
    $result = mysql_query($query);
    $line = 1;
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $formlines[$line++] = $rij;
    }
    $line = 1;
    $contentlines = explode("\n", $content);
    $contentlines[] = '[[END]]';
    $t = 0;
    $formvalue = "";
    foreach ($contentlines as $contentline)
    {
        //echo $line.': ';
        if ($formlines[$line]['linebegin_type'] == 2) //mtext
        {// multiple lines, search for end line.
            $mtextlines = explode("\n", $formlines[$line]['linebegin_value']);
            if (trim($contentline) == trim($mtextlines[$t]))
            {
                $t++;
            }
            else
            {
                $t = 0;
                $line++;
            }
        }
        elseif ($formlines[$line]['linebegin_type'] == 4) //textarea
        {//
            $nextline = search_line($contentline, $formlines[$line + 1]);
            if ($nextline['empty_line'])
            {// if an empty line is put after an text area check next line (only one empty lin
                $nextline = search_line($contentline, $formlines[$line + 2]);
                $offset = 2;
            }
            else
            {
                $offset = 1;
            }
            if ((!empty($nextline)) || ($contentline == '[[END]]'))
            {  // end of multiline input....
                $_POST['F' . $trackingform_id . 'begin' . $line] = $formvalue;
                $formvalue = "";
                $line = $line + $offset;
            }
            else
            {
                $formvalue.=$contentline . "\n";
            }
        }

        if (($formlines[$line]['linebegin_type'] != 2) && ($formlines[$line]['linebegin_type'] != 4))
        {
            $found = search_line($contentline, $formlines[$line]);
            $_POST['F' . $trackingform_id . 'begin' . $line] = $found['linebegin_value'];
            $_POST['F' . $trackingform_id . 'mid' . $line] = $found['linemid_value'];
            $_POST['F' . $trackingform_id . 'end' . $line] = $found['lineend_value'];

            $line++;
        }
    }

    // display form.....
    //echo "<IFRAME style='display:none; ' SRC='".$_configuration['root_web']."plugin/campus/inc/session_refresh.php'></IFRAME>";
    echo "<form method='post' action='" . $this->get_url() . "' name='myform' >";
    echo "<input type='hidden' name='page' value='$page' >";
    echo "<input type='hidden' name='action' value='$action' >";
    echo "<input type='hidden' name='teacher_code' value='$teacher_code' >";
    echo "<input type='hidden' name='public' value='$public' >";
    echo '<input type="hidden" name="override_id" value="' . $override_id . '" >';
    echo "<input type='hidden' name='grouplist' value='$grouplist' >";
    echo "<input type='hidden' name='department_code' value='$department_code' >";
    echo "<input type='hidden' name='tracking_category' value='$tracking_category' >";
    echo "<input type='hidden' name='tracking_title' value='$tracking_title' >";
    echo "<input type='hidden' name='trackingform_id' value='$trackingform_id' >";
    echo '<input type="hidden" name="tracking_id" value="' . $tracking_id . '" >';
    echo "<table width='100%'>";
    echo "<tr valign='top' >";
    echo "<td colspan='3'>";
    echo "<b>" . get_lang("txtForm") . " " . $subject . "</b><br><br>";
    echo "<input name='date' style='width:85px;' value='" . $date . "'> " . $tracking_category . " &rArr; " . $tracking_title . " <i>" . $teacher_code . " " . $department_code . " " . $grouplist . "</i>";
    echo "</td></tr>";
    echo "<tr valign='top'><td colspan='3'>";
    foreach ($formlines as $line => $formline)
    {
        echo "<div style='min-height:20px;height:auto !important;height:24px;'>";
        campus::display_inlineform($formline['linebegin'], $formline['linebegin_type'], $formline['linebegin_value'], 'F' . $trackingform_id . 'begin' . $line, $line, $student_id);
        if (($formline['linebegin_type'] != 'textarea') && ($formline['linebegin_type'] != 'mtext'))
        {
            echo " ";
            campus::display_inlineform($formline['linemid'], $formline['linemid_type'], $formline['linemid_value'], 'F' . $trackingform_id . 'mid' . $line, $line, $student_id);
            echo " ";
            campus::display_inlineform($formline['lineend'], $formline['lineend_type'], $formline['lineend_value'], 'F' . $trackingform_id . 'end' . $line, $line, $student_id);
        }
        echo "</div>";
    }
    echo "<input type='hidden' name='lines' value='$line'>";
    echo "</td></tr>";
    echo "<tr valign='top'><td></td><td>";
    echo "<input type='submit' name='submitmessage'  value='" . get_lang('buttonlabelOK') . "' />&nbsp;&nbsp;";
    echo "<input type='submit' name='cancel' onmouseover=\"javascript:hideID('title_list');\" value='" . get_lang('buttonlabelCancel') . "' onMouseDown=\"javascript:document.myform.action.value='list';\">";
    echo "<input type='submit' name='cancel' onmouseover=\"javascript:hideID('title_list');\" value='" . get_lang('buttonlabelNormalForm') . "' onMouseDown=\"javascript:document.myform.trackingform_id.value=-1;\">";
    echo "</td><td ></td></tr>";
    echo "</table></form>";
}

function search_line($line, $formline)
{
    $formlinestruc = array('linebegin', 'linemid', 'lineend');
    $found = array();
    $inputvalue = '';
    $inputpos = '';
    $pos = 0;
    $emptyline = 0;
    foreach ($formlinestruc as $linepos)
    {
        $type = $formline[$linepos . '_type'];
        $value = $formline[$linepos . '_value'];
        switch ($type)
        {
            case 1://"text":
                {
                    if (trim($value) == '')
                    {
                        $emptyline++;
                    }
                    elseif ((strpos($line, $value) !== FALSE))
                    {
                        $pos = strpos($line, $value);
                        $found[$linepos . '_value'] = $value;
                    }
                }
                break;
            case 3://"input":
                {
                    $pos = 0;
                    $inputvalue = $line;
                    $inputpos = $linepos;
                }
                break;
            case 5://"select":
                {
                    $values = explode(";", $value);
                    foreach ($values as $key)
                    {
                        if (strpos($line, trim($key)) !== FALSE)
                        {
                            $pos = strpos($line, trim($key));
                            $found[$linepos . '_value'] = trim($key);
                        }
                    }
                }
                break;
            case 8://"teachers":
                {
                    $department_id = campus::get_SESSION('department_id');
                    $teachers = campus::get_teachers($department_id);
                    foreach ($teachers as $key => $teacher)
                    {
                        if (strpos($line, $teacher['official_code']) !== FALSE)
                        {
                            $pos = strpos($line, $teacher['official_code']);
                            $found[$linepos . '_value'] = $teacher['official_code'];
                        }
                    }
                }
                break;
            case 9://"disciplines":
                {
                    $department_id = campus::get_SESSION('department_id');
                    $disciplines = campus::get_department2discipline($department_id);
                    foreach ($disciplines as $key => $discipline)
                    {
                        if (strpos($line, $discipline['name'] . ' (' . $discipline['code'] . ')') !== FALSE)
                        {
                            $pos = strpos($line, $discipline['name'] . ' (' . $discipline['code'] . ')');
                            $found[$linepos . '_value'] = $discipline['name'] . ' (' . $discipline['code'] . ')';
                        }
                    }
                }
                break;
            case 6://"mselect":
                {
                    $values = explode(";", $value);
                    foreach ($values as $key)
                    {
                        if (strpos($line, trim($key)) !== FALSE)
                        {
                            $pos = strpos($line, trim($key));
                            $found[$linepos . '_value'][] = trim($key);
                        }
                    }
                }
                break;
            case 7://"mteachers":
                {
                    $department_id = campus::get_SESSION('department_id');
                    $teachers = campus::get_teachers($department_id);
                    $selectstring = str_replace(", ", ";", $line);
                    // next space is end of selection list...
                    $selectstring = substr($selectstring, 0, strpos($selectstring, ' '));
                    foreach ($teachers as $key => $teacher)
                    {
                        if (strpos($selectstring, $teacher['official_code']) !== FALSE)
                        {
                            $found[$linepos . '_value'][] = $teacher['official_code'];
                        }
                    }
                }
                break;
            case 10://"mdisciplines":
                {
                    $department_id = campus::get_SESSION('department_id');
                    $disciplines = campus::get_department2discipline($department_id);
                    $selectstring = str_replace(", ", ";", $line);
                    // next ') ' is end of selection list... but ')' has to be include in the selectlist = +1
                    $selectstring = substr($selectstring, 0, strpos($selectstring, ') ') + 1);
                    foreach ($disciplines as $key => $discipline)
                    {
                        if (strpos($selectstring, $discipline['name'] . ' (' . $discipline['code'] . ')') !== FALSE)
                        {
                            $found[$linepos . '_value'][] = $discipline['name'] . ' (' . $discipline['code'] . ')';
                        }
                    }
                }
                break;
        }
        if ($inputvalue != "")
        {
            if ($pos > 0)
            {
                $found[$inputpos . '_value'] = substr($line, 0, $pos);
                $line = substr($line, strlen($found[$inputpos . '_value']) + 1);
                $inputvalue = "";
            }
            elseif (($pos == 0) && ($linepos == 'lineend'))
            {
                $found[$inputpos . '_value'] = $line;
            }
        }
        else
        {
            $newvalue = is_array($found[$linepos . '_value']) ? implode(", ", $found[$linepos . '_value']) : $found[$linepos . '_value'];
            $line = substr($line, strlen($newvalue) + 1);
        }
    }
    if ($emptyline == 3)
        $found['empty_line'] = TRUE;
    return $found;
}

?>