<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;
use common\libraries\ResourceManager;
use common\libraries\Path;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc)) && ! ($is_platformadmin))
{ // not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{ //only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    /*
  -----------------------------------------------------------
  Specials
  -----------------------------------------------------------
 */
    //echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.ui.min.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_userinfo_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/user_info.css');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');


    $result = mysql_query(
        "SELECT `campus_department_rel_group`.`group_id` FROM `campus_department_rel_group`
                            INNER JOIN `group_group_rel_user` ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` WHERE `type`=1 AND `user_id`=" .
        $_uid . " AND `department_id`=" . $department_id . " ORDER BY `display_order`"
    );
    list($defaultgroupid) = mysql_fetch_row($result);
    // $classesarray = campus::get_classes($rij['4']);
    $select = intval(campus::get_POST_GET("select", $defaultgroupid));
    $search = campus::get_POST_GET("search");

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if (! empty($message))
    {
        Display::normal_message($message);
    }
    $sql = "SELECT * FROM `campus_department_rel_group` WHERE `type`=1 AND `department_id`=" . $department_id . "";
    $result = mysql_query($sql);

    if (mysql_num_rows($result) >= 1)
    {
        $classes = campus::get_teacherclasses($department_id);
        echo "<div style='width:75%;float:right; '>";
        echo "<FORM ACTION=\"" . $this->get_teacherlist_url() . "\" METHOD=\"POST\" NAME=\"SearchTeacher\">";
        echo "<div style='float:right'>";
        echo get_lang("Search") .
            ": <input type='tekst' name='search' OnChange='javascript:SearchTeacher.submit();' value='" . $search .
            "'>";
        echo "&nbsp;&nbsp;</div>";
        echo "</FORM> ";
        echo "<b style=\"vertical-align:text-bottom;\">" . get_lang("txtQuickSelect") . "<BR></b>";
        echo
            " <a href=\"" . $this->get_teacherlist_url() . "&select=0&department_id=" . $department_id . "\" title=\"" .
            get_lang("tooltipAllMembersFrom") . $departmentStruc[$department_id]['code'] . "\">" .
            get_lang("txtComplete") . "</a>";
        foreach ($classes as $key => $value)
        {
            echo " <a href=\"" . $this->get_teacherlist_url() . "&select=" . $key . "&department_id=" . $department_id .
                "\" title=\"" . get_lang("tooltipShow") . " " . $classes[$key]['name'] . "\">" .
                $classes[$key]['code'] . "</a>";
        }
        echo("</div>");
        if ($search != "")
        {
            echo "<b style=\"font-size: 24px;\">" . get_lang("txtResult") . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT `lastname`, `firstname`, `official_code`, `email`, `address`, `phone`,`user_user`.`id`
	            FROM `campus_department_rel_group`
			INNER JOIN `group_group_rel_user`
	                   ON `campus_department_rel_group`.`group_id`= `group_group_rel_user`.`group_id`
	                INNER JOIN `user_user`
	                   ON `user_user`.`id`= `group_group_rel_user`.`user_id`
                            LEFT JOIN `campus_user`
 	                   ON `user_user`.`id` = `campus_user`.`user_id`
	         WHERE `type`=1 AND (`official_code` like '%" . $search . "%' OR `lastname` like '%" . $search . "%' OR
						concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
						concat(`firstname`,' ',`lastname`) like '%" . $search . "%')
					ORDER BY `lastname`,`firstname`";
        }
        elseif ($select != 0)
        {
            $classinfo = campus::get_class_info($select);
            echo "<b style=\"font-size: 24px;\">" . $classinfo[$select]['code'] . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT `lastname`, `firstname`, `official_code`,`email`, `address`, `phone`,`user_user`.`id`
                    FROM `user_user`
                        LEFT JOIN `campus_user`
 	                   ON `user_user`.`id` = `campus_user`.`user_id`
                        INNER JOIN `group_group_rel_user`
 	                   ON `user_user`.`id`= `group_group_rel_user`.`user_id`
                        WHERE `group_id` = " . $select . "
                    ORDER BY `lastname`, `firstname`";
        }
        else
        {
            echo "<b style=\"font-size: 24px;\">" . get_lang("txtComplete") . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT `lastname`, `firstname`, `official_code`, `email`, `address`, `phone`,`user_user`.`id`
                    FROM `campus_department_rel_group`
                	INNER JOIN `group_group_rel_user`
       	                   ON `campus_department_rel_group`.`group_id`= `group_group_rel_user`.`group_id`
	                INNER JOIN `user_user`
       	                   ON `user_user`.`id`= `group_group_rel_user`.`user_id`
                        LEFT JOIN `campus_user`
 	                   ON `user_user`.`id` = `campus_user`.`user_id`
	            WHERE `type`=1 AND `department_id`=" . $department_id . " ORDER BY `lastname`,`firstname`";
        }
        $tableheader = ($is_teacher) ? array(
            get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadNameShort"),
            get_lang("colheadEmail"), get_lang("colheadAdress"), get_lang("colheadPhone")
        ) : array(
            get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadEmail")
        );
        echo "<div style=\"clear:both\"></div>";
        if (($search == "")&&($is_teacher))
        {
            echo '<div style="float:right">';
            echo ($select > 0) ?
                '<a style="white-space: nowrap;" href="' . $this->get_url() . '&page=teachers2csv&select=' . $select .
                '" target="_blank" title="' . get_lang("tooltipAdresslist2csv") . '">' . get_lang("txtAdresslist2csv") .
                '</a>&nbsp' : '';
            echo '&nbsp;<a href="' . $this->get_agenda_url() . '&page=calender2pdf&select=teacher" target="_blank" >' .
                get_lang("txtClassCalender2Pdf") . '</a>';
            echo '</div>';
        }
        campus::display_complex_table_header($properties, $tableheader);

        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $data = array();
            $data[] = $rij['lastname'];
            $data[] = $rij['firstname'];
            // to do visualiation of group memberships... AJAX
            if ($is_teacher)
            {
                $data[] = '<div class="campus_user_tooltip"  user_id="' . $rij['id'] . '" title="">' . $rij['official_code'] . '&nbsp;<img src="' .
                    Theme::get_image_path('application\campus') . 'info_na.png" border=0 align="absmiddle" /></div>';
            }
            //
            $data[] = '<a href="mailto:' . $rij['email'] . '">' . $rij['email'] . '</a>';
            if ($is_teacher)
            {
                $data[] = $rij['address'];
                $data[] = $rij['phone'];
            }

            campus::display_table_row($bgcolor, $data, true);
        }
        campus::display_table_footer();
    }
    else
    {
        Display::warning_message(get_lang('msgNoTeacherclassAssigned'), false);
    }
}
?>