<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\DatetimeUtilities;

/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxItInfoStat extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);
        $department_id = intval(campus::get_SESSION("department_id"));

        $newContent = '';
        $query ="SELECT `campus_it_device`.`code`
          FROM `campus_it_device`
            INNER JOIN  `campus_it_device_rel_info`
                ON `campus_it_device`.`id`= `campus_it_device_rel_info`.`device_id`
          WHERE `campus_it_device_rel_info`.`info_id`= ".$this->get_parameter('sendid')." AND `department_id`= ".$department_id." ORDER BY `code`";
        $result = mysql_query($query);
        while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
        {
            $newContent .= ''.htmlentities($rij['code']).'<br />';
        }

        $ajax_result->set_property("ajaxid", $newContent);

        $ajax_result->display();







    }

}

?>