<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\Theme;
use common\libraries\Path;

/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxUserInfo extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);

        $_uid=campus::get_userid_from_session();
        $user_id = $this->get_parameter('sendid');

        campus::connect_db();
        $query = "SELECT * FROM `user_user`	WHERE `id`=" . $user_id . "";
        $result = mysql_query($query);
        $user = mysql_fetch_array($result);
        if (campus::is_department_teacher($_uid))
        {
            $grouparray = campus::get_classes($user_id);
            $groups = '';
            foreach ($grouparray as $classid => $classinfo)
            {
                $groups .= $classinfo['code'] . " ";
            }
            $newContent=$groups;
        }
        if (is_file(Path :: get(SYS_USER_PATH) . $user['picture_uri']))
        {
            $newContent .= '<img src="' . Path :: get(WEB_USER_PATH) . $user['picture_uri'] . '" height="100">';
        }
        $newContent .= $user['firstname'] . ' ' . $user['lastname'];

        $ajax_result->set_property("ajaxid", utf8_decode($newContent)); //$newContent)));

        $ajax_result->display();
    }
}

?>