$(document).ready(function() {
    $(".campus_tooltip_info").tooltip( {
        bodyHandler: function() {
            return getTooltipAgendaInfo($(this).attr("agenda_id"));
        },
        showURL: false

    });
    $(".campus_tooltip_personal_info").tooltip( {
        bodyHandler: function() {
            return getTooltipAgendaPersonalInfo($(this).attr("agenda_id"));
        },
        showURL: false

    });
    $(".campus_tooltip_tasks").tooltip( {
        bodyHandler: function() {
            return getTooltipAgendaTasks($(this).attr("grouplist"));
        },
        showURL: false

    });
    
});

function getTooltipAgendaInfo(id) {
    var ajaxUri = getPath('WEB_PATH') + 'ajax.php';

    var parameters = {
        'context' : 'application\\campus',
        'method' : 'agenda_info',
        'sendid' : id
    };
    var data ="";
    var response = $.ajax({
        type : "POST",
        url : ajaxUri,
        data : parameters,
        async : false
    }).success(function(json) {
        data = (json.properties.ajaxid);
          
    });
    return data;
}

function getTooltipAgendaTasks(id) {
    var ajaxUri = getPath('WEB_PATH') + 'ajax.php';

    var parameters = {
        'context' : 'application\\campus',
        'method' : 'agenda_tasks',
        'sendid' : id
    };
    var data ="";
    var response = $.ajax({
        type : "POST",
        url : ajaxUri,
        data : parameters,
        async : false
    }).success(function(json) {
        data = (json.properties.ajaxid);

    });
    return data;
}

function getTooltipAgendaPersonalInfo(id) {
    var ajaxUri = getPath('WEB_PATH') + 'ajax.php';

    var parameters = {
        'context' : 'application\\campus',
        'method' : 'agenda_personal_info',
        'sendid' : id
    };
    var data ="";
    var response = $.ajax({
        type : "POST",
        url : ajaxUri,
        data : parameters,
        async : false
    }).success(function(json) {
        data = (json.properties.ajaxid);

    });
    return data;
}
