$(document).ready(function() {
    $("#campus_dialog").dialog( {
        width:500,
        autoOpen: false
    });
    $(".campus_show_dialog").click( function() {
        $("#campus_dialog").html(
            getDeviceInfo($(this).attr("device_id")));
        $("#campus_dialog").dialog("option","title",$(this).attr("dialog_title"));
        $("#campus_dialog").dialog("open");
    });

});

function getDeviceInfo(id) {
    var ajaxUri = getPath('WEB_PATH') + 'ajax.php';

    var parameters = {
        'context' : 'application\\campus',
        'method' : 'device_info',
        'sendid' : id
    };
    var data ="";
    var response = $.ajax({
        type : "POST",
        url : ajaxUri,
        data : parameters,
        async : false
    }).success(function(json) {
        data = (json.properties.ajaxid);

    });
    return data;
}