$(document).ready(function() {
    $(".campus_tooltip").tooltip( {
        bodyHandler: function() {
            return getTooltipObjectiveInfo($(this).attr("objective_tracking_id"));
        },
        showURL: false

    });
       
});

function getTooltipObjectiveInfo(id) {
    var ajaxUri = getPath('WEB_PATH') + 'ajax.php';

    var parameters = {
        'context' : 'application\\campus',
        'method' : 'objective_info',
        'sendid' : id
    };
    var data ="";
    var response = $.ajax({
        type : "POST",
        url : ajaxUri,
        data : parameters,
        async : false
    }).success(function(json) {
        data = (json.properties.ajaxid);
          
    });
    return data;
}